/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/strings","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/common/map","vs/platform/policy/common/policy","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","os","child_process","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/node/decoder","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/processes","vs/base/common/extpath","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/platform/environment/node/userDataPath","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ee=function(B){for(var i=[],D=0,I=B.length;D<I;D++)i[D]=Z[B[D]];return i};define(Z[68],ee([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function D(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=D}),define(Z[50],ee([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(T){return(p,a,d)=>{let C=null,P=null;if(typeof d.value=="function"?(C="value",P=d.value):typeof d.get=="function"&&(C="get",P=d.get),!P)throw new Error("not supported");d[C]=T(P,a)}}i.createDecorator=D;function I(T,p,a){let d=null,C=null;if(typeof a.value=="function"?(d="value",C=a.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(d="get",C=a.get),!C)throw new Error("not supported");const P=`$memoize$${p}`;a[d]=function(...g){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,g)}),this[P]}}i.memoize=I;function b(T,p,a){return D((d,C)=>{const P=`$debounce$${C}`,g=`$debounce$result$${C}`;return function(...E){this[g]||(this[g]=a?a():void 0),clearTimeout(this[P]),p&&(this[g]=p(this[g],...E),E=[this[g]]),this[P]=setTimeout(()=>{d.apply(this,E),this[g]=a?a():void 0},T)}})}i.debounce=b;function k(T,p,a){return D((d,C)=>{const P=`$throttle$timer$${C}`,g=`$throttle$result$${C}`,E=`$throttle$lastRun$${C}`,l=`$throttle$pending$${C}`;return function(...f){if(this[g]||(this[g]=a?a():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),p&&(this[g]=p(this[g],...f)),this[l])return;const v=this[E]+T;v<=Date.now()?(this[E]=Date.now(),d.apply(this,[this[g]]),this[g]=a?a():void 0):(this[l]=!0,this[P]=setTimeout(()=>{this[l]=!1,this[E]=Date.now(),d.apply(this,[this[g]]),this[g]=a?a():void 0},v-Date.now()))}})}i.throttle=k}),define(Z[51],ee([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=i.ParseOptions||(i.ParseOptions={}));function T(t,n=!1){let e=0;const r=t.length;let o="",m=0,S=16,w=0;function L(re){let ge=0,ae=0;for(;ge<re;){const N=t.charCodeAt(e);if(N>=48&&N<=57)ae=ae*16+N-48;else if(N>=65&&N<=70)ae=ae*16+N-65+10;else if(N>=97&&N<=102)ae=ae*16+N-97+10;else break;e++,ge++}return ge<re&&(ae=-1),ae}function U(re){e=re,o="",m=0,S=16,w=0}function $(){const re=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&d(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&d(t.charCodeAt(e)))for(e++;e<t.length&&d(t.charCodeAt(e));)e++;else return w=3,t.substring(re,e);let ge=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&d(t.charCodeAt(e))){for(e++;e<t.length&&d(t.charCodeAt(e));)e++;ge=e}else w=3;return t.substring(re,ge)}function q(){let re="",ge=e;for(;;){if(e>=r){re+=t.substring(ge,e),w=2;break}const ae=t.charCodeAt(e);if(ae===34){re+=t.substring(ge,e),e++;break}if(ae===92){if(re+=t.substring(ge,e),e++,e>=r){w=2;break}switch(t.charCodeAt(e++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const _=L(4);_>=0?re+=String.fromCharCode(_):w=4;break}default:w=5}ge=e;continue}if(ae>=0&&ae<=31)if(a(ae)){re+=t.substring(ge,e),w=2;break}else w=6;e++}return re}function Y(){if(o="",w=0,m=e,e>=r)return m=r,S=17;let re=t.charCodeAt(e);if(p(re)){do e++,o+=String.fromCharCode(re),re=t.charCodeAt(e);while(p(re));return S=15}if(a(re))return e++,o+=String.fromCharCode(re),re===13&&t.charCodeAt(e)===10&&(e++,o+=`
`),S=14;switch(re){case 123:return e++,S=1;case 125:return e++,S=2;case 91:return e++,S=3;case 93:return e++,S=4;case 58:return e++,S=6;case 44:return e++,S=5;case 34:return e++,o=q(),S=10;case 47:{const ge=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<r&&!a(t.charCodeAt(e));)e++;return o=t.substring(ge,e),S=12}if(t.charCodeAt(e+1)===42){e+=2;const ae=r-1;let N=!1;for(;e<ae;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,N=!0;break}e++}return N||(e++,w=1),o=t.substring(ge,e),S=13}return o+=String.fromCharCode(re),e++,S=16}case 45:if(o+=String.fromCharCode(re),e++,e===r||!d(t.charCodeAt(e)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=$(),S=11;default:for(;e<r&&ne(re);)e++,re=t.charCodeAt(e);if(m!==e){switch(o=t.substring(m,e),o){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return o+=String.fromCharCode(re),e++,S=16}}function ne(re){if(p(re)||a(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let re;do re=Y();while(re>=12&&re<=15);return re}return{setPosition:U,getPosition:()=>e,scan:n?ce:Y,getToken:()=>S,getTokenValue:()=>o,getTokenOffset:()=>m,getTokenLength:()=>e-m,getTokenError:()=>w}}i.createScanner=T;function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function a(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function P(t,n){const e=[],r=new Object;let o;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function w(L,U,$,q){m.value=L,m.offset=U,m.length=$,m.type=q,m.colonOffset=void 0,o=m}try{y(t,{onObjectBegin:(L,U)=>{if(n<=L)throw r;o=void 0,S=n>L,e.push("")},onObjectProperty:(L,U,$)=>{if(n<U||(w(L,U,$,"property"),e[e.length-1]=L,n<=U+$))throw r},onObjectEnd:(L,U)=>{if(n<=L)throw r;o=void 0,e.pop()},onArrayBegin:(L,U)=>{if(n<=L)throw r;o=void 0,e.push(0)},onArrayEnd:(L,U)=>{if(n<=L)throw r;o=void 0,e.pop()},onLiteralValue:(L,U,$)=>{if(n<U||(w(L,U,$,s(L)),n<=U+$))throw r},onSeparator:(L,U,$)=>{if(n<=U)throw r;if(L===":"&&o&&o.type==="property")o.colonOffset=U,S=!1,o=void 0;else if(L===","){const q=e[e.length-1];typeof q=="number"?e[e.length-1]=q+1:(S=!0,e[e.length-1]=""),o=void 0}}})}catch(L){if(L!==r)throw L}return{path:e,previousNode:o,isAtPropertyKey:S,matches:L=>{let U=0;for(let $=0;U<L.length&&$<e.length;$++)if(L[U]===e[$]||L[U]==="*")U++;else if(L[U]!=="**")return!1;return U===L.length}}}i.getLocation=P;function g(t,n=[],e=k.DEFAULT){let r=null,o=[];const m=[];function S(L){Array.isArray(o)?o.push(L):r!==null&&(o[r]=L)}return y(t,{onObjectBegin:()=>{const L={};S(L),m.push(o),o=L,r=null},onObjectProperty:L=>{r=L},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const L=[];S(L),m.push(o),o=L,r=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:S,onError:(L,U,$)=>{n.push({error:L,offset:U,length:$})}},e),o[0]}i.parse=g;function E(t,n=[],e=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(L){r.type==="property"&&(r.length=L-r.offset,r=r.parent)}function m(L){return r.children.push(L),L}y(t,{onObjectBegin:L=>{r=m({type:"object",offset:L,length:-1,parent:r,children:[]})},onObjectProperty:(L,U,$)=>{r=m({type:"property",offset:U,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:L,offset:U,length:$,parent:r})},onObjectEnd:(L,U)=>{r.length=L+U-r.offset,r=r.parent,o(L+U)},onArrayBegin:(L,U)=>{r=m({type:"array",offset:L,length:-1,parent:r,children:[]})},onArrayEnd:(L,U)=>{r.length=L+U-r.offset,r=r.parent,o(L+U)},onLiteralValue:(L,U,$)=>{m({type:s(L),offset:U,length:$,parent:r,value:L}),o(U+$)},onSeparator:(L,U,$)=>{r.type==="property"&&(L===":"?r.colonOffset=U:L===","&&o(U))},onError:(L,U,$)=>{n.push({error:L,offset:U,length:$})}},e);const w=r.children[0];return w&&delete w.parent,w}i.parseTree=E;function l(t,n){if(!t)return;let e=t;for(const r of n)if(typeof r=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let o=!1;for(const m of e.children)if(Array.isArray(m.children)&&m.children[0].value===r){e=m.children[1],o=!0;break}if(!o)return}else{const o=r;if(e.type!=="array"||o<0||!Array.isArray(e.children)||o>=e.children.length)return;e=e.children[o]}return e}i.findNodeAtLocation=l;function f(t){if(!t.parent||!t.parent.children)return[];const n=f(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;n.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&n.push(e)}return n}i.getNodePath=f;function v(t){switch(t.type){case"array":return t.children.map(v);case"object":{const n=Object.create(null);for(const e of t.children){const r=e.children[1];r&&(n[e.children[0].value]=v(r))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=v;function u(t,n,e=!1){return n>=t.offset&&n<t.offset+t.length||e&&n===t.offset+t.length}i.contains=u;function h(t,n,e=!1){if(u(t,n,e)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const m=h(r[o],n,e);if(m)return m}return t}}i.findNodeAtOffset=h;function y(t,n,e=k.DEFAULT){const r=T(t,!1);function o(F){return F?()=>F(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(F){return F?V=>F(V,r.getTokenOffset(),r.getTokenLength()):()=>!0}const S=o(n.onObjectBegin),w=m(n.onObjectProperty),L=o(n.onObjectEnd),U=o(n.onArrayBegin),$=o(n.onArrayEnd),q=m(n.onLiteralValue),Y=m(n.onSeparator),ne=o(n.onComment),ce=m(n.onError),re=e&&e.disallowComments,ge=e&&e.allowTrailingComma;function ae(){for(;;){const F=r.scan();switch(r.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:re||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(F){case 12:case 13:re?N(10):ne();break;case 16:N(1);break;case 15:case 14:break;default:return F}}}function N(F,V=[],R=[]){if(ce(F),V.length+R.length>0){let O=r.getToken();for(;O!==17;){if(V.indexOf(O)!==-1){ae();break}else if(R.indexOf(O)!==-1)break;O=ae()}}}function _(F){const V=r.getTokenValue();return F?q(V):w(V),ae(),!0}function M(){switch(r.getToken()){case 11:{let F=0;try{F=JSON.parse(r.getTokenValue()),typeof F!="number"&&(N(2),F=0)}catch{N(2)}q(F);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return ae(),!0}function A(){return r.getToken()!==10?(N(3,[],[2,5]),!1):(_(!1),r.getToken()===6?(Y(":"),ae(),Q()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){S(),ae();let F=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(F||N(4,[],[]),Y(","),ae(),r.getToken()===2&&ge)break}else F&&N(6,[],[]);A()||N(4,[],[2,5]),F=!0}return L(),r.getToken()!==2?N(7,[2],[]):ae(),!0}function G(){U(),ae();let F=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(F||N(4,[],[]),Y(","),ae(),r.getToken()===4&&ge)break}else F&&N(6,[],[]);Q()||N(4,[],[4,5]),F=!0}return $(),r.getToken()!==4?N(8,[4],[]):ae(),!0}function Q(){switch(r.getToken()){case 3:return G();case 1:return W();case 10:return _(!0);default:return M()}}return ae(),r.getToken()===17?e.allowEmptyContent?!0:(N(4,[],[]),!1):Q()?(r.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}i.visit=y;function c(t,n){const e=T(t),r=[];let o,m=0,S;do switch(S=e.getPosition(),o=e.scan(),o){case 12:case 13:case 17:m!==S&&r.push(t.substring(m,S)),n!==void 0&&r.push(e.getTokenValue().replace(/[^\r\n]/g,n)),m=e.getPosition();break}while(o!==17);return r.join("")}i.stripComments=c;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function B(b){const k=[];typeof b=="number"&&k.push("code/timeOrigin",b);function T(a){k.push(a,Date.now())}function p(){const a=[];for(let d=0;d<k.length;d+=2)a.push({name:k[d],startTime:k[d+1]});return a}return{mark:T,getMarks:p}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(b+T.startTime)});return k}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function D(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=D(I))}(),function(B,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var I in D)(typeof exports=="object"?exports:B)[I]=D[I]}}(typeof self!="undefined"?self:this,function(){return function(B){var i={};function D(I){if(i[I])return i[I].exports;var b=i[I]={i:I,l:!1,exports:{}};return B[I].call(b.exports,b,b.exports,D),b.l=!0,b.exports}return D.m=B,D.c=i,D.d=function(I,b,k){D.o(I,b)||Object.defineProperty(I,b,{enumerable:!0,get:k})},D.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},D.t=function(I,b){if(1&b&&(I=D(I)),8&b||4&b&&typeof I=="object"&&I&&I.__esModule)return I;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:I}),2&b&&typeof I!="string")for(var T in I)D.d(k,T,function(p){return I[p]}.bind(null,T));return k},D.n=function(I){var b=I&&I.__esModule?function(){return I.default}:function(){return I};return D.d(b,"a",b),b},D.o=function(I,b){return Object.prototype.hasOwnProperty.call(I,b)},D.p="",D(D.s=0)}([function(B,i,D){(function(I){var b;i=B.exports=R,b=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var k=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,p=i.re=[],a=i.src=[],d=0,C=d++;a[C]="0|[1-9]\\d*";var P=d++;a[P]="[0-9]+";var g=d++;a[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=d++;a[E]="("+a[C]+")\\.("+a[C]+")\\.("+a[C]+")";var l=d++;a[l]="("+a[P]+")\\.("+a[P]+")\\.("+a[P]+")";var f=d++;a[f]="(?:"+a[C]+"|"+a[g]+")";var v=d++;a[v]="(?:"+a[P]+"|"+a[g]+")";var u=d++;a[u]="(?:-("+a[f]+"(?:\\."+a[f]+")*))";var h=d++;a[h]="(?:-?("+a[v]+"(?:\\."+a[v]+")*))";var y=d++;a[y]="[0-9A-Za-z-]+";var c=d++;a[c]="(?:\\+("+a[y]+"(?:\\."+a[y]+")*))";var s=d++,t="v?"+a[E]+a[u]+"?"+a[c]+"?";a[s]="^"+t+"$";var n="[v=\\s]*"+a[l]+a[h]+"?"+a[c]+"?",e=d++;a[e]="^"+n+"$";var r=d++;a[r]="((?:<|>)?=?)";var o=d++;a[o]=a[P]+"|x|X|\\*";var m=d++;a[m]=a[C]+"|x|X|\\*";var S=d++;a[S]="[v=\\s]*("+a[m]+")(?:\\.("+a[m]+")(?:\\.("+a[m]+")(?:"+a[u]+")?"+a[c]+"?)?)?";var w=d++;a[w]="[v=\\s]*("+a[o]+")(?:\\.("+a[o]+")(?:\\.("+a[o]+")(?:"+a[h]+")?"+a[c]+"?)?)?";var L=d++;a[L]="^"+a[r]+"\\s*"+a[S]+"$";var U=d++;a[U]="^"+a[r]+"\\s*"+a[w]+"$";var $=d++;a[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=d++;a[q]="(?:~>?)";var Y=d++;a[Y]="(\\s*)"+a[q]+"\\s+",p[Y]=new RegExp(a[Y],"g");var ne=d++;a[ne]="^"+a[q]+a[S]+"$";var ce=d++;a[ce]="^"+a[q]+a[w]+"$";var re=d++;a[re]="(?:\\^)";var ge=d++;a[ge]="(\\s*)"+a[re]+"\\s+",p[ge]=new RegExp(a[ge],"g");var ae=d++;a[ae]="^"+a[re]+a[S]+"$";var N=d++;a[N]="^"+a[re]+a[w]+"$";var _=d++;a[_]="^"+a[r]+"\\s*("+n+")$|^$";var M=d++;a[M]="^"+a[r]+"\\s*("+t+")$|^$";var A=d++;a[A]="(\\s*)"+a[r]+"\\s*("+n+"|"+a[S]+")",p[A]=new RegExp(a[A],"g");var W=d++;a[W]="^\\s*("+a[S]+")\\s+-\\s+("+a[S]+")\\s*$";var G=d++;a[G]="^\\s*("+a[w]+")\\s+-\\s+("+a[w]+")\\s*$";var Q=d++;a[Q]="(<|>)?=?\\s*\\*";for(var F=0;F<35;F++)b(F,a[F]),p[F]||(p[F]=new RegExp(a[F]));function V(z,K){if(z instanceof R)return z;if(typeof z!="string"||z.length>k||!(K?p[e]:p[s]).test(z))return null;try{return new R(z,K)}catch{return null}}function R(z,K){if(z instanceof R){if(z.loose===K)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof R))return new R(z,K);b("SemVer",z,K),this.loose=K;var J=z.trim().match(K?p[e]:p[s]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<T)return me}return ue}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}i.parse=V,i.valid=function(z,K){var J=V(z,K);return J?J.version:null},i.clean=function(z,K){var J=V(z.trim().replace(/^[=v]+/,""),K);return J?J.version:null},i.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(z){return b("SemVer.compare",this.version,this.loose,z),z instanceof R||(z=new R(z,this.loose)),this.compareMain(z)||this.comparePre(z)},R.prototype.compareMain=function(z){return z instanceof R||(z=new R(z,this.loose)),x(this.major,z.major)||x(this.minor,z.minor)||x(this.patch,z.patch)},R.prototype.comparePre=function(z){if(z instanceof R||(z=new R(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],ue=z.prerelease[K];if(b("prerelease compare",K,J,ue),J===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(J===void 0)return-1;if(J!==ue)return x(J,ue)}while(++K)},R.prototype.inc=function(z,K){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},i.inc=function(z,K,J,ue){typeof J=="string"&&(ue=J,J=void 0);try{return new R(z,J).inc(K,ue).version}catch{return null}},i.diff=function(z,K){if(oe(z,K))return null;var J=V(z),ue=V(K);if(J.prerelease.length||ue.prerelease.length){for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return me},i.compareIdentifiers=x;var O=/^[0-9]+$/;function x(z,K){var J=O.test(z),ue=O.test(K);return J&&ue&&(z=+z,K=+K),J&&!ue?-1:ue&&!J?1:z<K?-1:z>K?1:0}function j(z,K,J){return new R(z,J).compare(new R(K,J))}function H(z,K,J){return j(z,K,J)>0}function X(z,K,J){return j(z,K,J)<0}function oe(z,K,J){return j(z,K,J)===0}function le(z,K,J){return j(z,K,J)!==0}function pe(z,K,J){return j(z,K,J)>=0}function ve(z,K,J){return j(z,K,J)<=0}function ie(z,K,J,ue){var me;switch(K){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),me=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),me=z!==J;break;case"":case"=":case"==":me=oe(z,J,ue);break;case"!=":me=le(z,J,ue);break;case">":me=H(z,J,ue);break;case">=":me=pe(z,J,ue);break;case"<":me=X(z,J,ue);break;case"<=":me=ve(z,J,ue);break;default:throw new TypeError("Invalid operator: "+K)}return me}function se(z,K){if(z instanceof se){if(z.loose===K)return z;z=z.value}if(!(this instanceof se))return new se(z,K);b("comparator",z,K),this.loose=K,this.parse(z),this.semver===he?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(z,K){return x(K,z)},i.major=function(z,K){return new R(z,K).major},i.minor=function(z,K){return new R(z,K).minor},i.patch=function(z,K){return new R(z,K).patch},i.compare=j,i.compareLoose=function(z,K){return j(z,K,!0)},i.rcompare=function(z,K,J){return j(K,z,J)},i.sort=function(z,K){return z.sort(function(J,ue){return i.compare(J,ue,K)})},i.rsort=function(z,K){return z.sort(function(J,ue){return i.rcompare(J,ue,K)})},i.gt=H,i.lt=X,i.eq=oe,i.neq=le,i.gte=pe,i.lte=ve,i.cmp=ie,i.Comparator=se;var he={};function de(z,K){if(z instanceof de)return z.loose===K?z:new de(z.raw,K);if(z instanceof se)return new de(z.value,K);if(!(this instanceof de))return new de(z,K);if(this.loose=K,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Se(z){return!z||z.toLowerCase()==="x"||z==="*"}function Oe(z,K,J,ue,me,Ce,we,Te,be,De,Me,Re,Le){return((K=Se(J)?"":Se(ue)?">="+J+".0.0":Se(me)?">="+J+"."+ue+".0":">="+K)+" "+(Te=Se(be)?"":Se(De)?"<"+(+be+1)+".0.0":Se(Me)?"<"+be+"."+(+De+1)+".0":Re?"<="+be+"."+De+"."+Me+"-"+Re:"<="+Te)).trim()}function Ae(z,K){for(var J=0;J<z.length;J++)if(!z[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<z.length;J++)if(b(z[J].semver),z[J].semver!==he&&z[J].semver.prerelease.length>0){var ue=z[J].semver;if(ue.major===K.major&&ue.minor===K.minor&&ue.patch===K.patch)return!0}return!1}return!0}function Ue(z,K,J){try{K=new de(K,J)}catch{return!1}return K.test(z)}function xe(z,K,J,ue){var me,Ce,we,Te,be;switch(z=new R(z,ue),K=new de(K,ue),J){case">":me=H,Ce=ve,we=X,Te=">",be=">=";break;case"<":me=X,Ce=pe,we=H,Te="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,K,ue))return!1;for(var De=0;De<K.set.length;++De){var Me=K.set[De],Re=null,Le=null;if(Me.forEach(function(Fe){Fe.semver===he&&(Fe=new se(">=0.0.0")),Re=Re||Fe,Le=Le||Fe,me(Fe.semver,Re.semver,ue)?Re=Fe:we(Fe.semver,Le.semver,ue)&&(Le=Fe)}),Re.operator===Te||Re.operator===be||(!Le.operator||Le.operator===Te)&&Ce(z,Le.semver)||Le.operator===be&&we(z,Le.semver))return!1}return!0}se.prototype.parse=function(z){var K=this.loose?p[_]:p[M],J=z.match(K);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new R(J[2],this.loose):this.semver=he},se.prototype.toString=function(){return this.value},se.prototype.test=function(z){return b("Comparator.test",z,this.loose),this.semver===he||(typeof z=="string"&&(z=new R(z,this.loose)),ie(z,this.operator,this.semver,this.loose))},se.prototype.intersects=function(z,K){if(!(z instanceof se))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new de(z.value,K),Ue(this.value,J,K);if(z.operator==="")return J=new de(this.value,K),Ue(z.semver,J,K);var ue=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Ce=this.semver.version===z.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Te=ie(this.semver,"<",z.semver,K)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),be=ie(this.semver,">",z.semver,K)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ue||me||Ce&&we||Te||be},i.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(z){var K=this.loose;z=z.trim(),b("range",z,K);var J=K?p[G]:p[W];z=z.replace(J,Oe),b("hyphen replace",z),z=z.replace(p[A],"$1$2$3"),b("comparator trim",z,p[A]),z=(z=(z=z.replace(p[Y],"$1~")).replace(p[ge],"$1^")).split(/\s+/).join(" ");var ue=K?p[_]:p[M],me=z.split(" ").map(function(Ce){return function(we,Te){return b("comp",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Le){b("caret",Re,Le);var Fe=Le?p[N]:p[ae];return Re.replace(Fe,function(Ne,ye,Ee,Pe,Ie){var ke;return b("caret",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(b("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(b("no pr"),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),b("caret return",ke),ke})}(Me,De)}).join(" ")}(we,Te),b("caret",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Le){var Fe=Le?p[ce]:p[ne];return Re.replace(Fe,function(Ne,ye,Ee,Pe,Ie){var ke;return b("tilde",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(b("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):ke=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",b("tilde return",ke),ke})}(Me,De)}).join(" ")}(we,Te),b("tildes",we),we=function(be,De){return b("replaceXRanges",be,De),be.split(/\s+/).map(function(Me){return function(Re,Le){Re=Re.trim();var Fe=Le?p[U]:p[L];return Re.replace(Fe,function(Ne,ye,Ee,Pe,Ie,ke){b("xRange",Re,Ne,ye,Ee,Pe,Ie,ke);var We=Se(Ee),ze=We||Se(Pe),Ve=ze||Se(Ie);return ye==="="&&Ve&&(ye=""),We?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ve?(ze&&(Pe=0),Ve&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):Ve&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ve&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),b("xRange return",Ne),Ne})}(Me,De)}).join(" ")}(we,Te),b("xrange",we),we=function(be,De){return b("replaceStars",be,De),be.trim().replace(p[Q],"")}(we,Te),b("stars",we),we}(Ce,K)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(ue)})),me=me.map(function(Ce){return new se(Ce,K)})},de.prototype.intersects=function(z,K){if(!(z instanceof de))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ue){return z.set.some(function(me){return me.every(function(Ce){return ue.intersects(Ce,K)})})})})},i.toComparators=function(z,K){return new de(z,K).set.map(function(J){return J.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},de.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new R(z,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],z))return!0;return!1},i.satisfies=Ue,i.maxSatisfying=function(z,K,J){var ue=null,me=null;try{var Ce=new de(K,J)}catch{return null}return z.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==-1||(me=new R(ue=we,J)))}),ue},i.minSatisfying=function(z,K,J){var ue=null,me=null;try{var Ce=new de(K,J)}catch{return null}return z.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==1||(me=new R(ue=we,J)))}),ue},i.validRange=function(z,K){try{return new de(z,K).range||"*"}catch{return null}},i.ltr=function(z,K,J){return xe(z,K,"<",J)},i.gtr=function(z,K,J){return xe(z,K,">",J)},i.outside=xe,i.prerelease=function(z,K){var J=V(z,K);return J&&J.prerelease.length?J.prerelease:null},i.intersects=function(z,K,J){return z=new de(z,J),K=new de(K,J),z.intersects(K)},i.coerce=function(z){if(z instanceof R)return z;if(typeof z!="string")return null;var K=z.match(p[$]);return K==null?null:V((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,D(1))},function(B,i){var D,I,b=B.exports={};function k(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function p(v){if(D===setTimeout)return setTimeout(v,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(v,0);try{return D(v,0)}catch{try{return D.call(null,v,0)}catch{return D.call(this,v,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch{D=k}try{I=typeof clearTimeout=="function"?clearTimeout:T}catch{I=T}})();var a,d=[],C=!1,P=-1;function g(){C&&a&&(C=!1,a.length?d=a.concat(d):P=-1,d.length&&E())}function E(){if(!C){var v=p(g);C=!0;for(var u=d.length;u;){for(a=d,d=[];++P<u;)a&&a[P].run();P=-1,u=d.length}a=null,C=!1,function(h){if(I===clearTimeout)return clearTimeout(h);if((I===T||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(h);try{I(h)}catch{try{return I.call(null,h)}catch{return I.call(this,h)}}}(v)}}function l(v,u){this.fun=v,this.array=u}function f(){}b.nextTick=function(v){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];d.push(new l(v,u)),d.length!==1||C||p(E)},l.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=f,b.addListener=f,b.once=f,b.off=f,b.removeListener=f,b.removeAllListeners=f,b.emit=f,b.prependListener=f,b.prependOnceListener=f,b.listeners=function(v){return[]},b.binding=function(v){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(v){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Z[69],ee([0,1]),function(B,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class I{constructor(p,a,d){this.level=p,this.key=a,this.value=d,this.forward=[]}}const b=void 0;class k{constructor(p,a=2**16){this.comparator=p,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(a)|0),this._header=new I(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,b,b)}has(p){return Boolean(k._search(this,p,this.comparator))}get(p){return k._search(this,p,this.comparator)?.value}set(p,a){return k._insert(this,p,a,this.comparator)&&(this._size+=1),this}delete(p){const a=k._delete(this,p,this.comparator);return a&&(this._size-=1),a}forEach(p,a){let d=this._header.forward[0];for(;d;)p.call(a,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let p=this._header.forward[0];for(;p;)yield[p.key,p.value],p=p.forward[0]}*keys(){let p=this._header.forward[0];for(;p;)yield p.key,p=p.forward[0]}*values(){let p=this._header.forward[0];for(;p;)yield p.value,p=p.forward[0]}toString(){let p="[SkipList]:",a=this._header.forward[0];for(;a;)p+=`node(${a.key}, ${a.value}, lvl:${a.level})`,a=a.forward[0];return p}static _search(p,a,d){let C=p._header;for(let P=p._level-1;P>=0;P--)for(;C.forward[P]&&d(C.forward[P].key,a)<0;)C=C.forward[P];if(C=C.forward[0],C&&d(C.key,a)===0)return C}static _insert(p,a,d,C){const P=[];let g=p._header;for(let E=p._level-1;E>=0;E--){for(;g.forward[E]&&C(g.forward[E].key,a)<0;)g=g.forward[E];P[E]=g}if(g=g.forward[0],g&&C(g.key,a)===0)return g.value=d,!1;{const E=k._randomLevel(p);if(E>p._level){for(let l=p._level;l<E;l++)P[l]=p._header;p._level=E}g=new I(E,a,d);for(let l=0;l<E;l++)g.forward[l]=P[l].forward[l],P[l].forward[l]=g;return!0}}static _randomLevel(p,a=.5){let d=1;for(;Math.random()<a&&d<p._maxLevel;)d+=1;return d}static _delete(p,a,d){const C=[];let P=p._header;for(let g=p._level-1;g>=0;g--){for(;P.forward[g]&&d(P.forward[g].key,a)<0;)P=P.forward[g];C[g]=P}if(P=P.forward[0],!P||d(P.key,a)!==0)return!1;for(let g=0;g<p._level&&C[g].forward[g]===P;g++)C[g].forward[g]=P.forward[g];for(;p._level>0&&p._header.forward[p._level-1]===b;)p._level-=1;return!0}}i.SkipList=k}),define(Z[42],ee([0,1,12,2]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function b(c){const s=c;return s?typeof s.read=="function":!1}i.isReadable=b;function k(c){const s=c;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}i.isReadableStream=k;function T(c){const s=c;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=T;function p(c,s){return new a(c,s)}i.newWriteableStream=p;class a{constructor(s,t){this.reducer=s,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(t=>t(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(t=>t(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,t){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(s,t){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const e=n.indexOf(t);e>=0&&n.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,s){const t=[];let n;for(;(n=c.read())!==null;)t.push(n);return s(t)}i.consumeReadable=d;function C(c,s,t){const n=[];let e;for(;(e=c.read())!==null&&n.length<t;)n.push(e);return e===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof e!="undefined"){const r=e;return e=void 0,r}return c.read()}}}i.peekReadable=C;function P(c,s){return new Promise((t,n)=>{const e=[];g(c,{onData:r=>{s&&e.push(r)},onError:r=>{s?n(r):t(void 0)},onEnd:()=>{t(s?s(e):void 0)}})})}i.consumeStream=P;function g(c,s){let t=!1;return c.on("error",n=>{t||s.onError(n)}),c.on("end",()=>{t||s.onEnd()}),c.on("data",n=>{t||s.onData(n)}),(0,I.toDisposable)(()=>t=!0)}i.listenStream=g;function E(c,s){return new Promise((t,n)=>{const e=new I.DisposableStore,r=[],o=w=>{if(r.push(w),r.length>s)return e.dispose(),c.pause(),t({stream:c,buffer:r,ended:!1})},m=w=>n(w),S=()=>t({stream:c,buffer:r,ended:!0});e.add((0,I.toDisposable)(()=>c.removeListener("error",m))),c.on("error",m),e.add((0,I.toDisposable)(()=>c.removeListener("end",S))),c.on("end",S),e.add((0,I.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}i.peekStream=E;function l(c,s){const t=p(s);return t.end(c),t}i.toStream=l;function f(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}i.emptyStream=f;function v(c){let s=!1;return{read:()=>s?null:(s=!0,c)}}i.toReadable=v;function u(c,s,t){const n=p(t);return g(c,{onData:e=>n.write(s.data(e)),onError:e=>n.error(s.error?s.error(e):e),onEnd:()=>n.end()}),n}i.transform=u;function h(c,s,t){let n=!1;return{read:()=>{const e=s.read();return n?e:(n=!0,e!==null?t([c,e]):c)}}}i.prefixedReadable=h;function y(c,s,t){let n=!1;const e=p(t);return g(s,{onData:r=>n?e.write(r):(n=!0,e.write(t([c,r]))),onError:r=>e.error(r),onEnd:()=>{n||(n=!0,e.write(c)),e.end()}}),e}i.prefixedStream=y}),define(Z[15],ee([0,1,42]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,k;class T{constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}static alloc(w){return I?new T(Buffer.allocUnsafe(w)):new T(new Uint8Array(w))}static wrap(w){return I&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new T(w)}static fromString(w,L){return!(L?.dontUseNodeBuffer||!1)&&I?new T(Buffer.from(w)):(b||(b=new TextEncoder),new T(b.encode(w)))}static fromByteArray(w){const L=T.alloc(w.length);for(let U=0,$=w.length;U<$;U++)L.buffer[U]=w[U];return L}static concat(w,L){if(typeof L=="undefined"){L=0;for(let q=0,Y=w.length;q<Y;q++)L+=w[q].byteLength}const U=T.alloc(L);let $=0;for(let q=0,Y=w.length;q<Y;q++){const ne=w[q];U.set(ne,$),$+=ne.byteLength}return U}clone(){const w=T.alloc(this.byteLength);return w.set(this),w}toString(){return I?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(w,L){return new T(this.buffer.subarray(w,L))}set(w,L){if(w instanceof T)this.buffer.set(w.buffer,L);else if(w instanceof Uint8Array)this.buffer.set(w,L);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),L);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return d(this.buffer,w)}writeUInt32BE(w,L){C(this.buffer,w,L)}readUInt32LE(w){return P(this.buffer,w)}writeUInt32LE(w,L){g(this.buffer,w,L)}readUInt8(w){return E(this.buffer,w)}writeUInt8(w,L){l(this.buffer,w,L)}}i.VSBuffer=T;function p(S,w){return S[w+0]<<0>>>0|S[w+1]<<8>>>0}i.readUInt16LE=p;function a(S,w,L){S[L+0]=w&255,w=w>>>8,S[L+1]=w&255}i.writeUInt16LE=a;function d(S,w){return S[w]*2**24+S[w+1]*2**16+S[w+2]*2**8+S[w+3]}i.readUInt32BE=d;function C(S,w,L){S[L+3]=w,w=w>>>8,S[L+2]=w,w=w>>>8,S[L+1]=w,w=w>>>8,S[L]=w}i.writeUInt32BE=C;function P(S,w){return S[w+0]<<0>>>0|S[w+1]<<8>>>0|S[w+2]<<16>>>0|S[w+3]<<24>>>0}i.readUInt32LE=P;function g(S,w,L){S[L+0]=w&255,w=w>>>8,S[L+1]=w&255,w=w>>>8,S[L+2]=w&255,w=w>>>8,S[L+3]=w&255}i.writeUInt32LE=g;function E(S,w){return S[w]}i.readUInt8=E;function l(S,w,L){S[L]=w}i.writeUInt8=l;function f(S){return D.consumeReadable(S,w=>T.concat(w))}i.readableToBuffer=f;function v(S){return D.toReadable(S)}i.bufferToReadable=v;function u(S){return D.consumeStream(S,w=>T.concat(w))}i.streamToBuffer=u;async function h(S){return S.ended?T.concat(S.buffer):T.concat([...S.buffer,await u(S.stream)])}i.bufferedStreamToBuffer=h;function y(S){return D.toStream(S,w=>T.concat(w))}i.bufferToStream=y;function c(S){return D.transform(S,{data:w=>typeof w=="string"?T.fromString(w):T.wrap(w)},w=>T.concat(w))}i.streamToBufferReadableStream=c;function s(S){return D.newWriteableStream(w=>T.concat(w),S)}i.newWriteableBufferStream=s;function t(S,w){return D.prefixedReadable(S,w,L=>T.concat(L))}i.prefixedBufferReadable=t;function n(S,w){return D.prefixedStream(S,w,L=>T.concat(L))}i.prefixedBufferStream=n;function e(S){let w=0,L=0,U=0;const $=new Uint8Array(Math.floor(S.length/4*3)),q=ne=>{switch(L){case 3:$[U++]=w|ne,L=0;break;case 2:$[U++]=w|ne>>>2,w=ne<<6,L=3;break;case 1:$[U++]=w|ne>>>4,w=ne<<4,L=2;break;default:w=ne<<2,L=1}};for(let ne=0;ne<S.length;ne++){const ce=S.charCodeAt(ne);if(ce>=65&&ce<=90)q(ce-65);else if(ce>=97&&ce<=122)q(ce-97+26);else if(ce>=48&&ce<=57)q(ce-48+52);else if(ce===43||ce===45)q(62);else if(ce===47||ce===95)q(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${S[ne]}`)}}const Y=U;for(;L>0;)q(0);return T.wrap($).slice(0,Y)}i.decodeBase64=e;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:S},w=!0,L=!1){const U=L?o:r;let $="";const q=S.byteLength%3;let Y=0;for(;Y<S.byteLength-q;Y+=3){const ne=S[Y+0],ce=S[Y+1],re=S[Y+2];$+=U[ne>>>2],$+=U[(ne<<4|ce>>>4)&63],$+=U[(ce<<2|re>>>6)&63],$+=U[re&63]}if(q===1){const ne=S[Y+0];$+=U[ne>>>2],$+=U[ne<<4&63],w&&($+="==")}else if(q===2){const ne=S[Y+0],ce=S[Y+1];$+=U[ne>>>2],$+=U[(ne<<4|ce>>>4)&63],$+=U[ce<<2&63],w&&($+="=")}return $}i.encodeBase64=m}),define(Z[24],ee([0,1,7]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function I(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const f=Array.isArray(l)?[]:{};return Object.keys(l).forEach(v=>{l[v]&&typeof l[v]=="object"?f[v]=I(l[v]):f[v]=l[v]}),f}i.deepClone=I;function b(l){if(!l||typeof l!="object")return l;const f=[l];for(;f.length>0;){const v=f.shift();Object.freeze(v);for(const u in v)if(k.call(v,u)){const h=v[u];typeof h=="object"&&!Object.isFrozen(h)&&!(0,D.isTypedArray)(h)&&f.push(h)}}return l}i.deepFreeze=b;const k=Object.prototype.hasOwnProperty;function T(l,f){return p(l,f,new Set)}i.cloneAndChange=T;function p(l,f,v){if((0,D.isUndefinedOrNull)(l))return l;const u=f(l);if(typeof u!="undefined")return u;if((0,D.isArray)(l)){const h=[];for(const y of l)h.push(p(y,f,v));return h}if((0,D.isObject)(l)){if(v.has(l))throw new Error("Cannot clone recursive data-structure");v.add(l);const h={};for(const y in l)k.call(l,y)&&(h[y]=p(l[y],f,v));return v.delete(l),h}return l}function a(l,f,v=!0){return(0,D.isObject)(l)?((0,D.isObject)(f)&&Object.keys(f).forEach(u=>{u in l?v&&((0,D.isObject)(l[u])&&(0,D.isObject)(f[u])?a(l[u],f[u],v):l[u]=f[u]):l[u]=f[u]}),l):f}i.mixin=a;function d(l,f){if(l===f)return!0;if(l==null||f===null||f===void 0||typeof l!=typeof f||typeof l!="object"||Array.isArray(l)!==Array.isArray(f))return!1;let v,u;if(Array.isArray(l)){if(l.length!==f.length)return!1;for(v=0;v<l.length;v++)if(!d(l[v],f[v]))return!1}else{const h=[];for(u in l)h.push(u);h.sort();const y=[];for(u in f)y.push(u);if(y.sort(),!d(h,y))return!1;for(v=0;v<h.length;v++)if(!d(l[h[v]],f[h[v]]))return!1}return!0}i.equals=d;function C(l){const f=new Set;return JSON.stringify(l,(v,u)=>{if((0,D.isObject)(u)||Array.isArray(u)){if(f.has(u))return"[Circular]";f.add(u)}return u})}i.safeStringify=C;function P(l,f){const v=Object.create(null);return!l||!f||Object.keys(f).forEach(h=>{const y=l[h],c=f[h];d(y,c)||(v[h]=c)}),v}i.distinct=P;function g(l,f){const v=f.toLowerCase(),u=Object.keys(l).find(h=>h.toLowerCase()===v);return u?l[u]:l[f]}i.getCaseInsensitive=g;function E(l,f){const v=Object.create(null);for(const[u,h]of Object.entries(l))f(u,h)&&(v[u]=h);return v}i.filter=E}),define(Z[29],ee([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(b){return D.test(b)}i.isUUID=I,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(p){for(let a=0;a<p.length;a++)p[a]=Math.floor(Math.random()*256);return p};const k=new Uint8Array(16),T=[];for(let p=0;p<256;p++)T.push(p.toString(16).padStart(2,"0"));return function(){b(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let a=0,d="";return d+=T[k[a++]],d+=T[k[a++]],d+=T[k[a++]],d+=T[k[a++]],d+="-",d+=T[k[a++]],d+=T[k[a++]],d+="-",d+=T[k[a++]],d+=T[k[a++]],d+="-",d+=T[k[a++]],d+=T[k[a++]],d+="-",d+=T[k[a++]],d+=T[k[a++]],d+=T[k[a++]],d+=T[k[a++]],d+=T[k[a++]],d+=T[k[a++]],d}}()}),define(Z[70],ee([0,1,149]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class I{constructor(k="utf8"){this.stringDecoder=new D.StringDecoder(k),this.remaining=null}write(k){const T=[],p=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(p.length<1)return T;let a=0,d,C=a;for(;C<p.length;)if(d=p.charCodeAt(C),d===13||d===10){if(T.push(p.substring(a,C)),C++,C<p.length){const P=d;d=p.charCodeAt(C),(P===13&&d===10||P===10&&d===13)&&C++}a=C}else C++;return this.remaining=a<p.length?p.substr(a):null,T}end(){return this.remaining}}i.LineDecoder=I}),define(Z[71],ee([5,6]),function(B,i){return B.create("vs/base/common/date",i)}),define(Z[72],ee([0,1,71]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const I=60,b=I*60,k=b*24,T=k*7,p=k*30,a=k*365;function d(P,g,E){typeof P!="number"&&(P=P.getTime());const l=Math.round((new Date().getTime()-P)/1e3);if(l<-30)return(0,D.localize)(0,null,d(new Date().getTime()+l*1e3,!1));if(l<30)return(0,D.localize)(1,null);let f;return l<I?(f=l,g?f===1?E?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):E?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?E?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):E?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):l<b?(f=Math.floor(l/I),g?f===1?E?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):E?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?E?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):E?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):l<k?(f=Math.floor(l/b),g?f===1?E?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):E?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?E?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):E?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):l<T?(f=Math.floor(l/k),g?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):l<p?(f=Math.floor(l/T),g?f===1?E?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):E?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?E?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):E?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):l<a?(f=Math.floor(l/p),g?f===1?E?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):E?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?E?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):E?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(l/a),g?f===1?E?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):E?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?E?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):E?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}i.fromNow=d;function C(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=C}),define(Z[73],ee([5,6]),function(B,i){return B.create("vs/base/common/errorMessage",i)}),define(Z[30],ee([0,1,19,7,73]),function(B,i,D,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function k(P,g){return g&&(P.stack||P.stacktrace)?b.localize(0,null,p(P),T(P.stack)||T(P.stacktrace)):p(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?b.localize(1,null,P.message):P.message||b.localize(2,null)}function a(P=null,g=!1){if(!P)return b.localize(3,null);if(Array.isArray(P)){const E=D.coalesce(P),l=a(E[0],g);return E.length>1?b.localize(4,null,l,E.length):l}if(I.isString(P))return P;if(P.detail){const E=P.detail;if(E.error)return k(E.error,g);if(E.exception)return k(E.exception,g)}return P.stack?k(P,g):P.message?P.message:b.localize(5,null)}i.toErrorMessage=a;function d(P){const g=P;return g instanceof Error&&Array.isArray(g.actions)}i.isErrorWithActions=d;function C(P,g){let E;return typeof P=="string"?E=new Error(P):E=P,E.actions=g,E}i.createErrorWithActions=C}),define(Z[74],ee([5,6]),function(B,i){return B.create("vs/base/common/jsonErrorMessages",i)}),define(Z[75],ee([0,1,74]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function I(b){switch(b){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}i.getParseErrorMessage=I}),define(Z[52],ee([0,1,13]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var I;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(I=i.Source||(i.Source={}));var b;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(b=i.TerminateResponseCode||(i.TerminateResponseCode={}));function k(p,...a){const d=a.reduce((g,E)=>(g[E]=!0,g),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(g=>!d[g]).forEach(g=>{for(let E=0;E<C.length;E++)if(g.search(C[E])!==-1){delete p[g];break}})}i.sanitizeProcessEnvironment=k;function T(p){!p||(delete p.DEBUG,D.isMacintosh&&delete p.DYLD_LIBRARY_PATH,D.isLinux&&delete p.LD_PRELOAD)}i.removeDangerousEnvVariables=T}),define(Z[53],ee([0,1,4,2]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const b=T=>({onDidChange:D.Event.None,value:T});i.staticObservableValue=b;class k extends I.Disposable{constructor(p){super();this._value=p,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(p){p!==this._value&&(this._value=p,this.changeEmitter.fire(p))}}i.MutableObservableValue=k}),define(Z[54],ee([0,1,31]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function I(u){return b(u,0)}i.hash=I;function b(u,h){switch(typeof u){case"object":return u===null?k(349,h):Array.isArray(u)?a(u,h):d(u,h);case"string":return p(u,h);case"boolean":return T(u,h);case"number":return k(u,h);case"undefined":return k(937,h);default:return k(617,h)}}i.doHash=b;function k(u,h){return(h<<5)-h+u|0}i.numberHash=k;function T(u,h){return k(u?433:863,h)}function p(u,h){h=k(149417,h);for(let y=0,c=u.length;y<c;y++)h=k(u.charCodeAt(y),h);return h}i.stringHash=p;function a(u,h){return h=k(104579,h),u.reduce((y,c)=>b(c,y),h)}function d(u,h){return h=k(181387,h),Object.keys(u).sort().reduce((y,c)=>(y=p(c,y),b(u[c],y)),h)}class C{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=b(h,this._value),this._value}}i.Hasher=C;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function g(u,h,y=32){const c=y-h,s=~((1<<c)-1);return(u<<h|(s&u)>>>c)>>>0}function E(u,h=0,y=u.byteLength,c=0){for(let s=0;s<y;s++)u[h+s]=c}function l(u,h,y="0"){for(;u.length<h;)u=y+u;return u}function f(u,h=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(y=>y.toString(16).padStart(2,"0")).join(""):l((u>>>0).toString(16),h/4)}i.toHexString=f;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const y=h.length;if(y===0)return;const c=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,n,e;for(t!==0?(n=t,e=-1,t=0):(n=h.charCodeAt(0),e=0);;){let r=n;if(D.isHighSurrogate(n))if(e+1<y){const o=h.charCodeAt(e+1);D.isLowSurrogate(o)?(e++,r=D.computeCodePoint(n,o)):r=65533}else{t=n;break}else D.isLowSurrogate(n)&&(r=65533);if(s=this._push(c,s,r),e++,e<y)n=h.charCodeAt(e);else break}this._buffLen=s,this._leftoverHighSurrogate=t}_push(h,y,c){return c<128?h[y++]=c:c<2048?(h[y++]=192|(c&1984)>>>6,h[y++]=128|(c&63)>>>0):c<65536?(h[y++]=224|(c&61440)>>>12,h[y++]=128|(c&4032)>>>6,h[y++]=128|(c&63)>>>0):(h[y++]=240|(c&1835008)>>>18,h[y++]=128|(c&258048)>>>12,h[y++]=128|(c&4032)>>>6,h[y++]=128|(c&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=v._bigBlock32,y=this._buffDV;for(let S=0;S<64;S+=4)h.setUint32(S,y.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)h.setUint32(S,g(h.getUint32(S-12,!1)^h.getUint32(S-32,!1)^h.getUint32(S-56,!1)^h.getUint32(S-64,!1),1),!1);let c=this._h0,s=this._h1,t=this._h2,n=this._h3,e=this._h4,r,o,m;for(let S=0;S<80;S++)S<20?(r=s&t|~s&n,o=1518500249):S<40?(r=s^t^n,o=1859775393):S<60?(r=s&t|s&n|t&n,o=2400959708):(r=s^t^n,o=3395469782),m=g(c,5)+r+e+o+h.getUint32(S*4,!1)&4294967295,e=n,n=t,t=g(s,30),s=c,c=m;this._h0=this._h0+c&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+e&4294967295}}i.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[55],ee([0,1,31]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var I;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(I||(I={})),function(b){const k="error",T="warning",p="warn",a="info",d="ignore";function C(g){return g?D.equalsIgnoreCase(k,g)?b.Error:D.equalsIgnoreCase(T,g)||D.equalsIgnoreCase(p,g)?b.Warning:D.equalsIgnoreCase(a,g)?b.Info:b.Ignore:b.Ignore}b.fromValue=C;function P(g){switch(g){case b.Error:return k;case b.Warning:return T;case b.Info:return a;default:return d}}b.toString=P}(I||(I={})),i.default=I}),define(Z[76],ee([0,1,10]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function I(d){const C=d;return C&&typeof C.type=="string"&&typeof C.severity=="string"}i.isRemoteConsoleLog=I;function b(d){const C=[];let P;try{const g=JSON.parse(d.arguments),E=g[g.length-1];E&&E.__$stack&&(g.pop(),P=E.__$stack),C.push(...g)}catch{C.push("Unable to log remote console arguments",d.arguments)}return{args:C,stack:P}}i.parse=b;function k(d){if(typeof d!="string")return k(b(d).stack);const C=d;if(C){const P=T(C),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(g&&g.length===4)return{uri:D.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}i.getFirstFrame=k;function T(d){if(!d)return d;const C=d.indexOf(`
`);return C===-1?d:d.substring(0,C)}function p(d,C){const{args:P,stack:g}=b(d),E=typeof P[0]=="string"&&P.length===1;let l=T(g);l&&(l=`(${l.trim()})`);let f=[];if(typeof P[0]=="string"?l&&E?f=[`%c[${C}] %c${P[0]} %c${l}`,a("blue"),a(""),a("grey")]:f=[`%c[${C}] %c${P[0]}`,a("blue"),a(""),...P.slice(1)]:f=[`%c[${C}]%`,a("blue"),...P],l&&!E&&f.push(l),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,f)}i.log=p;function a(d){return`color: ${d}`}}),define(Z[43],ee([0,1,15,31,10]),function(B,i,D,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function k(d){return JSON.stringify(d,p)}i.stringify=k;function T(d){let C=JSON.parse(d);return C=a(C),C}i.parse=T;function p(d,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,I.regExpFlags)(C)}:C}function a(d,C=0){if(!d||C>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return b.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof D.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let P=0;P<d.length;++P)d[P]=a(d[P],C+1);else for(const P in d)Object.hasOwnProperty.call(d,P)&&(d[P]=a(d[P],C+1))}return d}i.revive=a}),define(Z[77],ee([0,1,44,14,20]),function(B,i,D,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,T=/^Microsoft.PowerShell_.*/,p=/^Microsoft.PowerShellPreview_.*/;var a;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(a||(a={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class P{constructor(s,t,n){this.exePath=s,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?d===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:c=!1,findPreview:s=!1}={}){const t=g({useAlternateBitness:c});if(!t)return null;const n=I.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(n))return null;let e=-1,r=null;for(const S of await b.Promises.readdir(n)){let w=-1;if(s){const U=S.indexOf("-");if(U<0)continue;const $=S.substring(0,U);if(!k.test($)||S.substring(U+1)!=="preview")continue;w=parseInt($,10)}else{if(!k.test(S))continue;w=parseInt(S,10)}if(w<=e)continue;const L=I.join(n,S,"pwsh.exe");!await b.SymlinkSupport.existsFile(L)||(r=L,e=w)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",m=s?" Preview":"";return new P(r,`PowerShell${m}${o}`,!0)}async function l({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const s=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=c?{pwshMsixDirRegex:p,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(s))if(t.test(e)){const r=I.join(s,e,"pwsh.exe");return new P(r,n)}return null}function f(){const c=I.join(D.homedir(),".dotnet","tools","pwsh.exe");return new P(c,".NET Core PowerShell Global Tool")}function v(){const c=I.join(process.env.windir,d===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(c,"Windows PowerShell",!0)}async function*u(){let c=await E();c&&(yield c),c=await E({useAlternateBitness:!0}),c&&(yield c),c=await l(),c&&(yield c),c=f(),c&&(yield c),c=await E({findPreview:!0}),c&&(yield c),c=await l({findPreview:!0}),c&&(yield c),c=await E({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=v(),c&&(yield c)}async function*h(){for await(const c of u())await c.exists()&&(yield c)}i.enumeratePowerShellInstallations=h;async function y(){for await(const c of h())return c;return null}i.getFirstAvailablePowerShellInstallation=y});var fe=this&&this.__decorate||function(B,i,D,I){var b=arguments.length,k=b<3?i:I===null?I=Object.getOwnPropertyDescriptor(i,D):I,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(B,i,D,I);else for(var p=B.length-1;p>=0;p--)(T=B[p])&&(k=(b<3?T(k):b>3?T(i,D,k):T(i,D))||k);return b>3&&k&&Object.defineProperty(i,D,k),k};define(Z[56],ee([0,1,19,3,15,25,50,12,4,2,43,31,7]),function(B,i,D,I,b,k,T,p,a,d,C,P,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var E;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(E=i.RequestType||(i.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(f=i.ResponseType||(i.ResponseType={}));function v(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(u||(u={}));class h{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class y{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var c;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(c||(c={}));function s(M){const A=b.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function t(M){return M.read(4).readUInt32BE(0)}function n(M){const A=b.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const e={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object)},r=typeof Buffer!="undefined";function o(M,A){if(typeof A=="undefined")M.write(e.Undefined);else if(typeof A=="string"){const W=b.VSBuffer.fromString(A);M.write(e.String),M.write(s(W.byteLength)),M.write(W)}else if(r&&Buffer.isBuffer(A)){const W=b.VSBuffer.wrap(A);M.write(e.Buffer),M.write(s(W.byteLength)),M.write(W)}else if(A instanceof b.VSBuffer)M.write(e.VSBuffer),M.write(s(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(e.Array),M.write(s(A.length));for(const W of A)o(M,W)}else{const W=b.VSBuffer.fromString(JSON.stringify(A));M.write(e.Object),M.write(s(W.byteLength)),M.write(W)}}function m(M){switch(M.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return M.read(t(M)).toString();case c.Buffer:return M.read(t(M)).buffer;case c.VSBuffer:return M.read(t(M));case c.Array:{const W=t(M),G=[];for(let Q=0;Q<W;Q++)G.push(m(M));return G}case c.Object:return JSON.parse(M.read(t(M)).toString())}}class S{constructor(A,W,G=null,Q=1e3){this.protocol=A,this.ctx=W,this.logger=G,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,v(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,v(A.type),A.data);return}}}send(A,W=void 0){const G=new y;return o(G,A),o(G,W),this.sendBuffer(G.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new h(A),G=m(W),Q=m(W),F=G[0];switch(F){case 100:return this.logger?.logIncoming(A.byteLength,G[1],1,`${l(F)}: ${G[2]}.${G[3]}`,Q),this.onPromise({type:F,id:G[1],channelName:G[2],name:G[3],arg:Q});case 102:return this.logger?.logIncoming(A.byteLength,G[1],1,`${l(F)}: ${G[2]}.${G[3]}`,Q),this.onEventListen({type:F,id:G[1],channelName:G[2],name:G[3],arg:Q});case 101:return this.logger?.logIncoming(A.byteLength,G[1],1,`${l(F)}`),this.disposeActiveRequest({type:F,id:G[1]});case 103:return this.logger?.logIncoming(A.byteLength,G[1],1,`${l(F)}`),this.disposeActiveRequest({type:F,id:G[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const G=new k.CancellationTokenSource;let Q;try{Q=W.call(this.ctx,A.name,A.arg,G.token)}catch(R){Q=Promise.reject(R)}const F=A.id;Q.then(R=>{this.sendResponse({id:F,data:R,type:201}),this.activeRequests.delete(A.id)},R=>{R instanceof Error?this.sendResponse({id:F,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.sendResponse({id:F,data:R,type:203}),this.activeRequests.delete(A.id)});const V=(0,d.toDisposable)(()=>G.cancel());this.activeRequests.set(A.id,V)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const G=A.id,F=W.listen(this.ctx,A.name,A.arg)(V=>this.sendResponse({id:G,data:V,type:204}));this.activeRequests.set(A.id,F)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:G})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=S;var w;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(w=i.RequestInitiator||(i.RequestInitiator={}));class L{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new a.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=W}getChannel(A){const W=this;return{call(G,Q,F){return W.isDisposed?Promise.reject(p.canceled()):W.requestPromise(A,G,Q,F)},listen(G,Q){return W.isDisposed?a.Event.None:W.requestEvent(A,G,Q)}}}requestPromise(A,W,G,Q=k.CancellationToken.None){const F=this.lastRequestId++,R={id:F,type:100,channelName:A,name:W,arg:G};if(Q.isCancellationRequested)return Promise.reject(p.canceled());let O;return new Promise((j,H)=>{if(Q.isCancellationRequested)return H(p.canceled());const X=()=>{const ve=ie=>{switch(ie.type){case 201:this.handlers.delete(F),j(ie.data);break;case 202:{this.handlers.delete(F);const se=new Error(ie.data.message);se.stack=ie.data.stack,se.name=ie.data.name,H(se);break}case 203:this.handlers.delete(F),H(ie.data);break}};this.handlers.set(F,ve),this.sendRequest(R)};let oe=null;this.state===u.Idle?X():(oe=(0,I.createCancelablePromise)(ve=>this.whenInitialized()),oe.then(()=>{oe=null,X()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:F,type:101}),H(p.canceled())},pe=Q.onCancellationRequested(le);O=(0,d.combinedDisposable)((0,d.toDisposable)(le),pe),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,G){const Q=this.lastRequestId++,V={id:Q,type:102,channelName:A,name:W,arg:G};let R=null;const O=new a.Emitter({onFirstListenerAdd:()=>{R=(0,I.createCancelablePromise)(j=>this.whenInitialized()),R.then(()=>{R=null,this.activeRequests.add(O),this.sendRequest(V)})},onLastListenerRemove:()=>{R?(R.cancel(),R=null):(this.activeRequests.delete(O),this.sendRequest({id:Q,type:103}))}}),x=j=>O.fire(j.data);return this.handlers.set(Q,x),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${l(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,l(A.type));return}}}send(A,W=void 0){const G=new y;return o(G,A),o(G,W),this.sendBuffer(G.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new h(A),G=m(W),Q=m(W),F=G[0];switch(F){case 200:return this.logger?.logIncoming(A.byteLength,0,0,v(F)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,G[1],0,v(F),Q),this.onResponse({type:G[0],id:G[1],data:Q})}}onResponse(A){if(A.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return a.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([T.memoize],L.prototype,"onDidInitializePromise",null),i.ChannelClient=L;class U{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new a.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new a.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:G})=>{a.Event.once(W.onMessage)(F=>{const V=new h(F),R=m(V),O=new S(W,R),x=new L(W);this.channels.forEach((H,X)=>O.registerChannel(X,H));const j={channelServer:O,channelClient:x,ctx:R};this._connections.add(j),this._onDidAddConnection.fire(j),G(()=>{O.dispose(),x.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const G=this;return{call(Q,F,V){let R;if((0,g.isFunction)(W)){const x=(0,D.getRandomElement)(G.connections.filter(W));R=x?Promise.resolve(x):a.Event.toPromise(a.Event.filter(G.onDidAddConnection,W))}else R=W.routeCall(G,Q,F);const O=R.then(x=>x.channelClient.getChannel(A));return q(O).call(Q,F,V)},listen(Q,F){if((0,g.isFunction)(W))return G.getMulticastEvent(A,W,Q,F);const V=W.routeEvent(G,Q,F).then(R=>R.channelClient.getChannel(A));return q(V).listen(Q,F)}}}getMulticastEvent(A,W,G,Q){const F=this;let V=new d.DisposableStore;const R=new a.Emitter({onFirstListenerAdd:()=>{V=new d.DisposableStore;const O=new a.EventMultiplexer,x=new Map,j=X=>{const le=X.channelClient.getChannel(A).listen(G,Q),pe=O.add(le);x.set(X,pe)},H=X=>{const oe=x.get(X);!oe||(oe.dispose(),x.delete(X))};F.connections.filter(W).forEach(j),a.Event.filter(F.onDidAddConnection,W)(j,void 0,V),F.onDidRemoveConnection(H,void 0,V),O.event(R.fire,R,V),V.add(O)},onLastListenerRemove:()=>{V.dispose()}});return R.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(G=>{G.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=U;class ${constructor(A,W,G=null){const Q=new y;o(Q,W),A.send(Q.buffer),this.channelClient=new L(A,G),this.channelServer=new S(A,W,G)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=$;function q(M){return{call(A,W,G){return M.then(Q=>Q.call(A,W,G))},listen(A,W){const G=new a.Relay;return M.then(Q=>G.input=Q.listen(A,W)),G.event}}}i.getDelayedChannel=q;function Y(M){let A=!1;return{call(W,G,Q){return A?M.call(W,G,Q):(0,I.timeout)(0).then(()=>A=!0).then(()=>M.call(W,G,Q))},listen(W,G){if(A)return M.listen(W,G);const Q=new a.Relay;return(0,I.timeout)(0).then(()=>A=!0).then(()=>Q.input=M.listen(W,G)),Q.event}}}i.getNextTickChannel=Y;class ne{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await a.Event.toPromise(A.onDidAddConnection),await this.route(A)}}i.StaticRouter=ne;var ce;(function(M){function A(F,V){const R=F,O=V&&V.disableMarshalling,x=new Map;for(const j in R)G(j)&&x.set(j,a.Event.buffer(R[j],!0));return new class{listen(j,H,X){const oe=x.get(H);if(oe)return oe;if(Q(H)){const le=R[H];if(typeof le=="function")return le.call(R,X)}throw new Error(`Event not found: ${H}`)}call(j,H,X){const oe=R[H];if(typeof oe=="function"){if(!O&&Array.isArray(X))for(let le=0;le<X.length;le++)X[le]=(0,C.revive)(X[le]);return oe.apply(R,X)}throw new Error(`Method not found: ${H}`)}}}M.fromService=A;function W(F,V){const R=V&&V.disableMarshalling;return new Proxy({},{get(O,x){if(typeof x=="string")return V?.properties?.has(x)?V.properties.get(x):Q(x)?function(j){return F.listen(x,j)}:G(x)?F.listen(x):async function(...j){let H;V&&!(0,g.isUndefinedOrNull)(V.context)?H=[V.context,...j]:H=j;const X=await F.call(x,H);return R?X:(0,C.revive)(X)};throw new Error(`Property not found: ${String(x)}`)}})}M.toService=W;function G(F){return F[0]==="o"&&F[1]==="n"&&P.isUpperAsciiLetter(F.charCodeAt(2))}function Q(F){return/^onDynamic/.test(F)&&P.isUpperAsciiLetter(F.charCodeAt(9))}})(ce=i.ProxyChannel||(i.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const A=M.toString();if(A!=="[object Object]")return A}return M}function ae(M){return Array.isArray(M)?M.map(ge):ge(M)}function N(M,A,W,G,Q,F,V){V=ae(V);const R=re[Q],O=R[G%R.length];let x=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(F)?(x=x.concat(V),x.push(")")):x.push(V),console.log.apply(console,x)}i.logWithColors=N;class _{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,G,Q,F){this._totalOutgoing+=A,N(this._outgoingPrefix,this._totalOutgoing,A,W,G,Q,F)}logIncoming(A,W,G,Q,F){this._totalIncoming+=A,N(this._incomingPrefix,this._totalIncoming,A,W,G,Q,F)}}i.IPCLogger=_}),define(Z[78],ee([0,1,3,4,2,7]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var T;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=i.StorageHint||(i.StorageHint={}));function p(P){const g=P;return g?.changed instanceof Map||g?.deleted instanceof Set}i.isStorageItemsChangeEvent=p;var a;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(a=i.StorageState||(i.StorageState={}));class d extends b.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((E,l)=>this.accept(l,E)),g.deleted?.forEach(E=>this.accept(E,void 0))}accept(g,E){if(this.state===a.Closed)return;let l=!1;(0,k.isUndefinedOrNull)(E)?l=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),l=!0),l&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const l=this.cache.get(g);return(0,k.isUndefinedOrNull)(l)?E:l}getBoolean(g,E){const l=this.get(g);return(0,k.isUndefinedOrNull)(l)?E:l==="true"}getNumber(g,E){const l=this.get(g);return(0,k.isUndefinedOrNull)(l)?E:parseInt(l,10)}async set(g,E){if(this.state===a.Closed)return;if((0,k.isUndefinedOrNull)(E))return this.delete(g);const l=String(E);if(this.cache.get(g)!==l)return this.cache.set(g,l),this.pendingInserts.set(g,l),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===a.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert?.forEach((E,l)=>this.items.set(l,E)),g.delete?.forEach(E=>this.items.delete(E))}async close(){}}i.InMemoryStorageDatabase=C}),define(Z[79],ee([5,6]),function(B,i){return B.create("vs/base/node/processes",i)}),define(Z[57],ee([0,1,45,80,16,24,14,13,35,52,7,70,20,79]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function l(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(s,t){if(p.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const e=D.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(r=>{e.once("error",o=>{r({success:!1,error:o})}),e.once("exit",(o,m)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?l(n.status):1})}else if(p.isLinux||p.isMacintosh)try{const n=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",B).fsPath;return new Promise(e=>{D.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,o,m)=>{e(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function v(s=a.env){return s.comspec||"cmd.exe"}i.getWindowsShell=v;class u{constructor(t,n,e,r){if(n!==void 0&&e!==void 0&&r!==void 0)this.cmd=t,this.args=n,this.shell=e,this.options=r;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(a.env).forEach(m=>{o[m]=a.env[m]}),Object.keys(this.options.env).forEach(m=>{o[m]=this.options.env[m]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(T.sep);return n!==-1&&(t=t.substring(n+1)),u.WellKnowCommands[t]?t:"other"}start(t){return p.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(a.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let e,r;const o=new Promise((m,S)=>{e=m,r=S});if(n){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=D.exec(m,this.options,(S,w,L)=>{this.childProcess=null;const U=S;U&&U.killed?r({killed:this.terminateRequested,stdout:w.toString(),stderr:L.toString()}):this.handleExec(e,t,S,w,L)})}else{let m=null;const S=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,e,t,r);const L={terminated:this.terminateRequested};C.isNumber(w)&&(L.cmdCode=w),e(L)};if(this.shell&&p.isWindows){const w=k.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let L=!1,U=!1;const $=[];let q=this.ensureQuotes(this.cmd);$.push(q.value),L=q.quoted,this.args&&this.args.forEach(ne=>{q=this.ensureQuotes(ne),$.push(q.value),U=U&&q.quoted});const Y=["/s","/c"];L?U?Y.push('"'+$.join(" ")+'"'):$.length>1?Y.push('"'+$[0]+'" '+$.slice(1).join(" ")):Y.push('"'+$[0]+'"'):Y.push($.join(" ")),m=D.spawn(v(),Y,w)}else this.cmd&&(m=D.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(C.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",w=>{this.childProcess=null,r({terminated:this.terminateRequested,error:w})}),m.pid&&(this.childProcess.on("close",S),this.handleSpawn(m,e,t,r,!0)))}return o})}handleClose(t,n,e,r){}ensureQuotes(t){return u.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,f(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!p.isWindows)return t(!1);const n=D.spawn(v(),["/s","/c"]);n.on("error",e=>t(!0)),n.on("exit",e=>t(!1))})}}i.AbstractProcess=u,u.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},u.regexp=/^[^"].* .*[^"]/;class h extends u{constructor(t,n,e,r){super(t,n,e,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,e,r,o){[r,o].forEach((m,S)=>{const w=new P.LineDecoder;w.write(m).forEach($=>{n({line:$,source:S===0?0:1})});const U=w.end();U&&n({line:U,source:S===0?0:1})}),t({terminated:this.terminateRequested,error:e})}handleSpawn(t,n,e,r,o){const m=new P.LineDecoder,S=new P.LineDecoder;t.stdout.on("data",w=>{m.write(w).forEach(U=>e({line:U,source:0}))}),t.stderr.on("data",w=>{S.write(w).forEach(U=>e({line:U,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=S}handleClose(t,n,e,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&e({line:o,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&e({line:m,source:1})}}i.LineProcess=h;function y(s){let t=[],n=!1;const e=function(r){if(n){t.push(r);return}(!s.send(r,m=>{if(m&&console.error(m),n=!1,t.length>0){const S=t.slice(0);t=[],S.forEach(w=>e(w))}})||p.isWindows)&&(n=!0)};return{send:e}}i.createQueuedSender=y;var c;(function(s){async function t(n,e,r){if(T.isAbsolute(n))return n;if(e===void 0&&(e=a.cwd()),T.dirname(n)!=="."||(r===void 0&&C.isString(a.env.PATH)&&(r=a.env.PATH.split(T.delimiter)),r===void 0||r.length===0))return T.join(e,n);async function m(S){if(await g.Promises.exists(S)){let w;try{w=await g.Promises.stat(S)}catch(L){L.message.startsWith("EACCES")&&(w=await g.Promises.lstat(S))}return w?!w.isDirectory():!1}return!1}for(const S of r){let w;if(T.isAbsolute(S)?w=T.join(S,n):w=T.join(e,S,n),await m(w))return w;let L=w+".com";if(await m(L)||(L=w+".exe",await m(L)))return L}return T.join(e,n)}s.findExecutable=t})(c=i.win32||(i.win32={}))}),define(Z[81],ee([0,1,44,13,77,57]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function T(E,l){return E===1?I.isWindows?P():k.getWindowsShell(l):d(E,l)}i.getSystemShell=T;function p(E,l){return E===1?I.isWindows?g(l):k.getWindowsShell(l):d(E,l)}i.getSystemShellSync=p;let a=null;function d(E,l){if(I.isLinux&&E===2||I.isMacintosh&&E===3)return"/bin/bash";if(!a){let f;if(I.isWindows)f="/bin/bash";else{if(f=l.SHELL,!f)try{f=(0,D.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}a=f}return a}let C=null;async function P(){return C||(C=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),C}function g(E){if(C)return C;const l=I.isWindows&&parseFloat((0,D.release)())>=10,f=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${E.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?v:k.getWindowsShell(E)}}),define(Z[82],ee([0,1,45,3,15,25,76,12,4,2,24,57,52,56]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class l extends E.ChannelServer{constructor(u){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:a.Event.fromNodeEventEmitter(process,"message",h=>b.VSBuffer.wrap(Buffer.from(h,"base64")))},u);process.once("disconnect",()=>this.dispose())}}i.Server=l;class f{constructor(u,h){this.modulePath=u,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new a.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new I.Delayer(y),this.child=null,this._client=null}getChannel(u){const h=this;return{call(y,c,s){return h.requestPromise(u,y,c,s)},listen(y,c){return h.requestEvent(u,y,c)}}}requestPromise(u,h,y,c=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(u),t=(0,I.createCancelablePromise)(r=>s.call(h,y,r)),n=c.onCancellationRequested(()=>t.cancel()),e=(0,d.toDisposable)(()=>t.cancel());return this.activeRequests.add(e),t.finally(()=>{n.dispose(),this.activeRequests.delete(e),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(u,h,y){if(!this.disposeDelayer)return a.Event.None;this.disposeDelayer.cancel();let c;const s=new a.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(u).listen(h,y)(s.fire,s),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,g.removeDangerousEnvVariables)(h.env),this.child=(0,D.fork)(this.modulePath,u,h);const y=new a.Emitter;a.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.options.serverName}`);return}y.fire(b.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=y.event,e={send:t,onMessage:n};this._client=new E.ChannelClient(e);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,m)=>{process.removeListener("exit",r),this.activeRequests.forEach(S=>(0,d.dispose)(S)),this.activeRequests.clear(),o!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:m})})}return this._client}getCachedChannel(u){let h=this.channels.get(u);return h||(h=this.client.getChannel(u),this.channels.set(u,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=f}),define(Z[83],ee([5,6]),function(B,i){return B.create("vs/base/node/zip",i)}),define(Z[84],ee([5,6]),function(B,i){return B.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Z[85],ee([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Z[86],ee([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Z[87],ee([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Z[88],ee([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(Z[89],ee([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Z[90],ee([5,6]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Z[91],ee([5,6]),function(B,i){return B.create("vs/platform/extensions/common/extensionValidator",i)}),define(Z[92],ee([5,6]),function(B,i){return B.create("vs/platform/files/common/fileService",i)}),define(Z[93],ee([5,6]),function(B,i){return B.create("vs/platform/files/common/io",i)}),define(Z[94],ee([5,6]),function(B,i){return B.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Z[95],ee([5,6]),function(B,i){return B.create("vs/platform/languagePacks/common/languagePacks",i)}),define(Z[96],ee([5,6]),function(B,i){return B.create("vs/platform/request/common/request",i)}),define(Z[97],ee([5,6]),function(B,i){return B.create("vs/platform/shell/node/shellEnv",i)}),define(Z[98],ee([5,6]),function(B,i){return B.create("vs/platform/telemetry/common/telemetryService",i)}),define(Z[99],ee([5,6]),function(B,i){return B.create("vs/platform/userDataProfile/common/userDataProfile",i)}),define(Z[100],ee([5,6]),function(B,i){return B.create("vs/platform/workspace/common/workspace",i)}),define(Z[101],ee([0,1,72,50,16,14,35,18,10]),function(B,i,D,I,b,k,T,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class d{constructor(f,v,u){this._args=f,this.paths=v,this.productService=u,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,k.dirname)(b.FileAccess.asFileUri("",B).fsPath)}get userHome(){return a.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return a.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return a.URI.file(this.paths.tmpDir)}get cacheHome(){return a.URI.file(this.userDataPath)}get stateResource(){return(0,p.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,p.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return a.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return a.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,p.joinPath)(a.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,p.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,p.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,p.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=T.env.VSCODE_PORTABLE;return f?a.URI.file((0,k.join)(f,"argv.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return a.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,k.resolve)(f):(0,k.normalize)((0,k.join)(b.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?(0,k.resolve)(f):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,k.resolve)(f);const v=T.env.VSCODE_EXTENSIONS;if(v)return v;const u=T.env.VSCODE_PORTABLE;return u?(0,k.join)(u,"extensions"):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(v=>/^[^:/?#]+?:\/\//.test(v)?a.URI.parse(v):a.URI.file((0,k.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?a.URI.parse(f):a.URI.file((0,k.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,p.joinPath)(a.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return a.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=T.env.VSCODE_PORTABLE;return f?a.URI.file((0,k.join)(f,"policy.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}fe([I.memoize],d.prototype,"appRoot",null),fe([I.memoize],d.prototype,"userHome",null),fe([I.memoize],d.prototype,"userDataPath",null),fe([I.memoize],d.prototype,"appSettingsHome",null),fe([I.memoize],d.prototype,"tmpDir",null),fe([I.memoize],d.prototype,"cacheHome",null),fe([I.memoize],d.prototype,"stateResource",null),fe([I.memoize],d.prototype,"userRoamingDataHome",null),fe([I.memoize],d.prototype,"userDataSyncHome",null),fe([I.memoize],d.prototype,"userDataSyncLogResource",null),fe([I.memoize],d.prototype,"editSessionsLogResource",null),fe([I.memoize],d.prototype,"sync",null),fe([I.memoize],d.prototype,"machineSettingsResource",null),fe([I.memoize],d.prototype,"workspaceStorageHome",null),fe([I.memoize],d.prototype,"localHistoryHome",null),fe([I.memoize],d.prototype,"keyboardLayoutResource",null),fe([I.memoize],d.prototype,"argvResource",null),fe([I.memoize],d.prototype,"isExtensionDevelopment",null),fe([I.memoize],d.prototype,"untitledWorkspacesHome",null),fe([I.memoize],d.prototype,"installSourcePath",null),fe([I.memoize],d.prototype,"builtinExtensionsPath",null),fe([I.memoize],d.prototype,"extensionsPath",null),fe([I.memoize],d.prototype,"extensionDevelopmentLocationURI",null),fe([I.memoize],d.prototype,"extensionDevelopmentKind",null),fe([I.memoize],d.prototype,"extensionTestsLocationURI",null),fe([I.memoize],d.prototype,"debugExtensionHost",null),fe([I.memoize],d.prototype,"serviceMachineIdResource",null),fe([I.memoize],d.prototype,"telemetryLogResource",null),fe([I.memoize],d.prototype,"disableWorkspaceTrust",null),fe([I.memoize],d.prototype,"policyFile",null),i.AbstractNativeEnvironmentService=d;function C(l,f){return E(l["inspect-extensions"],l["inspect-brk-extensions"],5870,f,l.debugId,l.extensionEnvironment)}i.parseExtensionHostPort=C;function P(l,f){return E(l["inspect-search"],l["inspect-brk-search"],5876,f,l.extensionEnvironment)}i.parseSearchPort=P;function g(l,f){return E(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,f,l.extensionEnvironment)}i.parsePtyHostPort=g;function E(l,f,v,u,h,y){const s=Number(f||l)||(u?null:v),t=s?Boolean(!!f):!1;let n;if(y)try{n=JSON.parse(y)}catch{}return{port:s,break:t,debugId:h,env:n}}}),define(Z[102],ee([0,1,44,101,150]),function(B,i,D,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class k extends I.AbstractNativeEnvironmentService{constructor(p,a){super(p,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,b.getUserDataPath)(p)},a)}}i.NativeEnvironmentService=k}),define(Z[46],ee([0,1,18,55,91,38]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function a(u){return u=u.trim(),u==="*"||T.test(u)}i.isValidVersionStr=a;function d(u){if(!a(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}i.parseVersion=d;function C(u){if(!u)return null;const h=u.majorBase,y=u.majorMustEqual,c=u.minorBase;let s=u.minorMustEqual;const t=u.patchBase;let n=u.patchMustEqual;u.hasCaret&&(h===0||(s=!1),n=!1);let e=0;if(u.preRelease){const r=p.exec(u.preRelease);if(r){const[,o,m,S]=r;e=Date.UTC(Number(o),Number(m)-1,Number(S))}}return{majorBase:h,majorMustEqual:y,minorBase:c,minorMustEqual:s,patchBase:t,patchMustEqual:n,isMinimum:u.hasGreaterEquals,notBefore:e}}i.normalizeVersion=C;function P(u,h,y){let c;typeof u=="string"?c=C(d(u)):c=u;let s;h instanceof Date?s=h.getTime():typeof h=="string"&&(s=new Date(h).getTime());let t;if(typeof y=="string"?t=C(d(y)):t=y,!c||!t)return!1;const n=c.majorBase,e=c.minorBase,r=c.patchBase;let o=t.majorBase,m=t.minorBase,S=t.patchBase;const w=t.notBefore;let L=t.majorMustEqual,U=t.minorMustEqual,$=t.patchMustEqual;return t.isMinimum?n>o?!0:n<o?!1:e>m?!0:e<m||s&&s<w?!1:r>=S:(n===1&&o===0&&(!L||!U||!$)&&(o=1,m=0,S=0,L=!0,U=!1,$=!1),n<o?!1:n>o?!L:e<m?!1:e>m?!U:r<S?!1:r>S?!$:!(s&&s<w))}i.isValidVersion=P;function g(u,h,y,c,s){const t=[];if(typeof c.publisher!="undefined"&&typeof c.publisher!="string")return t.push([I.default.Error,b.localize(0,null)]),t;if(typeof c.name!="string")return t.push([I.default.Error,b.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([I.default.Error,b.localize(2,null,"version")]),t;if(!c.engines)return t.push([I.default.Error,b.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([I.default.Error,b.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies!="undefined"&&!v(c.extensionDependencies))return t.push([I.default.Error,b.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents!="undefined"){if(!v(c.activationEvents))return t.push([I.default.Error,b.localize(6,null,"activationEvents")]),t;if(typeof c.main=="undefined"&&typeof c.browser=="undefined")return t.push([I.default.Error,b.localize(7,null,"activationEvents","main")]),t}if(typeof c.extensionKind!="undefined"&&typeof c.main=="undefined"&&t.push([I.default.Warning,b.localize(8,null,"extensionKind")]),typeof c.main!="undefined"){if(typeof c.main!="string")return t.push([I.default.Error,b.localize(9,null,"main")]),t;{const r=(0,D.joinPath)(y,c.main);(0,D.isEqualOrParent)(r,y)||t.push([I.default.Warning,b.localize(10,null,r.path,y.path)])}if(typeof c.activationEvents=="undefined")return t.push([I.default.Error,b.localize(11,null,"activationEvents","main")]),t}if(typeof c.browser!="undefined"){if(typeof c.browser!="string")return t.push([I.default.Error,b.localize(12,null,"browser")]),t;{const r=(0,D.joinPath)(y,c.browser);(0,D.isEqualOrParent)(r,y)||t.push([I.default.Warning,b.localize(13,null,r.path,y.path)])}if(typeof c.activationEvents=="undefined")return t.push([I.default.Error,b.localize(14,null,"activationEvents","browser")]),t}if(!k.valid(c.version))return t.push([I.default.Error,b.localize(15,null)]),t;const n=[];if(!E(u,h,c,s,n))for(const r of n)t.push([I.default.Error,r]);return t}i.validateExtensionManifest=g;function E(u,h,y,c,s){return c||typeof y.main=="undefined"&&typeof y.browser=="undefined"?!0:f(u,h,y.engines.vscode,s)}i.isValidExtensionVersion=E;function l(u,h,y){return u==="*"||f(h,y,u)}i.isEngineValid=l;function f(u,h,y,c=[]){const s=C(d(y));if(!s)return c.push(b.localize(16,null,y)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return c.push(b.localize(17,null,y)),!1}else if(!s.majorMustEqual)return c.push(b.localize(18,null,y)),!1;return P(u,h,s)?!0:(c.push(b.localize(19,null,u,y)),!1)}function v(u){if(!Array.isArray(u))return!1;for(let h=0,y=u.length;h<y;h++)if(typeof u[h]!="string")return!1;return!0}}),define(Z[103],ee([0,1,15,29]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(k,T,p){let a=p&&p.get("storage.serviceMachineId",-1)||null;if(a)return a;try{const C=(await T.readFile(k.serviceMachineIdResource)).value.toString();a=(0,I.isUUID)(C)?C:null}catch{a=null}if(!a){a=(0,I.generateUuid)();try{await T.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(a))}catch{}}return p?.store("storage.serviceMachineId",a,-1,1),a}i.getServiceMachineId=b}),define(Z[47],ee([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(b,k=[],T=!1){this.ctor=b,this.staticArguments=k,this.supportsDelayedInstantiation=T}}i.SyncDescriptor=D}),define(Z[104],ee([0,1,47]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const I=[];function b(T,p,a){p instanceof D.SyncDescriptor||(p=new D.SyncDescriptor(p,[],a)),I.push([T,p])}i.registerSingleton=b;function k(){return I}i.getSingletonServiceDescriptors=k}),define(Z[105],ee([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}i.Node=D;class I{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const T of this._nodes.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const p=this.lookupOrInsertNode(k),a=this.lookupOrInsertNode(T);p.outgoing.set(this._hashFn(T),a),a.incoming.set(this._hashFn(k),p)}removeNode(k){const T=this._hashFn(k);this._nodes.delete(T);for(const p of this._nodes.values())p.outgoing.delete(T),p.incoming.delete(T)}lookupOrInsertNode(k){const T=this._hashFn(k);let p=this._nodes.get(T);return p||(p=new D(k),this._nodes.set(T,p)),p}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[T,p]of this._nodes)k.push(`${T}, (incoming)[${[...p.incoming.keys()].join(", ")}], (outgoing)[${[...p.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(const[k,T]of this._nodes){const p=new Set([k]),a=this._findCycle(T,p);if(a)return a}}_findCycle(k,T){for(const[p,a]of k.outgoing){if(T.has(p))return[...T,p].join(" -> ");T.add(p);const d=this._findCycle(a,T);if(d)return d;T.delete(p)}}}i.Graph=I}),define(Z[21],ee([0,1,7,10,8]),function(B,i,D,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,b.createDecorator)("configurationService");function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof I.URI)}i.isConfigurationOverrides=k;function T(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||D.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof I.URI)}i.isConfigurationUpdateOverrides=T;var p;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(p=i.ConfigurationTarget||(i.ConfigurationTarget={}));function a(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}i.ConfigurationTargetToString=a;function d(u,h){const y=Object.create(null);for(const c in u)C(y,c,u[c],h);return y}i.toValuesTree=d;function C(u,h,y,c){const s=h.split("."),t=s.pop();let n=u;for(let e=0;e<s.length;e++){const r=s[e];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${h} as ${s.slice(0,e+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[t]=y}catch{c(`Ignoring ${h} as ${s.join(".")} is ${JSON.stringify(n)}`)}else c(`Ignoring ${h} as ${s.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=C;function P(u,h){const y=h.split(".");g(u,y)}i.removeFromValueTree=P;function g(u,h){const y=h.shift();if(h.length===0){delete u[y];return}if(Object.keys(u).indexOf(y)!==-1){const c=u[y];typeof c=="object"&&!Array.isArray(c)&&(g(c,h),Object.keys(c).length===0&&delete u[y])}}function E(u,h,y){function c(n,e){let r=n;for(const o of e){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=h.split("."),t=c(u,s);return typeof t=="undefined"?y:t}i.getConfigurationValue=E;function l(u,h,y){Object.keys(h).forEach(c=>{c!=="__proto__"&&(c in u?D.isObject(u[c])&&D.isObject(h[c])?l(u[c],h[c],y):y&&(u[c]=h[c]):u[c]=h[c])})}i.merge=l;function f(u,h,y){const c=u.inspect(h),s=u.inspect(y);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:c.defaultValue}i.getMigratedSettingValue=f;function v(u){return u.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=v}),define(Z[58],ee([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Z[17],ee([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(Z[22],ee([0,1,86,8]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDefaultExtensionsProfileInitService=i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IServerExtensionManagementService=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function b(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=b;function k(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=k;function T(u,h){switch(u){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=T;function p(u,h){return h==="web"&&!u.includes("web")}i.isNotWebExtensionInWebTargetPlatform=p;function a(u,h,y){return p(h,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:d(y).includes(u)}i.isTargetPlatformCompatible=a;function d(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=d;function C(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}i.isIExtensionIdentifier=C;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P=i.SortBy||(i.SortBy={}));var g;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(g=i.SortOrder||(i.SortOrder={}));var E;(function(u){u.Install="install",u.Uninstall="uninstall"})(E=i.StatisticType||(i.StatisticType={}));var l;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(l=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var f;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(f=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class v extends Error{constructor(h,y){super(h);this.code=y,this.name=y}}i.ExtensionManagementError=v,i.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),i.IServerExtensionManagementService=(0,I.refineServiceDecorator)(i.IExtensionManagementService),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService"),i.IDefaultExtensionsProfileInitService=(0,I.createDecorator)("IDefaultExtensionsProfileInitService")}),define(Z[59],ee([0,1,15,12,93,11]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function T(C,P,g,E,l,f){let v;try{await p(C,P,g,E,l,f)}catch(u){v=u}finally{v&&l.errorTransformer&&(v=l.errorTransformer(v)),typeof v!="undefined"&&g.error(v),g.end()}}i.readFileIntoStream=T;async function p(C,P,g,E,l,f){a(f);const v=await C.open(P,{create:!1});try{a(f);let u=0,h=0,y=l&&typeof l.length=="number"?l.length:void 0,c=D.VSBuffer.alloc(Math.min(l.bufferSize,typeof y=="number"?y:l.bufferSize)),s=l&&typeof l.position=="number"?l.position:0,t=0;do h=await C.read(v,s,c.buffer,t,c.byteLength-t),s+=h,t+=h,u+=h,typeof y=="number"&&(y-=h),t===c.byteLength&&(await g.write(E(c)),c=D.VSBuffer.alloc(Math.min(l.bufferSize,typeof y=="number"?y:l.bufferSize)),t=0);while(h>0&&(typeof y!="number"||y>0)&&a(f)&&d(u,l));if(t>0){let n=t;typeof y=="number"&&(n=Math.min(t,y)),g.write(E(c.slice(0,n)))}}catch(u){throw(0,k.ensureFileSystemProviderError)(u)}finally{await C.close(v)}}function a(C){if(C.isCancellationRequested)throw(0,I.canceled)();return!0}function d(C,P){if(P?.limits){if(typeof P.limits.memory=="number"&&C>P.limits.memory)throw(0,k.createFileSystemProviderError)((0,b.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&C>P.limits.size)throw(0,k.createFileSystemProviderError)((0,b.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[106],ee([0,1,4,151,2,13,152]),function(B,i,D,I,b,k,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class p extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const C=this.normalizeRequests(d),P=C.filter(E=>{const l=this.watchers.get(E.path);return l?!(0,I.patternsEquals)(l.request.excludes,E.excludes)||!(0,I.patternsEquals)(l.request.includes,E.includes):!0}),g=Array.from(this.watchers.values()).filter(({request:E})=>!C.find(l=>l.path===E.path&&(0,I.patternsEquals)(l.excludes,E.excludes)&&(0,I.patternsEquals)(l.includes,E.includes))).map(({request:E})=>E.path);P.length&&this.trace(`Request to start watching: ${P.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"})`).join(",")}`),g.length&&this.trace(`Request to stop watching: ${g.join(",")}`);for(const E of g)this.stopWatching(E);for(const E of P)this.startWatching(E)}startWatching(d){const C=new T.NodeJSFileWatcherLibrary(d,g=>this._onDidChangeFile.fire(g),g=>this._onDidLogMessage.fire(g),this.verboseLogging),P={request:d,instance:C};this.watchers.set(d.path,P)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const C=this.watchers.get(d);C&&(this.watchers.delete(d),C.instance.dispose())}normalizeRequests(d){const C=new Map;for(const P of d){const g=k.isLinux?P.path:P.path.toLowerCase();C.set(g,P)}return Array.from(C.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,C]of this.watchers)C.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,C){return C?`[File Watcher (node.js)] ${d} (path: ${C.request.path})`:`[File Watcher (node.js)] ${d}`}}i.NodeJSWatcher=p}),define(Z[107],ee([0,1,60,106]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class b extends D.AbstractNonRecursiveWatcherClient{constructor(T,p,a){super(T,p,a);this.init()}createWatcher(){return new I.NodeJSWatcher}}i.NodeJSWatcherClient=b}),define(Z[108],ee([0,1,16,56,82,60]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class T extends k.AbstractUniversalWatcherClient{constructor(a,d,C){super(a,d,C);this.init()}createWatcher(a){const d=a.add(new b.Client(D.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return a.add(d.onDidProcessExit(({code:C,signal:P})=>this.onError(`terminated by itself with code ${C}, signal: ${P}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(d.getChannel("watcher")))}}i.UniversalWatcherClient=T}),define(Z[61],ee([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...b){this._entries=new Map;for(const[k,T]of b)this.set(k,T)}set(b,k){const T=this._entries.get(b);return this._entries.set(b,k),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=D}),define(Z[109],ee([0,1,3,12,47,105,8,61]),function(B,i,D,I,b,k,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const a=!1;class d extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class C{constructor(l=new p.ServiceCollection,f=!1,v){this._activeInstantiations=new Set,this._services=l,this._strict=f,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(l){return new C(l,this._strict,this)}invokeFunction(l,...f){const v=g.traceInvocation(l);let u=!1;try{return l({get:y=>{if(u)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(y,v);if(!c)throw new Error(`[invokeFunction] unknown service '${y}'`);return c}},...f)}finally{u=!0,v.stop()}}createInstance(l,...f){let v,u;return l instanceof b.SyncDescriptor?(v=g.traceCreation(l.ctor),u=this._createInstance(l.ctor,l.staticArguments.concat(f),v)):(v=g.traceCreation(l),u=this._createInstance(l,f,v)),v.stop(),u}_createInstance(l,f=[],v){const u=T._util.getServiceDependencies(l).sort((c,s)=>c.index-s.index),h=[];for(const c of u){const s=this._getOrCreateServiceInstance(c.id,v);s||this._throwIfStrict(`[createInstance] ${l.name} depends on UNKNOWN service ${c.id}.`,!1),h.push(s)}const y=u.length>0?u[0].index:f.length;if(f.length!==y){console.trace(`[createInstance] First service dependency of ${l.name} at position ${y+1} conflicts with ${f.length} static arguments`);const c=y-f.length;c>0?f=f.concat(new Array(c)):f=f.slice(0,y)}return new l(...[...f,...h])}_setServiceInstance(l,f){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,f);else if(this._parent)this._parent._setServiceInstance(l,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){const f=this._services.get(l);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):f}_getOrCreateServiceInstance(l,f){const v=this._getServiceInstanceOrDescriptor(l);return v instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,v,f.branch(l,!0)):(f.branch(l,!1),v)}_safeCreateAndCacheServiceInstance(l,f,v){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,f,v)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,f,v){const u=new k.Graph(c=>c.id.toString());let h=0;const y=[{id:l,desc:f,_trace:v}];for(;y.length;){const c=y.pop();if(u.lookupOrInsertNode(c),h++>1e3)throw new d(u);for(const s of T._util.getServiceDependencies(c.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(s.id);if(t||this._throwIfStrict(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`,!0),t instanceof b.SyncDescriptor){const n={id:s.id,desc:t,_trace:c._trace.branch(s.id,!0)};u.insertEdge(c,n),y.push(n)}}}for(;;){const c=u.roots();if(c.length===0){if(!u.isEmpty())throw new d(u);break}for(const{data:s}of c){if(this._getServiceInstanceOrDescriptor(s.id)instanceof b.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}u.removeNode(s)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,f,v=[],u,h){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(f,v,u,h);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,f,v,u,h);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(l,f=[],v,u){if(v){const h=new D.IdleValue(()=>this._createInstance(l,f,u));return new Proxy(Object.create(null),{get(y,c){if(c in y)return y[c];const s=h.value;let t=s[c];return typeof t!="function"||(t=t.bind(s),y[c]=t),t},set(y,c,s){return h.value[c]=s,!0}})}else return this._createInstance(l,f,u)}_throwIfStrict(l,f){if(f&&console.warn(l),this._strict)throw new Error(l)}}i.InstantiationService=C;var P;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(P||(P={}));class g{constructor(l,f){this.type=l,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return a?new g(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(l){return a?new g(0,l.name):g._None}branch(l,f){const v=new g(2,l.toString());return this._dep.push([l,f,v]),v}stop(){const l=Date.now()-this._start;g._totals+=l;let f=!1;function v(h,y){const c=[],s=new Array(h+1).join("	");for(const[t,n,e]of y._dep)if(n&&e){f=!0,c.push(`${s}CREATES -> ${t}`);const r=v(h+1,e);r&&c.push(r)}else c.push(`${s}uses -> ${t}`);return c.join(`
`)}const u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(l>2||f)&&console.log(u.join(`
`))}}i.Trace=g,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0});var te=this&&this.__param||function(B,i){return function(D,I){i(D,I,B)}};define(Z[62],ee([0,1,25,2,13,95,22,8]),function(B,i,D,I,b,k,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LanguagePackBaseService=i.ILanguagePackService=void 0,i.ILanguagePackService=(0,p.createDecorator)("languagePackService");let a=class extends I.Disposable{constructor(C){super();this.extensionGalleryService=C}async getAvailableLanguages(){const C=new D.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let P;try{P=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const E=P.firstPage.filter(l=>l.properties.localizedLanguages?.length&&l.tags.some(f=>f.startsWith("lp-"))).map(l=>{const f=l.properties.localizedLanguages?.[0],v=this.getLocale(l);return{...this.createQuickPickItem({locale:v,label:f}),extensionId:l.identifier.id,galleryExtension:l}});return E.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),E}getLocale(C){return C.tags.find(P=>P.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(C){const P=C.label??C.locale;let g=C.locale!==C.label?C.locale:void 0;return C.locale.toLowerCase()===b.language.toLowerCase()&&(g||(g=""),g+=(0,k.localize)(0,null)),{id:C.locale,label:P,description:g}}};a=fe([te(0,T.IExtensionGalleryService)],a),i.LanguagePackBaseService=a}),define(Z[9],ee([0,1,30,4,2,13,8]),function(B,i,D,I,b,k,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,T.createDecorator)("logService"),i.ILoggerService=(0,T.createDecorator)("loggerService");function p(){return new Date().toISOString()}var a;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(a=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=a.Info;function d(n,e,r){switch(e){case a.Trace:n.trace(r);break;case a.Debug:n.debug(r);break;case a.Info:n.info(r);break;case a.Warning:n.warn(r);break;case a.Error:n.error(r);break;case a.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}i.log=d;function C(n){let e="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}e+=(r>0?" ":"")+o}return e}i.format=C;class P extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=P;class g extends P{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...r){this.checkLogLevel(a.Trace)&&this.log(a.Trace,C([e,...r]))}debug(e,...r){this.checkLogLevel(a.Debug)&&this.log(a.Debug,C([e,...r]))}info(e,...r){this.checkLogLevel(a.Info)&&this.log(a.Info,C([e,...r]))}warn(e,...r){this.checkLogLevel(a.Warning)&&this.log(a.Warning,C([e,...r]))}error(e,...r){if(this.checkLogLevel(a.Error))if(e instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=e.stack,this.log(a.Error,C(o))}else this.log(a.Error,C([e,...r]))}critical(e,...r){this.checkLogLevel(a.Critical)&&this.log(a.Critical,C([e,...r]))}flush(){}}i.AbstractMessageLogger=g;class E extends P{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!k.isWindows}trace(e,...r){this.getLevel()<=a.Trace&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}debug(e,...r){this.getLevel()<=a.Debug&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}info(e,...r){this.getLevel()<=a.Info&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}warn(e,...r){this.getLevel()<=a.Warning&&(this.useColors?console.warn(`[93m[main ${p()}][0m`,e,...r):console.warn(`[main ${p()}]`,e,...r))}error(e,...r){this.getLevel()<=a.Error&&(this.useColors?console.error(`[91m[main ${p()}][0m`,e,...r):console.error(`[main ${p()}]`,e,...r))}critical(e,...r){this.getLevel()<=a.Critical&&(this.useColors?console.error(`[90m[main ${p()}][0m`,e,...r):console.error(`[main ${p()}]`,e,...r))}dispose(){}flush(){}}i.ConsoleMainLogger=E;class l extends P{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...r){this.getLevel()<=a.Trace&&console.log("%cTRACE","color: #888",e,...r)}debug(e,...r){this.getLevel()<=a.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...r)}info(e,...r){this.getLevel()<=a.Info&&console.log("%c INFO","color: #33f",e,...r)}warn(e,...r){this.getLevel()<=a.Warning&&console.log("%c WARN","color: #993",e,...r)}error(e,...r){this.getLevel()<=a.Error&&console.log("%c  ERR","color: #f33",e,...r)}critical(e,...r){this.getLevel()<=a.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...r)}dispose(){}flush(){}}i.ConsoleLogger=l;class f extends P{constructor(e,r=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(r)}trace(e,...r){this.getLevel()<=a.Trace&&this.adapter.log(a.Trace,[this.extractMessage(e),...r])}debug(e,...r){this.getLevel()<=a.Debug&&this.adapter.log(a.Debug,[this.extractMessage(e),...r])}info(e,...r){this.getLevel()<=a.Info&&this.adapter.log(a.Info,[this.extractMessage(e),...r])}warn(e,...r){this.getLevel()<=a.Warning&&this.adapter.log(a.Warning,[this.extractMessage(e),...r])}error(e,...r){this.getLevel()<=a.Error&&this.adapter.log(a.Error,[this.extractMessage(e),...r])}critical(e,...r){this.getLevel()<=a.Critical&&this.adapter.log(a.Critical,[this.extractMessage(e),...r])}extractMessage(e){return typeof e=="string"?e:(0,D.toErrorMessage)(e,this.getLevel()<=a.Trace)}dispose(){}flush(){}}i.AdapterLogger=f;class v extends P{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const r of this.logServices)r.setLevel(e);super.setLevel(e)}trace(e,...r){for(const o of this.logServices)o.trace(e,...r)}debug(e,...r){for(const o of this.logServices)o.debug(e,...r)}info(e,...r){for(const o of this.logServices)o.info(e,...r)}warn(e,...r){for(const o of this.logServices)o.warn(e,...r)}error(e,...r){for(const o of this.logServices)o.error(e,...r)}critical(e,...r){for(const o of this.logServices)o.critical(e,...r)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=v;class u extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...r){this.logger.trace(e,...r)}debug(e,...r){this.logger.debug(e,...r)}info(e,...r){this.logger.info(e,...r)}warn(e,...r){this.logger.warn(e,...r)}error(e,...r){this.logger.error(e,...r)}critical(e,...r){this.logger.critical(e,...r)}flush(){this.logger.flush()}}i.LogService=u;class h extends b.Disposable{constructor(e,r){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(m=>m.setLevel(o))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,r){let o=this.loggers.get(e.toString());return o||(o=this.doCreateLogger(e,r?.always?a.Trace:this.logLevel,r),this.loggers.set(e.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=h;class y{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return a.Info}trace(e,...r){}debug(e,...r){}info(e,...r){}warn(e,...r){}error(e,...r){}critical(e,...r){}dispose(){}flush(){}}i.NullLogService=y;function c(n){if(n.verbose)return a.Trace;if(typeof n.logLevel=="string"){const e=s(n.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=c;function s(n){switch(n){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Critical;case"off":return a.Off}}i.parseLogLevel=s;function t(n){switch(n){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Critical:return"critical";case a.Off:return"off"}}i.LogLevelToString=t}),define(Z[110],ee([0,1,19,3,12,4,2,14,60,9]),function(B,i,D,I,b,k,T,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class C extends T.Disposable{constructor(g,E){super();this.logService=g,this.options=E,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new I.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(g,E){return E.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(g,E):this.watchNonRecursive(g,E)}watchUniversal(g,E){const l={path:this.toFilePath(g),excludes:E.excludes,includes:E.includes,recursive:E.recursive},f=(0,D.insert)(this.universalPathsToWatch,l);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{f(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(g=>(0,b.onUnexpectedError)(g))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(E=>this._onDidChangeFile.fire((0,a.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const g=this.options?.watcher?.recursive?.usePolling;if(g===!0)for(const E of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(E)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const E of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(E)&&g.includes(E.path)&&(E.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(g,E){const l={path:this.toFilePath(g),excludes:E.excludes,includes:E.includes,recursive:!1},f=(0,D.insert)(this.nonRecursivePathsToWatch,l);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{f(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(g=>(0,b.onUnexpectedError)(g))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(g=>this._onDidChangeFile.fire((0,a.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,p.normalize)(g.fsPath)}}i.AbstractDiskFileSystemProvider=C}),define(Z[111],ee([0,1,19,3,15,25,4,54,63,2,36,16,112,18,42,92,11,59,9]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f,v,u,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let y=class extends d.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${s}`);const n=new d.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new v.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,d.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){t.push(n)}}),!this.provider.has(s)&&await I.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return a.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,E.isAbsolutePath)(s))throw new v.FileOperationError((0,f.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const n=new Error;throw n.name="ENOPRO",n.message=(0,f.localize)(1,null,s.toString()),n}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)||(0,v.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(n){throw(0,v.toFileSystemProviderErrorCode)(n)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,f.localize)(2,null,this.resourceForError(s)),1):(0,v.ensureFileSystemProviderError)(n)}}async doResolveFile(s,t){const n=await this.withProvider(s),e=this.isPathCaseSensitive(n),r=t?.resolveTo,o=t?.resolveSingleChildDescendants,m=t?.resolveMetadata,S=await n.stat(s);let w;return this.toFileStat(n,s,S,void 0,!!m,(L,U)=>(w||(w=C.TernarySearchTree.forUris(()=>!e),w.set(s,!0),r&&w.fill(!0,r)),w.get(L.resource)||w.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&o?U===1:!1))}async toFileStat(s,t,n,e,r,o){const{providerExtUri:m}=this.getExtUri(s),S={resource:t,name:m.basename(t),isFile:(n.type&v.FileType.File)!=0,isDirectory:(n.type&v.FileType.Directory)!=0,isSymbolicLink:(n.type&v.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&v.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,v.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(S.isDirectory&&o(S,e)){try{const w=await s.readdir(t),L=await I.Promises.settled(w.map(async([U,$])=>{try{const q=m.joinPath(t,U),Y=r?await s.stat(q):{type:$};return await this.toFileStat(s,q,Y,w.length,r,o)}catch(q){return this.logService.trace(q),null}}));S.children=(0,D.coalesce)(L)}catch(w){this.logService.trace(w),S.children=[]}return S}return S}async resolveAll(s){return I.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),n=await t.stat(s);return this.toFileStat(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(n){return n}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new v.FileOperationError((0,f.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=b.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const e=await this.writeFile(s,t);return this._onDidRunOperation.fire(new v.FileOperationEvent(s,0,e)),e}async writeFile(s,t,n){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(e);try{await this.validateWriteFile(e,s,n)||await this.mkdirp(e,r.dirname(s));let m;if((0,v.hasReadWriteCapability)(e)&&!(t instanceof b.VSBuffer))if((0,l.isReadableStream)(t)){const S=await(0,l.peekStream)(t,3);S.ended?m=b.VSBuffer.concat(S.buffer):m=S}else m=(0,l.peekReadable)(t,S=>b.VSBuffer.concat(S),3);else m=t;!(0,v.hasOpenReadWriteCloseCapability)(e)||(0,v.hasReadWriteCapability)(e)&&m instanceof b.VSBuffer?await this.doWriteUnbuffered(e,s,n,m):await this.doWriteBuffered(e,s,n,m instanceof b.VSBuffer?(0,b.bufferToReadable)(m):m),this._onDidRunOperation.fire(new v.FileOperationEvent(s,4))}catch(o){throw new v.FileOperationError((0,f.localize)(4,null,this.resourceForError(s),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,f.localize)(5,null,this.resourceForError(t)));let r;try{r=await s.stat(t)}catch{return}if((r.type&v.FileType.Directory)!=0)throw new v.FileOperationError((0,f.localize)(6,null,this.resourceForError(t)),0,n);if(this.throwIfFileIsReadonly(t,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==v.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,v.etag)({mtime:n.mtime,size:r.size}))throw new v.FileOperationError((0,f.localize)(7,null),3,n);return r}async readFile(s,t,n){const e=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(e,s,t,n):this.doReadFile(e,s,t,n)}async doReadFileAtomic(s,t,n,e){return new Promise((r,o)=>{this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{try{const m=await this.doReadFile(s,t,n,e);r(m)}catch(m){o(m)}})})}async doReadFile(s,t,n,e){const r=await this.doReadFileStream(s,t,{...n,preferUnbuffered:!0},e);return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(s,t,n){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,t,n)}async doReadFileStream(s,t,n,e){const r=new k.CancellationTokenSource(e),o=this.validateReadFile(t,n).then(S=>S,S=>{throw r.cancel(),S});let m;try{return typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&await o,n?.atomic&&(0,v.hasFileAtomicReadCapability)(s)||!((0,v.hasOpenReadWriteCloseCapability)(s)||(0,v.hasFileReadStreamCapability)(s))||(0,v.hasReadWriteCapability)(s)&&n?.preferUnbuffered?m=this.readFileUnbuffered(s,t,n):(0,v.hasFileReadStreamCapability)(s)?m=this.readFileStreamed(s,t,r.token,n):m=this.readFileBuffered(s,t,r.token,n),{...await o,value:m}}catch(S){m&&await(0,l.consumeStream)(m);const w=(0,f.localize)(8,null,this.resourceForError(t),(0,v.ensureFileSystemProviderError)(S).toString());throw S instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(w,S.stat,n):new v.FileOperationError(w,(0,v.toFileOperationResult)(S),n)}}readFileStreamed(s,t,n,e=Object.create(null)){const r=s.readFileStream(t,e,n);return(0,l.transform)(r,{data:o=>o instanceof b.VSBuffer?o:b.VSBuffer.wrap(o),error:o=>new v.FileOperationError((0,f.localize)(9,null,this.resourceForError(t),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),e)},o=>b.VSBuffer.concat(o))}readFileBuffered(s,t,n,e=Object.create(null)){const r=(0,b.newWriteableBufferStream)();return(0,u.readFileIntoStream)(s,t,r,o=>o,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new v.FileOperationError((0,f.localize)(10,null,this.resourceForError(t),(0,v.ensureFileSystemProviderError)(o).toString()),(0,v.toFileOperationResult)(o),e)},n),r}readFileUnbuffered(s,t,n){const e=(0,l.newWriteableStream)(r=>b.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,v.hasFileAtomicReadCapability)(s)?r=await s.readFile(t,{atomic:!0}):r=await s.readFile(t),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(t,r.byteLength,n),e.end(b.VSBuffer.wrap(r))}catch(r){e.error(r),e.end()}})(),e}async validateReadFile(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new v.FileOperationError((0,f.localize)(11,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==v.ETAG_DISABLED&&t.etag===n.etag)throw new v.NotModifiedSinceFileOperationError((0,f.localize)(12,null),n,t);return this.validateReadFileLimits(s,n.size,t),n}validateReadFileLimits(s,t,n){if(n?.limits){let e;if(typeof n.limits.memory=="number"&&t>n.limits.memory&&(e=9),typeof n.limits.size=="number"&&t>n.limits.size&&(e=7),typeof e=="number")throw new v.FileOperationError((0,f.localize)(13,null,this.resourceForError(s)),e)}}async canMove(s,t,n){return this.doCanMoveCopy(s,t,"move",n)}async canCopy(s,t,n){return this.doCanMoveCopy(s,t,"copy",n)}async doCanMoveCopy(s,t,n,e){if(s.toString()!==t.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(r,s,o,t,n,e)}catch(r){return r}return!0}async move(s,t,n){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(e,s,r,t,"move",!!n),m=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,o==="move"?2:3,m)),m}async copy(s,t,n){const e=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(e,s,r,t,"copy",!!n),m=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,o==="copy"?3:2,m)),m}async doMoveCopy(s,t,n,e,r,o){if(t.toString()===e.toString())return r;const{exists:m,isSameResourceWithDifferentPathCase:S}=await this.doValidateMoveCopy(s,t,n,e,r,o);if(m&&!S&&o&&await this.del(e,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(e)),r==="copy"){if(s===n&&(0,v.hasFileFolderCopyCapability)(s))await s.copy(t,e,{overwrite:o});else{const w=await this.resolve(t);w.isDirectory?await this.doCopyFolder(s,w,n,e):await this.doCopyFile(s,t,n,e)}return r}else return s===n?(await s.rename(t,e,{overwrite:o}),r):(await this.doMoveCopy(s,t,n,e,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,n,e){if((0,v.hasOpenReadWriteCloseCapability)(s)&&(0,v.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,t,n,e);if((0,v.hasOpenReadWriteCloseCapability)(s)&&(0,v.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,t,n,e);if((0,v.hasReadWriteCapability)(s)&&(0,v.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,t,n,e);if((0,v.hasReadWriteCapability)(s)&&(0,v.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,t,n,e)}async doCopyFolder(s,t,n,e){await n.mkdir(e),Array.isArray(t.children)&&await I.Promises.settled(t.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(e,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,t,n,e,r,o){let m=!1;if(s===n){const{providerExtUri:w,isPathCaseSensitive:L}=this.getExtUri(s);if(L||(m=w.isEqual(t,e)),m&&r==="copy")throw new Error((0,f.localize)(14,null,this.resourceForError(t),this.resourceForError(e)));if(!m&&w.isEqualOrParent(e,t))throw new Error((0,f.localize)(15,null,this.resourceForError(t),this.resourceForError(e)))}const S=await this.exists(e);if(S&&!m){if(!o)throw new v.FileOperationError((0,f.localize)(16,null,this.resourceForError(t),this.resourceForError(e)),4);if(s===n){const{providerExtUri:w}=this.getExtUri(s);if(w.isEqualOrParent(t,e))throw new Error((0,f.localize)(17,null,this.resourceForError(t),this.resourceForError(e)))}}return{exists:S,isSameResourceWithDifferentPathCase:m}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new v.FileOperationEvent(s,0,n)),n}async mkdirp(s,t){const n=[],{providerExtUri:e}=this.getExtUri(s);for(;!e.isEqual(t,e.dirname(t));)try{if(((await s.stat(t)).type&v.FileType.Directory)==0)throw new Error((0,f.localize)(18,null,this.resourceForError(t)));break}catch(r){if((0,v.toFileSystemProviderErrorCode)(r)!==v.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(e.basename(t)),t=e.dirname(t)}for(let r=n.length-1;r>=0;r--){t=e.joinPath(t,n[r]);try{await s.mkdir(t)}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(n){return n}return!0}async doValidateDelete(s,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!t?.useTrash&&!(n.capabilities&4096))throw new Error((0,f.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new v.FileOperationError((0,f.localize)(20,null,this.resourceForError(s)),1);if(!!!t?.recursive){const m=await this.resolve(s);if(m.isDirectory&&Array.isArray(m.children)&&m.children.length>0)throw new Error((0,f.localize)(21,null,this.resourceForError(s)))}return n}async del(s,t){const n=await this.doValidateDelete(s,t),e=!!t?.useTrash,r=!!t?.recursive;await n.delete(s,{recursive:r,useTrash:e}),this._onDidRunOperation.fire(new v.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.withProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(n===e&&this.getExtUri(n).providerExtUri.isEqual(s,t))return;if(n===e&&(0,v.hasFileCloneCapability)(n))return n.cloneFile(s,t);await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(t));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===e&&(0,v.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,t,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,e,t))}watch(s,t={recursive:!1,excludes:[]}){const n=new d.DisposableStore;let e=!1,r=()=>{e=!0};return n.add((0,d.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,t);e?(0,d.dispose)(o):r=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,t){const n=await this.withProvider(s),e=(0,p.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),t]);let r=this.activeWatchers.get(e);return r||(r={count:0,disposable:n.watch(s,t)},this.activeWatchers.set(e,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,n,e){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,l.isReadableStream)(e)||(0,l.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(s,r,e):await this.doWriteReadableBufferedQueued(s,r,e)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,t,n){let e=0,r;if((0,l.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=b.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,t,o,o.byteLength,e,0),e+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,m)=>{(0,l.listenStream)(r,{onData:async S=>{r.pause();try{await this.doWriteBuffer(s,t,S,S.byteLength,e,0)}catch(w){return m(w)}e+=S.byteLength,setTimeout(()=>r.resume())},onError:S=>m(S),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,t,n){let e=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,t,r,r.byteLength,e,0),e+=r.byteLength}async doWriteBuffer(s,t,n,e,r,o){let m=0;for(;m<e;)m+=await s.write(t,r+m,n.buffer,o+m,e-m)}async doWriteUnbuffered(s,t,n,e){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,t,n,e))}async doWriteUnbufferedQueued(s,t,n,e){let r;e instanceof b.VSBuffer?r=e:(0,l.isReadableStream)(e)?r=await(0,b.streamToBuffer)(e):(0,l.isReadableBufferedStream)(e)?r=await(0,b.bufferedStreamToBuffer)(e):r=(0,b.readableToBuffer)(e),await s.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,t,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,t,n,e))}async doPipeBufferedQueued(s,t,n,e){let r,o;try{r=await s.open(t,{create:!1}),o=await n.open(e,{create:!0,unlock:!1});const m=b.VSBuffer.alloc(this.BUFFER_SIZE);let S=0,w=0,L=0;do L=await s.read(r,S,m.buffer,w,m.byteLength-w),await this.doWriteBuffer(n,o,m,L,S,w),S+=L,w+=L,w===m.byteLength&&(w=0);while(L>0)}catch(m){throw(0,v.ensureFileSystemProviderError)(m)}finally{await I.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,t,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,t,n,e))}async doPipeUnbufferedQueued(s,t,n,e){return n.writeFile(e,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,t,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,t,n,e))}async doPipeUnbufferedToBufferedQueued(s,t,n,e){const r=await n.open(e,{create:!0,unlock:!1});try{const o=await s.readFile(t);await this.doWriteBuffer(n,r,b.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,v.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,t,n,e){const r=await(0,b.streamToBuffer)(this.readFileBuffered(s,t,k.CancellationToken.None));await this.doWriteUnbuffered(n,e,void 0,r)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new v.FileOperationError((0,f.localize)(22,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,f.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===P.Schemas.file?s.fsPath:s.toString(!0)}};y=fe([te(0,h.ILogService)],y),i.FileService=y}),define(Z[113],ee([0,1,114,153,3,36,15,4,80,2,14,13,18,42,20,94,11,59,110,30,108,107]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f,v,u,h,y,c,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,y.toErrorMessage)(n)}`)}})();class t extends h.AbstractDiskFileSystemProvider{constructor(e,r){super(e,r);this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new k.ResourceMap(o=>g.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:r,symbolicLink:o}=await l.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(e){try{const r=await l.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async m=>{try{let S;m.isSymbolicLink()?S=(await this.stat((0,g.joinPath)(e,m.name))).type:S=this.toType(m),o.push([m.name,S])}catch(S){this.logService.trace(S)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(e,r){let o;return r?.dangling?o=v.FileType.Unknown:e.isFile()?o=v.FileType.File:e.isDirectory()?o=v.FileType.Directory:o=v.FileType.Unknown,r&&(o|=v.FileType.SymbolicLink),o}async createResourceLock(e){const r=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const m=new b.Barrier;return this.resourceLocks.set(e,m),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(e)===m&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),m.open()})}async readFile(e,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),o=await this.createResourceLock(e));const m=this.toFilePath(e);return await l.Promises.readFile(m)}catch(m){throw this.toFileSystemProviderError(m)}finally{o?.dispose()}}readFileStream(e,r,o){const m=(0,E.newWriteableStream)(S=>T.VSBuffer.concat(S.map(w=>T.VSBuffer.wrap(w))).buffer);return(0,u.readFileIntoStream)(this,e,m,S=>S.buffer,{...r,bufferSize:256*1024},o),m}async writeFile(e,r,o){let m;try{const S=this.toFilePath(e);if(!o.create||!o.overwrite){if(await l.Promises.exists(S)){if(!o.overwrite)throw(0,v.createFileSystemProviderError)((0,f.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,v.createFileSystemProviderError)((0,f.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(e,{create:!0,unlock:o.unlock}),await this.write(m,0,r,0,r.byteLength)}catch(S){throw await this.toFileSystemProviderWriteError(e,S)}finally{typeof m=="number"&&await this.close(m)}}static configureFlushOnWrite(e){t.canFlush=e}async open(e,r){const o=this.toFilePath(e);let m;(0,v.isFileOpenForWriteOptions)(r)&&(m=await this.createResourceLock(e));let S;try{if((0,v.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:L}=await l.SymlinkSupport.stat(o);L.mode&128||await l.Promises.chmod(o,L.mode|128)}catch(L){this.logService.trace(L)}let w;if((0,v.isFileOpenForWriteOptions)(r)){if(P.isWindows)try{await l.Promises.truncate(o,0),w="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}w||(w="w")}else w="r";S=await l.Promises.open(o,w)}catch(w){throw m?.dispose(),(0,v.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(e,w):this.toFileSystemProviderError(w)}if(this.mapHandleToPos.set(S,0),(0,v.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(S,e),m){const w=this.mapHandleToLock.get(S);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.mapHandleToLock.set(S,m),w&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),w.dispose())}return S}async close(e){const r=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&t.canFlush)try{await l.Promises.fdatasync(e)}catch(o){t.configureFlushOnWrite(!1),this.logService.error(o)}return await l.Promises.close(e)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(e)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),r.dispose())}}async read(e,r,o,m,S){const w=this.normalizePos(e,r);let L=null;try{L=(await l.Promises.read(e,o,m,S,w)).bytesRead}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(e,w,L)}return L}normalizePos(e,r){return r===this.mapHandleToPos.get(e)?null:r}updatePos(e,r,o){const m=this.mapHandleToPos.get(e);typeof m=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(e,m+o):this.mapHandleToPos.delete(e)))}async write(e,r,o,m,S){return(0,b.retry)(()=>this.doWrite(e,r,o,m,S),100,3)}async doWrite(e,r,o,m,S){const w=this.normalizePos(e,r);let L=null;try{L=(await l.Promises.write(e,o,m,S,w)).bytesWritten}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),U)}finally{this.updatePos(e,w,L)}return L}async mkdir(e){try{await l.Promises.mkdir(this.toFilePath(e))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(e,r){try{const o=this.toFilePath(e);r.recursive?await l.Promises.rm(o,l.RimRafMode.MOVE):await l.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(e,r,o){const m=this.toFilePath(e),S=this.toFilePath(r);if(m!==S)try{await this.validateTargetDeleted(e,r,"move",o.overwrite),await l.Promises.move(m,S)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,f.localize)(2,null,(0,C.basename)(m),(0,C.basename)((0,C.dirname)(S)),w.toString()))),this.toFileSystemProviderError(w)}}async copy(e,r,o){const m=this.toFilePath(e),S=this.toFilePath(r);if(m!==S)try{await this.validateTargetDeleted(e,r,"copy",o.overwrite),await l.Promises.copy(m,S,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,f.localize)(3,null,(0,C.basename)(m),(0,C.basename)((0,C.dirname)(S)),w.toString()))),this.toFileSystemProviderError(w)}}async validateTargetDeleted(e,r,o,m){const S=this.toFilePath(e),w=this.toFilePath(r);let L=!1;if(!!(this.capabilities&1024)||(L=(0,a.isEqual)(S,w,!0)),L&&o==="copy")throw(0,v.createFileSystemProviderError)((0,f.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!L&&await l.Promises.exists(w)){if(!m)throw(0,v.createFileSystemProviderError)((0,f.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(e,r){return this.doCloneFile(e,r,!1)}async doCloneFile(e,r,o){const m=this.toFilePath(e),S=this.toFilePath(r),w=!!(this.capabilities&1024);if((0,a.isEqual)(m,S,!w))return;const L=new d.DisposableStore;try{const[U,$]=await Promise.all([this.createResourceLock(e),this.createResourceLock(r)]);L.add(U),L.add($),o&&await l.Promises.mkdir((0,C.dirname)(S),{recursive:!0}),await l.Promises.copyFile(m,S)}catch(U){if(U.code==="ENOENT"&&!o)return this.doCloneFile(e,r,!0);throw this.toFileSystemProviderError(U)}finally{L.dispose()}}createUniversalWatcher(e,r,o){return new c.UniversalWatcherClient(m=>e(m),m=>r(m),o)}createNonRecursiveWatcher(e,r,o){return new s.NodeJSWatcherClient(m=>e(m),m=>r(m),o)}toFileSystemProviderError(e){if(e instanceof v.FileSystemProviderError)return e;let r;switch(e.code){case"ENOENT":r=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=v.FileSystemProviderErrorCode.NoPermissions;break;default:r=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(e,r)}async toFileSystemProviderWriteError(e,r){let o=this.toFileSystemProviderError(r);if(e&&o.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:m}=await l.SymlinkSupport.stat(this.toFilePath(e));m.mode&128||(o=(0,v.createFileSystemProviderError)(r,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(m){this.logService.trace(m)}return o}}i.DiskFileSystemProvider=t,t.canFlush=!0}),define(Z[115],ee([0,1,11,9]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(p,a,d,C,P){try{const g=await new Promise((l,f)=>{B(["spdlog"],l,f)});g.setFlushOn(I.LogLevel.Trace);const E=await g.createAsyncRotatingLogger(p,a,d,C);return P&&E.clearFormatters(),E}catch(g){console.error(g)}return null}function k(p,a,d){switch(a){case I.LogLevel.Trace:p.trace(d);break;case I.LogLevel.Debug:p.debug(d);break;case I.LogLevel.Info:p.info(d);break;case I.LogLevel.Warning:p.warn(d);break;case I.LogLevel.Error:p.error(d);break;case I.LogLevel.Critical:p.critical(d);break;default:throw new Error("Invalid log level")}}class T extends I.AbstractMessageLogger{constructor(a,d,C,P,g){super();this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(a,d,C,P),this._register(this.onDidChangeLogLevel(E=>{this._logger?.setLevel(E)}))}async _createSpdLogLogger(a,d,C,P){const g=C?6:1,E=30/g*D.ByteSize.MB,l=await b(a,d,E,g,P);if(l){this._logger=l,this._logger.setLevel(this.getLevel());for(const{level:f,message:v}of this.buffer)k(this._logger,f,v);this.buffer=[]}}log(a,d){this._logger?k(this._logger,a,d):this.getLevel()<=a&&this.buffer.push({level:a,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=T}),define(Z[37],ee([0,1,4,63,2,8]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NullPolicyService=i.AbstractPolicyService=i.IPolicyService=void 0,i.IPolicyService=(0,k.createDecorator)("policy");class T extends b.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),I.Iterable.reduce(this.policies.entries(),(P,[g,E])=>({...P,[g]:E}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return I.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[C,P])=>({...d,[C]:{definition:P,value:this.policies.get(C)}}),{})}}i.AbstractPolicyService=T;class p{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}i.NullPolicyService=p}),define(Z[116],ee([0,1,3,4,63,7,11,9,37]),function(B,i,D,I,b,k,T,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FilePolicyService=void 0;function d(P,g){const E=[];for(const l of b.Iterable.concat(P.keys(),g.keys()))P.get(l)!==g.get(l)&&E.push(l);return E}let C=class extends a.AbstractPolicyService{constructor(g,E,l){super();this.file=g,this.fileService=E,this.logService=l,this.throttledDelayer=this._register(new D.ThrottledDelayer(500));const f=I.Event.filter(E.onDidFilesChange,v=>v.affects(g));this._register(E.watch(g)),this._register(f(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(g){await this.refresh()}async read(){const g=new Map;try{const E=await this.fileService.readFile(this.file),l=JSON.parse(E.value.toString());if(!(0,k.isObject)(l))throw new Error("Policy file isn't a JSON object");for(const f of Object.keys(l))this.policyDefinitions[f]&&g.set(f,l[f])}catch(E){E.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",E)}return g}async refresh(){const g=await this.read(),E=d(this.policies,g);this.policies=g,E.length>0&&this._onDidChange.fire(E)}};C=fe([te(1,T.IFileService),te(2,p.ILogService)],C),i.FilePolicyService=C}),define(Z[27],ee([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Z[32],ee([0,1,68,7]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(T,p){D.ok(I.isString(T)),D.ok(I.isObject(p)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,p)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}i.Registry=new b}),define(Z[117],ee([0,1,4,32]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class k{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(a,d){this.schemasById[b(a)]=d,this._onDidChangeSchema.fire(a)}notifySchemaChanged(a){this._onDidChangeSchema.fire(a)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new k;I.Registry.add(i.Extensions.JSONContribution,T)}),define(Z[39],ee([0,1,19,4,7,84,21,117,32]),function(B,i,D,I,b,k,T,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var C;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=a.Registry.as(p.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const e=this.doRegisterConfigurations(t,n);P.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}deregisterConfigurations(t){const n=this.doDeregisterConfigurations(t);P.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:t,remove:n}){const e=[];e.push(...this.doDeregisterConfigurations(n)),e.push(...this.doRegisterConfigurations(t,!1)),P.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(e)})}registerDefaultConfigurations(t){const n=[],e=[];for(const{overrides:r,source:o}of t)for(const m in r)if(n.push(m),i.OVERRIDE_PROPERTY_REGEX.test(m)){const S=this.configurationDefaultsOverrides.get(m),w=S?.valuesSources??new Map;if(o)for(const q of Object.keys(r[m]))w.set(q,o);const L={...S?.value||{},...r[m]};this.configurationDefaultsOverrides.set(m,{source:o,value:L,valuesSources:w});const U=(0,T.getLanguageTagSettingPlainKey)(m),$={type:"object",default:L,description:k.localize(1,null,U),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:L,source:b.isString(o)?void 0:o,defaultValueSource:o};e.push(...f(m)),this.configurationProperties[m]=$,this.defaultLanguageConfigurationOverridesNode.properties[m]=$}else{this.configurationDefaultsOverrides.set(m,{value:r[m],source:o});const S=this.configurationProperties[m];S&&(this.updatePropertyDefaultValue(m,S),this.updateSchema(m,S))}this.registerOverrideIdentifiers(e),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const n=[];for(const{overrides:e,source:r}of t)for(const o in e){const m=this.configurationDefaultsOverrides.get(o),S=b.isString(r)?r:r?.id,w=b.isString(m?.source)?m?.source:m?.source?.id;if(S===w)if(n.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const L=this.configurationProperties[o];L&&(this.updatePropertyDefaultValue(o,L),this.updateSchema(o,L))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const n of t)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,n){const e=[];return t.forEach(r=>{e.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),e}doDeregisterConfigurations(t){const n=[],e=r=>{if(r.properties)for(const o in r.properties){n.push(o);const m=this.configurationProperties[o];m?.policy?.name&&this.policyConfigurations.delete(m.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>e(o))};for(const r of t){e(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(t,n=!0,e,r,o=3){o=b.isUndefinedOrNull(t.scope)?o:t.scope;const m=[],S=t.properties;if(S)for(const L in S){const U=S[L];if(n&&y(L,U)){delete S[L];continue}if(U.source=e,U.defaultDefaultValue=S[L].default,this.updatePropertyDefaultValue(L,U),i.OVERRIDE_PROPERTY_REGEX.test(L)?U.scope=void 0:(U.scope=b.isUndefinedOrNull(U.scope)?o:U.scope,U.restricted=b.isUndefinedOrNull(U.restricted)?!!r?.includes(L):U.restricted),S[L].hasOwnProperty("included")&&!S[L].included){this.excludedConfigurationProperties[L]=S[L],delete S[L];continue}else this.configurationProperties[L]=S[L],S[L].policy?.name&&this.policyConfigurations.set(S[L].policy.name,L);!S[L].deprecationMessage&&S[L].markdownDeprecationMessage&&(S[L].deprecationMessage=S[L].markdownDeprecationMessage),m.push(L)}const w=t.allOf;if(w)for(const L of w)m.push(...this.validateAndRegisterProperties(L,n,e,r,o));return m}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const n=e=>{const r=e.properties;if(r)for(const m in r)this.updateSchema(m,r[m]);e.allOf?.forEach(n)};n(t)}updateSchema(t,n){switch(i.allSettings.properties[t]=n,n.scope){case 1:i.applicationSettings.properties[t]=n;break;case 2:i.machineSettings.properties[t]=n;break;case 6:i.machineOverridableSettings.properties[t]=n;break;case 3:i.windowSettings.properties[t]=n;break;case 4:i.resourceSettings.properties[t]=n;break;case 5:i.resourceSettings.properties[t]=n,this.resourceLanguageSettingsSchema.properties[t]=n;break}}removeFromSchema(t,n){switch(delete i.allSettings.properties[t],n.scope){case 1:delete i.applicationSettings.properties[t];break;case 2:delete i.machineSettings.properties[t];break;case 6:delete i.machineOverridableSettings.properties[t];break;case 3:delete i.windowSettings.properties[t];break;case 4:case 5:delete i.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const n=`[${t}]`,e={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,e),i.allSettings.properties[n]=e,i.applicationSettings.properties[n]=e,i.machineSettings.properties[n]=e,i.machineOverridableSettings.properties[n]=e,i.windowSettings.properties[n]=e,i.resourceSettings.properties[n]=e}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,n){const e=this.configurationDefaultsOverrides.get(t);let r=e?.value,o=e?.source;b.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),b.isUndefined(r)&&(r=u(n.type)),n.default=r,n.defaultValueSource=o}}const E="\\[([^\\]]+)\\]",l=new RegExp(E,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function f(s){const t=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let n=l.exec(s);for(;n?.length;){const e=n[1].trim();e&&t.push(e),n=l.exec(s)}}return(0,D.distinct)(t)}i.overrideIdentifiersFromKey=f;function v(s){return s.reduce((t,n)=>`${t}[${n}]`,"")}i.keyFromOverrideIdentifiers=v;function u(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=u;const h=new g;a.Registry.add(i.Extensions.Configuration,h);function y(s,t){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?k.localize(7,null,s):h.getConfigurationProperties()[s]!==void 0?k.localize(8,null,s):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,s,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}i.validateProperty=y;function c(){const s=[],t=h.getConfigurationProperties();for(const n of Object.keys(t))s.push([n,t[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=c}),define(Z[64],ee([0,1,19,4,51,2,36,24,7,10,21,39,32]),function(B,i,D,I,b,k,T,p,a,d,C,P,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.ConfigurationModel=void 0;class E{constructor(n={},e=[],r=[]){this._contents=n,this._keys=e,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,C.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,e){const r=this.getContentsForOverrideIdentifer(e);return r?n?(0,C.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const e=[];for(const r of this.overrides)r.identifiers.includes(n)&&e.push(...r.keys);return D.distinct(e)}getAllOverrideIdentifiers(){const n=[];for(const e of this.overrides)n.push(...e.identifiers);return D.distinct(n)}override(n){let e=this.overrideConfigurations.get(n);return e||(e=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,e)),e}merge(...n){const e=p.deepClone(this.contents),r=p.deepClone(this.overrides),o=[...this.keys];for(const m of n)if(!m.isEmpty()){this.mergeContents(e,m.contents);for(const S of m.overrides){const[w]=r.filter(L=>D.equals(L.identifiers,S.identifiers));w?(this.mergeContents(w.contents,S.contents),w.keys.push(...S.keys),w.keys=D.distinct(w.keys)):r.push(p.deepClone(S))}for(const S of m.keys)o.indexOf(S)===-1&&o.push(S)}return new E(e,o,r)}freeze(){return this.frozen=!0,this}clone(){return new E(p.deepClone(this.contents),[...this.keys],p.deepClone(this.overrides))}createOverrideConfigurationModel(n){const e=this.getContentsForOverrideIdentifer(n);if(!e||typeof e!="object"||!Object.keys(e).length)return this;const r={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(e)])){let m=this.contents[o];const S=e[o];S&&(typeof m=="object"&&typeof S=="object"?(m=p.deepClone(m),this.mergeContents(m,S)):m=S),r[o]=m}return new E(r,this.keys,this.overrides)}mergeContents(n,e){for(const r of Object.keys(e)){if(r in n&&a.isObject(n[r])&&a.isObject(e[r])){this.mergeContents(n[r],e[r]);continue}n[r]=p.deepClone(e[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?p.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let e=null,r=null;const o=m=>{m&&(r?this.mergeContents(r,m):r=p.deepClone(m))};for(const m of this.overrides)D.equals(m.identifiers,[n])?e=m.contents:m.identifiers.includes(n)&&o(m.contents);return o(e),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,e){this.addKey(n),(0,C.addToValueTree)(this.contents,n,e,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,C.removeFromValueTree)(this.contents,n)}addKey(n){let e=this.keys.length;for(let r=0;r<e;r++)n.indexOf(this.keys[r])===0&&(e=r);this.keys.splice(e,1,n)}removeKey(n){const e=this.keys.indexOf(n);return e!==-1?(this.keys.splice(e,1),!0):!1}}i.ConfigurationModel=E;class l{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,e){if(!a.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,e)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,e){this._raw=n;const{contents:r,keys:o,overrides:m,restricted:S}=this.doParseRaw(n,e);this._configurationModel=new E(r,o,m),this._restrictedConfigurations=S||[]}doParseContent(n){let e={},r=null,o=[];const m=[],S=[];function w(U){Array.isArray(o)?o.push(U):r!==null&&(o[r]=U)}const L={onObjectBegin:()=>{const U={};w(U),m.push(o),o=U,r=null},onObjectProperty:U=>{r=U},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const U=[];w(U),m.push(o),o=U,r=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:w,onError:(U,$,q)=>{S.push({error:U,offset:$,length:q})}};if(n)try{b.visit(n,L),e=o[0]||{}}catch(U){console.error(`Error while parsing settings file ${this._name}: ${U}`),this._parseErrors=[U]}return e}doParseRaw(n,e){const r=g.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,e);n=o.raw;const m=(0,C.toValuesTree)(n,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),S=Object.keys(n),w=this.toOverrides(n,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:m,keys:S,overrides:w,restricted:o.restricted}}filter(n,e,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const m={},S=[];for(const w in n)if(P.OVERRIDE_PROPERTY_REGEX.test(w)&&r){const L=this.filter(n[w],e,!1,o);m[w]=L.raw,S.push(...L.restricted)}else{const L=e[w],U=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&S.push(w),(U===void 0||o.scopes===void 0||o.scopes.includes(U))&&(o.skipRestricted&&L?.restricted||(m[w]=n[w]))}return{raw:m,restricted:S}}toOverrides(n,e){const r=[];for(const o of Object.keys(n))if(P.OVERRIDE_PROPERTY_REGEX.test(o)){const m={};for(const S in n[o])m[S]=n[o][S];r.push({identifiers:(0,P.overrideIdentifiersFromKey)(o),keys:Object.keys(m),contents:(0,C.toValuesTree)(m,e)})}return r}}i.ConfigurationModelParser=l;class f extends k.Disposable{constructor(n,e,r,o){super();this.userSettingsResource=n,this.scopes=e,this.fileService=o,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,m=>m.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&r.isEqual(m.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=f;class v{constructor(n,e,r,o,m=new E,S=new E,w=new T.ResourceMap,L=new E,U=new T.ResourceMap,$=!0){this._defaultConfiguration=n,this._policyConfiguration=e,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=m,this._workspaceConfiguration=S,this._folderConfigurations=w,this._memoryConfiguration=L,this._memoryConfigurationByResource=U,this._freeze=$,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(n,e,r){return this.getConsolidatedConfigurationModel(n,e,r).getValue(n)}updateValue(n,e,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new E,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,e===void 0?o.removeValue(n):o.setValue(n,e),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,e,r){const o=this.getConsolidatedConfigurationModel(n,e,r),m=this.getFolderConfigurationModelForResource(e.resource,r),S=e.resource?this._memoryConfigurationByResource.get(e.resource)||this._memoryConfiguration:this._memoryConfiguration,w=e.overrideIdentifier?this._defaultConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),L=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),U=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),$=e.overrideIdentifier?this.userConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),q=e.overrideIdentifier?this.localUserConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),Y=e.overrideIdentifier?this.remoteUserConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),ne=r?e.overrideIdentifier?this._workspaceConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,ce=m?e.overrideIdentifier?m.freeze().override(e.overrideIdentifier).getValue(n):m.freeze().getValue(n):void 0,re=e.overrideIdentifier?S.override(e.overrideIdentifier).getValue(n):S.getValue(n),ge=o.getValue(n),ae=D.distinct(o.overrides.map(N=>N.identifiers).flat()).filter(N=>o.getOverrideValue(n,N)!==void 0);return{defaultValue:w,policyValue:L,applicationValue:U,userValue:$,userLocalValue:q,userRemoteValue:Y,workspaceValue:ne,workspaceFolderValue:ce,memoryValue:re,value:ge,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,policy:L!==void 0?{value:L}:void 0,application:U!==void 0?{value:U,override:e.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,user:$!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,userLocal:q!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,userRemote:Y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,workspace:ne!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,workspaceFolder:ce!==void 0?{value:m?.freeze().getValue(n),override:e.overrideIdentifier?m?.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:S.getValue(n),override:e.overrideIdentifier?S.getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(n){const e=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:e?e.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,e){this._folderConfigurations.set(n,e),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,e){const r=[];if(!e){const{added:o,updated:m,removed:S}=c(this._defaultConfiguration,n);e=[...o,...m,...S]}for(const o of e)for(const m of(0,P.overrideIdentifiersFromKey)(o)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(m),w=n.getKeysForOverrideIdentifier(m),L=[...w.filter(U=>S.indexOf(U)===-1),...S.filter(U=>w.indexOf(U)===-1),...S.filter(U=>!p.equals(this._defaultConfiguration.override(m).getValue(U),n.override(m).getValue(U)))];r.push([m,L])}return this.updateDefaultConfiguration(n),{keys:e,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:e,updated:r,removed:o}=c(this._policyConfiguration,n),m=[...e,...r,...o];return m.length&&this.updatePolicyConfiguration(n),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:e,updated:r,removed:o,overrides:m}=c(this.applicationConfiguration,n),S=[...e,...r,...o];return S.length&&this.updateApplicationConfiguration(n),{keys:S,overrides:m}}compareAndUpdateLocalUserConfiguration(n){const{added:e,updated:r,removed:o,overrides:m}=c(this.localUserConfiguration,n),S=[...e,...r,...o];return S.length&&this.updateLocalUserConfiguration(n),{keys:S,overrides:m}}compareAndUpdateRemoteUserConfiguration(n){const{added:e,updated:r,removed:o,overrides:m}=c(this.remoteUserConfiguration,n),S=[...e,...r,...o];return S.length&&this.updateRemoteUserConfiguration(n),{keys:S,overrides:m}}compareAndUpdateWorkspaceConfiguration(n){const{added:e,updated:r,removed:o,overrides:m}=c(this.workspaceConfiguration,n),S=[...e,...r,...o];return S.length&&this.updateWorkspaceConfiguration(n),{keys:S,overrides:m}}compareAndUpdateFolderConfiguration(n,e){const r=this.folderConfigurations.get(n),{added:o,updated:m,removed:S,overrides:w}=c(r,e),L=[...o,...m,...S];return(L.length||!r)&&this.updateFolderConfiguration(n,e),{keys:L,overrides:w}}compareAndDeleteFolderConfiguration(n){const e=this.folderConfigurations.get(n);if(!e)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:m,overrides:S}=c(e,void 0);return{keys:[...r,...o,...m],overrides:S}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,e,r){let o=this.getConsolidatedConfigurationModelForResource(e,r);return e.overrideIdentifier&&(o=o.override(e.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},e){let r=this.getWorkspaceConsolidatedConfiguration();if(e&&n){const o=e.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const m=this._memoryConfigurationByResource.get(n);m&&(r=r.merge(m))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let e=this._foldersConsolidatedConfigurations.get(n);if(!e){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(e=r.merge(o),this._freeze&&(e=e.freeze()),this._foldersConsolidatedConfigurations.set(n,e)):e=r}return e}getFolderConfigurationModelForResource(n,e){if(e&&n){const r=e.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,e)=>{const{contents:r,overrides:o,keys:m}=this._folderConfigurations.get(e);return n.push([e,{contents:r,overrides:o,keys:m}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(e=>n.add(e)),this.userConfiguration.freeze().keys.forEach(e=>n.add(e)),this._workspaceConfiguration.freeze().keys.forEach(e=>n.add(e)),this._folderConfigurations.forEach(e=>e.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this._folderConfigurations.forEach(e=>e.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const e=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>e.add(o))),[...e.values()]}static parse(n){const e=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),m=this.parseConfigurationModel(n.user),S=this.parseConfigurationModel(n.workspace),w=n.folders.reduce((L,U)=>(L.set(d.URI.revive(U[0]),this.parseConfigurationModel(U[1])),L),new T.ResourceMap);return new v(e,r,o,m,new E,S,w,new E,new T.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}i.Configuration=v;function u(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const n=new Set,e=new Map;for(const o of t)o.keys.forEach(m=>n.add(m)),o.overrides.forEach(([m,S])=>{const w=(0,T.getOrSet)(e,m,new Set);S.forEach(L=>w.add(L))});const r=[];return e.forEach((o,m)=>r.push([m,[...o.values()]])),{keys:[...n.values()],overrides:r}}i.mergeChanges=u;class h{constructor(n,e,r,o){this.change=n,this.previous=e,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const m=new Set;n.keys.forEach(w=>m.add(w)),n.overrides.forEach(([,w])=>w.forEach(L=>m.add(L))),this.affectedKeys=[...m.values()];const S=new E;this.affectedKeys.forEach(w=>S.setValue(w,{})),this.affectedKeysTree=S.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,e){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(e){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,e,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,e,this.currentWorkspace);return!p.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,e){let r=(0,C.toValuesTree)({[e]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}i.ConfigurationChangeEvent=h;class y extends h{constructor(n,e,r,o){super({keys:n.allKeys(),overrides:[]},void 0,n,e);this.source=r,this.sourceConfig=o}}i.AllKeysConfigurationChangeEvent=y;function c(t,n){const{added:e,removed:r,updated:o}=s(n,t),m=[],S=t?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const L=w.filter(U=>!S.includes(U));for(const U of L)m.push([U,n.getKeysForOverrideIdentifier(U)])}if(t){const L=S.filter(U=>!w.includes(U));for(const U of L)m.push([U,t.getKeysForOverrideIdentifier(U)])}if(n&&t){for(const L of S)if(w.includes(L)){const U=s({contents:t.getOverrideValue(void 0,L)||{},keys:t.getKeysForOverrideIdentifier(L)},{contents:n.getOverrideValue(void 0,L)||{},keys:n.getKeysForOverrideIdentifier(L)});m.push([L,[...U.added,...U.removed,...U.updated]])}}return{added:e,removed:r,updated:o,overrides:m}}function s(t,n){const e=t?n?t.keys.filter(m=>n.keys.indexOf(m)===-1):[...t.keys]:[],r=n?t?n.keys.filter(m=>t.keys.indexOf(m)===-1):[...n.keys]:[],o=[];if(t&&n){for(const m of n.keys)if(t.keys.indexOf(m)!==-1){const S=(0,C.getConfigurationValue)(n.contents,m),w=(0,C.getConfigurationValue)(t.contents,m);p.equals(S,w)||o.push(m)}}return{added:e,removed:r,updated:o}}}),define(Z[118],ee([0,1,19,4,2,24,7,21,64,39,9,37,32]),function(B,i,D,I,b,k,T,p,a,d,C,P,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PolicyConfiguration=i.NullPolicyConfiguration=i.DefaultConfigurationModel=i.DefaultConfiguration=void 0;class E extends b.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new l(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(g.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:h,defaultsOverrides:y})=>this.onDidUpdateConfiguration(h,y))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(h,y){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:h})}getConfigurationDefaultOverrides(){return{}}}i.DefaultConfiguration=E;class l extends a.ConfigurationModel{constructor(h={}){const y=g.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(y),s=Object.create(null),t=[];for(const n in y){const e=h[n],r=e!==void 0?e:y[n].default;(0,p.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(n)&&t.push({identifiers:(0,d.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,p.toValuesTree)(s[n],e=>console.error(`Conflict in default settings file: ${e}`))});super(s,c,t)}}i.DefaultConfigurationModel=l;class f{constructor(){this.onDidChangeConfiguration=I.Event.None,this.configurationModel=new a.ConfigurationModel}async initialize(){return this.configurationModel}}i.NullPolicyConfiguration=f;let v=class extends b.Disposable{constructor(h,y,c){super();this.defaultConfiguration=h,this.policyService=y,this.logService=c,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new a.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(h=>this.onDidChangePolicies(h))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:h})=>this.update(await this.registerPolicyDefinitions(h),!0))),this._configurationModel}async registerPolicyDefinitions(h){const y={},c=[],s=g.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const t of h){const n=s[t];if(!n){c.push(t);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}c.push(t),y[n.policy.name]={type:n.type}}}return(0,T.isEmptyObject)(y)||await this.policyService.registerPolicyDefinitions(y),c}onDidChangePolicies(h){const y=g.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),c=(0,D.coalesce)(h.map(s=>y.get(s)));this.update(c,!0)}update(h,y){const c=g.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],t=this._configurationModel.isEmpty();for(const n of h){const e=c[n]?.policy?.name;if(e){const r=this.policyService.getPolicyValue(e);(t?r!==void 0:!(0,k.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new a.ConfigurationModel;for(const e of n.keys)this._configurationModel.setValue(e,n.getValue(e));for(const[e,r]of s)r===void 0?this._configurationModel.removeValue(e):this._configurationModel.setValue(e,r);y&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};v=fe([te(1,P.IPolicyService),te(2,C.ILogService)],v),i.PolicyConfiguration=v}),define(Z[119],ee([0,1,3,4,2,18,21,64,118,37]),function(B,i,D,I,b,k,T,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class C extends b.Disposable{constructor(g,E,l,f){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new a.DefaultConfiguration),this.policyConfiguration=l instanceof d.NullPolicyService?new a.NullPolicyConfiguration:this._register(new a.PolicyConfiguration(this.defaultConfiguration,l,f)),this.userConfiguration=this._register(new p.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,E)),this.configuration=new p.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new p.ConfigurationModel,new p.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:v,properties:u})=>this.onDidDefaultConfigurationChange(v,u))),this._register(this.policyConfiguration.onDidChangeConfiguration(v=>this.onDidPolicyConfigurationChange(v))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[g,E,l]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new p.Configuration(g,E,new p.ConfigurationModel,l)}getConfigurationData(){return this.configuration.toData()}getValue(g,E){const l=typeof g=="string"?g:void 0,f=(0,T.isConfigurationOverrides)(g)?g:(0,T.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(l,f,void 0)}updateValue(g,E,l,f){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const E=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(l,E,2)}onDidDefaultConfigurationChange(g,E){const l=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(g,E);this.trigger(f,l,7)}onDidPolicyConfigurationChange(g){const E=this.configuration.toData(),l=this.configuration.compareAndUpdatePolicyConfiguration(g);this.trigger(l,E,7)}trigger(g,E,l){const f=new p.ConfigurationChangeEvent(g,{data:E},this.configuration);f.source=l,f.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(g){switch(g){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=C}),define(Z[120],ee([0,1,16]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parseAuthorityWithOptionalPort=i.parseAuthorityWithPort=i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function I(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}i.getRemoteAuthority=I;function b(d){if(!d)return;const C=d.indexOf("+");return C<0?d:d.substr(0,C)}i.getRemoteName=b;function k(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}i.getRemoteServerRootPath=k;function T(d){const{host:C,port:P}=a(d);if(typeof P=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:P}}i.parseAuthorityWithPort=T;function p(d,C){let{host:P,port:g}=a(d);return typeof g=="undefined"&&(g=C),{host:P,port:g}}i.parseAuthorityWithOptionalPort=p;function a(d){const C=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const P=d.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const g=d.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:d,port:void 0}}}),define(Z[33],ee([0,1,31,8,120]),function(B,i,D,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.isApplicationScopedExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}i.getWorkspaceSupportTypeMessage=k;function T(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}i.isIExtensionIdentifier=T,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var p;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(p=i.ExtensionType||(i.ExtensionType={}));var a;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(a=i.TargetPlatform||(i.TargetPlatform={}));class d{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,v){if(typeof f=="undefined"||f===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof f=="string"||typeof v=="string"){const u=typeof f=="string"?f:f.value,h=typeof v=="string"?v:v.value;return D.equalsIgnoreCase(u,h)}return f._lower===v._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}i.ExtensionIdentifier=d;function C(l){return P(l)}i.isApplicationScopedExtension=C;function P(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}i.isLanguagePackExtension=P;function g(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=g;function E(l,f){if(f){const v=`onResolveRemoteAuthority:${(0,b.getRemoteName)(f)}`;return l.activationEvents?.indexOf(v)!==-1}return!1}i.isResolverExtension=E,i.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[23],ee([0,1,31,22,33,13,10,12,35]),function(B,i,D,I,b,k,T,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function d(n,e){return n.uuid&&e.uuid?n.uuid===e.uuid:n.id===e.id?!0:(0,D.compareIgnoreCase)(n.id,e.id)===0}i.areSameExtensions=d;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{constructor(e,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=e.id}static create(e){const r=e.manifest?e.manifest.version:e.version,o=e.manifest?e.targetPlatform:e.properties.targetPlatform;return new P(e.identifier,r,o)}static parse(e){const r=C.exec(e);return r&&r[1]&&r[2]?new P({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(e){return e instanceof P?d(this,e)&&this.version===e.version&&this.targetPlatform===e.targetPlatform:!1}}i.ExtensionKey=P;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(n){const e=g.exec(n);return e&&e[1]?[f(e[1]),e[2]]:[f(n),void 0]}i.getIdAndVersion=E;function l(n,e){return`${n}.${e}`}i.getExtensionId=l;function f(n){return n.toLocaleLowerCase()}i.adoptToGalleryExtensionId=f;function v(n,e){return f(l(n,e))}i.getGalleryExtensionId=v;function u(n,e){const r=[],o=m=>{for(const S of r)if(S.some(w=>d(e(w),e(m))))return S;return null};for(const m of n){const S=o(m);S?S.push(m):r.push([m])}return r}i.groupByExtension=u;function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=h;function y(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}i.getGalleryExtensionTelemetryData=y,i.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function c(n,e){const r=[],o=e.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const m=o.shift();if(m&&r.every(S=>!d(S.identifier,{id:m}))){const S=n.filter(w=>d(w.identifier,{id:m}));S.length===1&&(r.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}i.getExtensionDependencies=c;async function s(n,e){if(!k.isLinux)return!1;let r;try{r=(await n.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){e.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(m))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=s;async function t(n,e){const r=await s(n,e),o=(0,I.getTargetPlatform)(r?"alpine":k.platform,a.arch);return e.debug("ComputeTargetPlatform:",o),o}i.computeTargetPlatform=t}),define(Z[121],ee([0,1,25,12,16,18,38,10,87,22,23,33]),function(B,i,D,I,b,k,T,p,a,d,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const g=v=>(0,a.localize)(0,null,v),E=(0,a.localize)(1,null,"ms-dotnettools.csharp");function l(v,u){return u?`${v.publisher}.${v.name}@${v.version}`:`${v.publisher}.${v.name}`}let f=class{constructor(u,h){this.extensionManagementService=u,this.extensionGalleryService=h}get location(){}async listExtensions(u,h,y=console){let c=await this.extensionManagementService.getInstalled(1);const s=P.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(h&&h!==""){if(s.indexOf(h.toLowerCase())<0){y.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}c=c.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){y.log("Possible Categories: "),s.forEach(n=>{y.log(n)});return}this.location&&y.log((0,a.localize)(2,null,this.location)),c=c.sort((n,e)=>n.identifier.id.localeCompare(e.identifier.id));let t;for(const n of c)t!==n.identifier.id&&(t=n.identifier.id,y.log(l(n.manifest,u)))}async installExtensions(u,h,y,c,s=console){const t=[],n=[];u.length&&s.log(this.location?(0,a.localize)(3,null,this.location):(0,a.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),r=(w,L)=>{const U=e.find($=>(0,C.areSameExtensions)($.identifier,{id:w}));if(U){if(!c&&(!L||L==="prerelease"&&U.preRelease))return s.log((0,a.localize)(5,null,w,U.manifest.version,w)),!1;if(L&&U.manifest.version===L)return s.log((0,a.localize)(6,null,`${w}@${L}`)),!1}return!0},o=(w,L,U)=>{S.push({id:w,version:L!=="prerelease"?L:void 0,installOptions:{...y,isBuiltin:U,installPreReleaseVersion:L==="prerelease"||y.installPreReleaseVersion}})},m=[],S=[];for(const w of u)if(w instanceof p.URI)m.push(w);else{const[L,U]=(0,C.getIdAndVersion)(w);r(L,U)&&o(L,U,!1)}for(const w of h){const[L,U]=(0,C.getIdAndVersion)(w);r(L,U)&&o(L,U,!0)}if(m.length&&await Promise.all(m.map(async w=>{try{const L=await this.installVSIX(w,{...y,isBuiltin:!1},c,s);L&&n.push(L)}catch(L){s.error(L.message||L.stack||L),t.push(w.toString())}})),S.length){const w=await this.getGalleryExtensions(S);await Promise.all(S.map(async L=>{const U=w.get(L.id.toLowerCase());if(U)try{const $=await this.installFromGallery(L,U,e,c,s);$&&n.push($)}catch($){s.error($.message||$.stack||$),t.push(L.id)}else s.error(`${g(L.version?`${L.id}@${L.version}`:L.id)}
${E}`),t.push(L.id)}))}if(t.length)throw new Error((0,a.localize)(7,null,t.join(", ")))}async installVSIX(u,h,y,c){const s=await this.extensionManagementService.getManifest(u);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,y,c))try{return await this.extensionManagementService.install(u,h),c.log((0,a.localize)(8,null,(0,k.basename)(u))),s}catch(n){if((0,I.isCancellationError)(n))return c.log((0,a.localize)(9,null,(0,k.basename)(u))),null;throw n}return null}async getGalleryExtensions(u){const h=new Map,y=u.some(s=>s.installOptions.installPreReleaseVersion),c=await this.extensionGalleryService.getExtensions(u.map(s=>({...s,preRelease:y})),D.CancellationToken.None);for(const s of c)h.set(s.identifier.id.toLowerCase(),s);return h}async installFromGallery({id:u,version:h,installOptions:y},c,s,t,n){const e=await this.extensionGalleryService.getManifest(c,D.CancellationToken.None);if(e&&!this.validateExtensionKind(e,n))return null;const r=s.find(o=>(0,C.areSameExtensions)(o.identifier,c.identifier));if(r){if(c.version===r.manifest.version)return n.log((0,a.localize)(10,null,h?`${u}@${h}`:u)),null;n.log((0,a.localize)(11,null,u,c.version))}try{y.isBuiltin?n.log(h?(0,a.localize)(12,null,u,h):(0,a.localize)(13,null,u)):n.log(h?(0,a.localize)(14,null,u,h):(0,a.localize)(15,null,u));const o=await this.extensionManagementService.installFromGallery(c,{...y,installGivenVersion:!!h});return n.log((0,a.localize)(16,null,u,o.manifest.version)),e}catch(o){if((0,I.isCancellationError)(o))return n.log((0,a.localize)(17,null,u)),null;throw o}}validateExtensionKind(u,h){return!0}async validateVSIX(u,h,y){const c={id:(0,C.getGalleryExtensionId)(u.publisher,u.name)},t=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,C.areSameExtensions)(c,n.identifier)&&(0,T.gt)(n.manifest.version,u.version));return t&&!h?(y.log((0,a.localize)(18,null,t.identifier.id,t.manifest.version,u.version)),!1):this.validateExtensionKind(u,y)}async uninstallExtensions(u,h,y=console){const c=async t=>{if(t instanceof p.URI){const n=await this.extensionManagementService.getManifest(t);return l(n)}return t},s=[];for(const t of u){const n=await c(t),r=(await this.extensionManagementService.getInstalled()).filter(o=>(0,C.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.notInstalled(n)}
${E}`);if(r.some(o=>o.type===0)){y.log((0,a.localize)(19,null,n));return}if(!h&&r.some(o=>o.isBuiltin)){y.log((0,a.localize)(20,null,n));return}y.log((0,a.localize)(21,null,n));for(const o of r)await this.extensionManagementService.uninstall(o),s.push(o);this.location?y.log((0,a.localize)(22,null,n,this.location)):y.log((0,a.localize)(23,null,n))}}async locateExtension(u,h=console){const y=await this.extensionManagementService.getInstalled();u.forEach(c=>{y.forEach(s=>{if(s.identifier.id===c&&s.location.scheme===b.Schemas.file){h.log(s.location.fsPath);return}})})}notInstalled(u){return this.location?(0,a.localize)(24,null,u,this.location):(0,a.localize)(25,null,u)}};f=fe([te(0,d.IExtensionManagementService),te(1,d.IExtensionGalleryService)],f),i.ExtensionManagementCLIService=f}),define(Z[40],ee([0,1,3,15,2,36,10,23,11,8,9]),function(B,i,D,I,b,k,T,p,a,d,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsProfileScannerService=i.IExtensionsProfileScannerService=void 0,i.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let P=class extends b.Disposable{constructor(E,l){super();this.fileService=E,this.logService=l,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(E){return this.withProfileExtensions(E)}addExtensionsToProfile(E,l){return this.withProfileExtensions(l,f=>(f=f.filter(v=>E.some(([u])=>!(0,p.areSameExtensions)(v.identifier,u.identifier))),f.push(...E.map(([v,u])=>({identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:u}))),f))}removeExtensionFromProfile(E,l){return this.withProfileExtensions(l,f=>f.filter(v=>!(0,p.areSameExtensions)(v.identifier,E)))}async withProfileExtensions(E,l){return this.getResourceAccessQueue(E).queue(async()=>{let f=[];try{const v=await this.fileService.readFile(E),u=JSON.parse(v.value.toString());for(const h of u){if(!h.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",h);continue}if(!h.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",h);continue}if(!h.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",h);continue}f.push({identifier:h.identifier,location:T.URI.revive(h.location),version:h.version,metadata:h.metadata})}}catch(v){v.fileOperationResult!==1&&this.logService.error(v)}if(l){f=l(f);const v=f.map(u=>({identifier:u.identifier,version:u.version,location:u.location.toJSON(),metadata:u.metadata}));await this.fileService.writeFile(E,I.VSBuffer.fromString(JSON.stringify(v)))}return f})}getResourceAccessQueue(E){let l=this.resourcesAccessQueueMap.get(E);return l||(l=new D.Queue,this.resourcesAccessQueueMap.set(E,l)),l}};P=fe([te(0,a.IFileService),te(1,C.ILogService)],P),i.ExtensionsProfileScannerService=P}),define(Z[122],ee([0,1,3,12,2,13,18,38,10,29,20,17,22,23,11,9]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let v=class extends b.Disposable{constructor(h,y,c,s){super();this.fileService=y,this.extensionGalleryService=c,this.logService=s,this.extensionsDownloadDir=a.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,y){await this.cleanUpPromise;const c=this.getName(h),s=(0,T.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(s)){const t=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(t)||await this.extensionGalleryService.download(h,t,y);try{await this.rename(t,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(t)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,t.path),n}}return s}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async rename(h,y,c){try{await C.Promises.rename(h.fsPath,y.fsPath)}catch(s){if(k.isWindows&&s&&s.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${h} to ${y} with 'EPERM' error. Trying again...`),this.rename(h,y,c);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const y=[],c=[];for(const n of h.children){const e=E.ExtensionKey.parse(n.name);e&&c.push([e,n])}const s=(0,E.groupByExtension)(c,([n])=>n),t=[];for(const n of s)n.sort((e,r)=>p.rcompare(e[0].version,r[0].version)),y.push(...n.slice(1).map(e=>e[1].resource)),t.push(n[0][1]);t.sort((n,e)=>n.mtime-e.mtime),y.push(...t.slice(0,Math.max(0,t.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(y.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?E.ExtensionKey.create(h).toString().toLowerCase():(0,d.generateUuid)()}};v=fe([te(0,P.INativeEnvironmentService),te(1,l.IFileService),te(2,g.IExtensionGalleryService),te(3,f.ILogService)],v),i.ExtensionsDownloader=v}),define(Z[123],ee([0,1,2,14,20,33]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(a,d){super();this.environmentService=a,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(d.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(a){a.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(a){a.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=T}),define(Z[124],ee([0,1,154,19,3,2,16,14,20,17,22,23,9,62]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeLanguagePackService=void 0;let l=class extends E.LanguagePackBaseService{constructor(h,y,c,s){super(c);this.extensionManagementService=h,this.logService=s,this.cache=this._register(new f(y,s)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getInstalledLanguages(){const h=await this.cache.getLanguagePacks(),y=Object.keys(h).map(c=>{const s=h[c];return{...this.createQuickPickItem({locale:c,label:s.label}),extensionId:s.extensions[0].extensionIdentifier.id}});return y.push({...this.createQuickPickItem({locale:"en",label:"English"}),extensionId:"default"}),y}async postInstallExtension(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",h.identifier.id),await this.update())}async postUninstallExtension(h){const y=await this.cache.getLanguagePacks();Object.keys(y).some(c=>y[c]&&y[c].extensions.some(s=>(0,P.areSameExtensions)(s.extensionIdentifier,h.identifier)))&&(this.logService.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),c=await this.cache.update(y);return!(0,I.equals)(Object.keys(h),Object.keys(c))}};l=fe([te(0,C.IExtensionManagementService),te(1,d.INativeEnvironmentService),te(2,C.IExtensionGalleryService),te(3,g.ILogService)],l),i.NativeLanguagePackService=l;let f=class extends k.Disposable{constructor(h,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(h.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(h){return this.withLanguagePacks(y=>{Object.keys(y).forEach(c=>delete y[c]),this.createLanguagePacksFromExtensions(y,...h)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(h,...y){for(const c of y)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(h,c);Object.keys(h).forEach(c=>this.updateHash(h[c]))}createLanguagePacksFromExtension(h,y){const c=y.identifier,s=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const t of s)if(y.location.scheme===T.Schemas.file&&v(t)){let n=h[t.languageId];n||(n={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},h[t.languageId]=n);const e=n.extensions.filter(r=>(0,P.areSameExtensions)(r.extensionIdentifier,c))[0];e?e.version=y.manifest.version:n.extensions.push({extensionIdentifier:c,version:y.manifest.version});for(const r of t.translations)n.translations[r.id]=(0,p.join)(y.location.fsPath,r.path)}}updateHash(h){if(h){const y=(0,D.createHash)("md5");for(const c of h.extensions)y.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);h.hash=y.digest("hex")}}withLanguagePacks(h=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return a.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch{return{}}}).then(c=>(y=h(c),c)).then(c=>{for(const t of Object.keys(c))c[t]||delete c[t];this.languagePacks=c,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),a.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>y,c=>this.logService.error(c))})}};f=fe([te(0,d.INativeEnvironmentService),te(1,g.ILogService)],f);function v(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const h of u.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(Z[48],ee([0,1,15,96,39,8,32]),function(B,i,D,I,b,k,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,k.createDecorator)("requestService");function p(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}i.isSuccess=p;function a(f){return f.res.statusCode===204}async function d(f){return a(f)?null:(await(0,D.streamToBuffer)(f.stream)).toString()}i.asText=d;async function C(f){if(!p(f))throw new Error("Server returned "+f.res.statusCode);return d(f)}i.asTextOrError=C;async function P(f){if(!p(f))throw new Error("Server returned "+f.res.statusCode);if(a(f))return null;const u=(await(0,D.streamToBuffer)(f.stream)).toString();try{return JSON.parse(u)}catch(h){throw h.message+=`:
`+u,h}}i.asJson=P;function g(f){l(f)}i.updateProxyConfigurationsScope=g;let E;function l(f){const v=T.Registry.as(b.Extensions.Configuration),u=E;E={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[E],remove:u?[u]:[]})}l(2)}),define(Z[125],ee([0,1,25,16,11,48]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let T=class{constructor(a,d){this.requestService=a,this.fileService=d}async download(a,d,C=D.CancellationToken.None){if(a.scheme===I.Schemas.file||a.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(a,d);return}const P={type:"GET",url:a.toString(!0)},g=await this.requestService.request(P,C);if(g.res.statusCode===200)await this.fileService.writeFile(d,g.stream);else{const E=await(0,k.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${E}`)}}};T=fe([te(0,k.IRequestService),te(1,b.IFileService)],T),i.DownloadService=T}),define(Z[126],ee([0,1,127,7]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(T,p){return T.protocol==="http:"?p.HTTP_PROXY||p.http_proxy||null:T.protocol==="https:"&&(p.HTTPS_PROXY||p.https_proxy||p.HTTP_PROXY||p.http_proxy)||null}async function k(T,p,a={}){const d=(0,D.parse)(T),C=a.proxyUrl||b(d,p);if(!C)return null;const P=(0,D.parse)(C);if(!/^https?:$/.test(P.protocol||""))return null;const g={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,I.isBoolean)(a.strictSSL)?a.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((E,l)=>{B(["http-proxy-agent"],E,l)}))(g):new(await new Promise((E,l)=>{B(["https-proxy-agent"],E,l)}))(g)}i.getProxyAgent=k}),define(Z[128],ee([0,1,45,14,97,25,30,12,13,29,81,155,3]),function(B,i,D,I,b,k,T,p,a,d,C,P,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const E=1e4;let l;async function f(u,h,y){return h["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):a.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(y)&&!h["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(y)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),l||(l=g.Promises.withAsyncBody(async(c,s)=>{const t=new k.CancellationTokenSource,n=setTimeout(()=>{t.dispose(!0),s(new Error((0,b.localize)(0,null)))},E);try{c(await v(u,t.token))}catch(e){!(0,p.isCancellationError)(e)&&!t.token.isCancellationRequested?s(new Error((0,b.localize)(1,null,(0,T.toErrorMessage)(e)))):c({})}finally{clearTimeout(n),t.dispose()}})),l)}i.getResolvedShellEnv=f;async function v(u,h){const y=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",y);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",c);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};u.trace("getUnixShellEnvironment#env",n);const e=await(0,C.getSystemShell)(a.OS,n);return u.trace("getUnixShellEnvironment#shell",e),new Promise((r,o)=>{if(h.isCancellationRequested)return o((0,p.canceled)());const m=(0,I.basename)(e);let S,w;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(m)?(S=`& '${process.execPath}' ${L} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,w=["-Login","-Command"]):(S=`'${process.execPath}' ${L} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,m==="tcsh"?w=["-ic"]:w=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(w),S);const U=(0,D.spawn)(e,[...w,S],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});h.onCancellationRequested(()=>(U.kill(),o((0,p.canceled)()))),U.on("error",Y=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(Y)),o(Y)});const $=[];U.stdout.on("data",Y=>$.push(Y));const q=[];U.stderr.on("data",Y=>q.push(Y)),U.on("close",(Y,ne)=>{const ce=Buffer.concat($).toString("utf8");u.trace("getUnixShellEnvironment#raw",ce);const re=Buffer.concat(q).toString("utf8");if(re.trim()&&u.trace("getUnixShellEnvironment#stderr",re),Y||ne)return o(new Error((0,b.localize)(2,null,Y,ne)));const ge=t.exec(ce),ae=ge?ge[1]:"{}";try{const N=JSON.parse(ae);y?N.ELECTRON_RUN_AS_NODE=y:delete N.ELECTRON_RUN_AS_NODE,c?N.ELECTRON_NO_ATTACH_CONSOLE=c:delete N.ELECTRON_NO_ATTACH_CONSOLE,delete N.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",N),r(N)}catch(N){u.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(N)),o(N)}})})}}),define(Z[65],ee([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IStateService=void 0,i.IStateService=(0,D.createDecorator)("stateService")}),define(Z[129],ee([0,1,3,15,7,17,11,9]),function(B,i,D,I,b,k,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StateService=i.FileStorage=void 0;class a{constructor(P,g,E){this.storagePath=P,this.logService=g,this.fileService=E,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new D.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}}getItem(P,g){const E=this.storage[P];return(0,b.isUndefinedOrNull)(E)?g:E}setItem(P,g){this.setItems([{key:P,data:g}])}setItems(P){let g=!1;for(const{key:E,data:l}of P)this.storage[E]!==l&&((0,b.isUndefinedOrNull)(l)?(0,b.isUndefined)(this.storage[E])||(this.storage[E]=void 0,g=!0):(this.storage[E]=l,g=!0));g&&this.save()}removeItem(P){(0,b.isUndefined)(this.storage[P])||(this.storage[P]=void 0,this.save())}async save(P){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),P)}async doSave(){if(!this.initializing)return;await this.initializing;const P=JSON.stringify(this.storage,null,4);if(P!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,I.VSBuffer.fromString(P)),this.lastSavedStorageContents=P}catch(g){this.logService.error(g)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}i.FileStorage=a;let d=class{constructor(P,g,E){this.fileStorage=new a(P.stateResource,g,E)}async init(){await this.fileStorage.init()}getItem(P,g){return this.fileStorage.getItem(P,g)}};d=fe([te(0,k.IEnvironmentService),te(1,p.ILogService),te(2,T.IFileService)],d),i.StateService=d}),define(Z[66],ee([0,1,13,35,10,29]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function T(d){if(D.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function p(d,C,P,g,E,l,f,v,u,h){const y=Object.create(null);y["common.machineId"]=f,y.sessionID=(0,k.generateUuid)()+Date.now(),y.commitHash=E,y.version=l,y["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,D.PlatformToString)(D.platform),y["common.nodePlatform"]=I.platform,y["common.nodeArch"]=g,y["common.product"]=h||"desktop",v&&(y["common.msftInternal"]=v);let c=0;const s=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),D.isLinuxSnap&&(y["common.snap"]="true");const t=T(P);t&&(y["common.platformDetail"]=t);try{const n=await d.readFile(b.URI.file(u));y["common.source"]=n.value.toString().slice(0,30)}catch{}return y}i.resolveCommonProperties=p;function a(d){const C=I.env.USERDNSDOMAIN;if(!C)return!1;const P=C.toLowerCase();return d.some(g=>P===g)}i.verifyMicrosoftInternalDomain=a}),define(Z[34],ee([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(I=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Z[41],ee([0,1,24,53,7,21,66,34]),function(B,i,D,I,b,k,T,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.isInternalTelemetry=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class a{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(t,n){return Promise.resolve(void 0)}publicLog2(t,n){return this.publicLog(t,n)}publicLogError(t,n){return Promise.resolve(void 0)}publicLogError2(t,n){return this.publicLogError(t,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=a,i.NullTelemetryService=new a;class d{async publicLog(t,n,e){}async publicLogError(t,n,e){}}i.NullEndpointTelemetryService=d,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(s,t){return t.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(n.source),configurationKeys:u(n.sourceConfig)})})}i.configurationTelemetry=C;function P(s,t){return!(t.disableTelemetry||!s.enableTelemetry||t.extensionTestsLocationURI)}i.supportsTelemetry=P;function g(s){const t=s.getValue(p.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=g;function E(s){const t={},n={},e={};v(s,e);for(let r in e){r=r.length>150?r.substr(r.length-149):r;const o=e[r];typeof o=="number"?n[r]=o:typeof o=="boolean"?n[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),t[r]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(t[r]=o)}return{properties:t,measurements:n}}i.validateTelemetryData=E;const l=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function f(s){if(!s)return"none";for(const t of l)if(s.startsWith(`${t}+`))return t;return"other"}i.cleanRemoteAuthority=f;function v(s,t,n=0,e){if(!!s)for(const r of Object.getOwnPropertyNames(s)){const o=s[r],m=e?e+r:r;Array.isArray(o)?t[m]=(0,D.safeStringify)(o):o instanceof Date?t[m]=o.toISOString():(0,b.isObject)(o)?n<2?v(o,t,n+1,m+"."):t[m]=(0,D.safeStringify)(o):t[m]=o}}function u(s){if(!s)return[];const t=[];return h(t,"",s),t}function h(s,t,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(e=>h(s,t?`${t}.${e}`:e,n[e])):s.push(t)}function y(s,t){const n=s.msftInternalDomains||[],e=t.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(n)||e}i.isInternalTelemetry=y;function c(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}i.getPiiPathsFromEnvironment=c}),define(Z[130],ee([0,1,103,41]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function b(k,T,p,a,d,C,P){const g={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${T.nameShort})`},E=await(0,D.getServiceMachineId)(p,d,C),{sessionId:l}=await P.getTelemetryInfo();return(0,I.supportsTelemetry)(T,p)&&(0,I.getTelemetryLevel)(a)===3&&(g["X-Market-User-Id"]=E,g["VSCode-SessionId"]=l),g}i.resolveMarketplaceHeaders=b}),define(Z[131],ee([0,1,12,24,41]),function(B,i,D,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractOneDataSystemAppender=i.telemetryEndpointUrl=void 0,i.telemetryEndpointUrl="https://0.0.0.0/OneCollector/1.0";async function k(p,a,d){const C=await new Promise((f,v)=>{B(["@microsoft/1ds-core-js"],f,v)}),P=await new Promise((f,v)=>{B(["@microsoft/1ds-post-js"],f,v)}),g=new C.AppInsightsCore,E=new P.PostChannel,l={instrumentationKey:p,endpointUrl:i.telemetryEndpointUrl,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(d){l.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:d};l.extensionConfig[E.identifier]=f}return g.initialize(l,[]),g.addTelemetryInitializer(f=>{a&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),g}class T{constructor(a,d,C,P,g){this._isInternalTelemetry=a,this._eventPrefix=d,this._defaultData=C,this._xhrOverride=g,this.endPointUrl=i.telemetryEndpointUrl,this._defaultData||(this._defaultData={}),typeof P=="function"?this._aiCoreOrKey=P():this._aiCoreOrKey=P,this._asyncAiCore=null}_withAIClient(a){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){a(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=k(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(d=>{a(d)},d=>{(0,D.onUnexpectedError)(d),console.error(d)})}}log(a,d){if(!this._aiCoreOrKey)return;d=(0,I.mixin)(d,this._defaultData),d=(0,b.validateTelemetryData)(d);const C=this._eventPrefix+"/"+a;try{this._withAIClient(P=>{P.pluginVersionString=d?.properties.version??"Unknown",P.track({name:C,baseData:{name:C,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(a=>{this._withAIClient(d=>{d.unload(!0,()=>{this._aiCoreOrKey=void 0,a(void 0)})})}):Promise.resolve(void 0)}}i.AbstractOneDataSystemAppender=T}),define(Z[132],ee([0,1,2,24,53,13,31,98,21,39,133,27,32,34,41]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let f=class{constructor(h,y,c){this._configurationService=y,this._productService=c,this._experimentProperties={},this.telemetryLevel=new b.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=h.appenders,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(h,y){this._experimentProperties[h]=y}_updateTelemetryLevel(){let h=(0,l.getTelemetryLevel)(this._configurationService);const y=this._productService.enabledTelemetryLevels;if(y){this._sendErrorTelemetry=this.sendErrorTelemetry?y.error:!1;const c=y.usage?3:y.error?2:0;h=Math.min(h,c)}this.telemetryLevel.value=h}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const h=await this._commonProperties,y=h.sessionID,c=h["common.machineId"],s=h["common.firstSessionDate"],t=h["common.msftInternal"];return{sessionId:y,machineId:c,firstSessionDate:s,msftInternal:t}}dispose(){this._disposables.dispose()}_log(h,y,c,s){return this.telemetryLevel.value<y?Promise.resolve(void 0):this._commonProperties.then(t=>{c=(0,I.mixin)(c,t),c=(0,I.mixin)(c,this._experimentProperties),c=(0,I.cloneAndChange)(c,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(h,c))},t=>{console.error(t)})}publicLog(h,y,c){return this._log(h,3,y,c)}publicLog2(h,y,c){return this.publicLog(h,y,c)}publicLogError(h,y){return this._sendErrorTelemetry?this._log(h,2,y,!0):Promise.resolve(void 0)}publicLogError2(h,y){return this.publicLogError(h,y)}_anonymizeFilePaths(h){let y=h;const c=[];for(const e of this._cleanupPatterns)for(;;){const r=e.exec(h);if(!r)break;c.push([r.index,e.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,t=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(y="";;){const e=t.exec(h);if(!e)break;!s.test(e[0])&&c.every(([r,o])=>e.index<r||e.index>=o)&&(y+=h.substring(n,e.index)+"<REDACTED: user-file-path>",n=t.lastIndex)}return n<h.length&&(y+=h.substr(n)),y}_removePropertiesWithPossibleUserInfo(h){if(!h)return h;const y=h.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of c)if(s.regex.test(y))return`<REDACTED: ${s.label}>`;return h}_cleanupInfo(h,y){let c=h;y&&(c=this._anonymizeFilePaths(c));for(const s of this._cleanupPatterns)c=c.replace(s,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=fe([te(1,a.IConfigurationService),te(2,P.IProductService)],f),i.TelemetryService=f;function v(){const u=(0,p.localize)(0,null,C.default.nameLong),h=C.default.privacyStatementUrl?(0,p.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,p.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=k.isWeb?"":(0,p.localize)(3,null),c=(0,p.localize)(4,null),s=(0,p.localize)(5,null),t=(0,p.localize)(6,null),n=(0,p.localize)(7,null),e=`
|       | ${c} | ${s} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,p.localize)(8,null);return`
${u} ${h} ${y}

&nbsp;

${n}
${e}

&nbsp;

${r}
`}g.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,p.localize)(10,null),(0,p.localize)(11,null),(0,p.localize)(12,null),(0,p.localize)(13,null)],markdownDescription:v(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.Registry.as(d.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,p.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,p.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,p.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[134],ee([0,1,156,131]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OneDataSystemAppender=void 0;class b extends I.AbstractOneDataSystemAppender{constructor(T,p,a,d){const C={sendPOST:(P,g)=>{const E={method:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data)}};try{const l=D.request(P.urlString,E,f=>{f.on("data",function(v){g(f.statusCode??200,f.headers,v.toString())}),f.on("error",function(v){g(0,{})})});l.write(P.data),l.end()}catch{g(0,{})}}};super(T,p,a,d,C)}}i.OneDataSystemAppender=b}),define(Z[135],ee([0,1,14,20]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(k,T){const p=Object.create(null),a=(C,P)=>{const g=JSON.parse(C);p[P]=g};if(T){const C=[],P=await I.Promises.readdir(T);for(const E of P)try{(await I.Promises.stat((0,D.join)(T,E))).isDirectory()&&C.push(E)}catch{}const g=[];for(const E of C)(await I.Promises.readdir((0,D.join)(T,E))).filter(f=>f==="telemetry.json").length===1&&g.push(E);for(const E of g){const l=(await I.Promises.readFile((0,D.join)(T,E,"telemetry.json"))).toString();a(l,E)}}let d=(await I.Promises.readFile((0,D.join)(k,"telemetry-core.json"))).toString();return a(d,"vscode-core"),d=(await I.Promises.readFile((0,D.join)(k,"telemetry-extensions.json"))).toString(),a(d,"vscode-extensions"),JSON.stringify(p,null,4)}i.buildTelemetryMessage=b}),define(Z[28],ee([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Z[136],ee([0,1,4,2,10,17,23,11,9,28]),function(B,i,D,I,b,k,T,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let C=class extends I.Disposable{constructor(g,E,l,f,v){super();this.extensionsManagementService=g,this.logService=f,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(h=>{this.installedExtensions=h.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(h=>this.onInstallExtension(h))),this._register(g.onDidInstallExtensions(h=>this.onDidInstallExtensions(h))),this._register(g.onDidUninstallExtension(h=>this.onDidUninstallExtension(h)));const u=b.URI.file(l.extensionsPath);this._register(E.watch(u)),this._register(D.Event.filter(E.onDidFilesChange,h=>h.rawChanges.some(y=>this.doesChangeAffects(y,u)))(()=>this.onDidChange()))}doesChangeAffects(g,E){return g.type!==1&&g.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),E)?!1:this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(g.resource).startsWith(".")}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const E of g)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(E=>!(0,T.areSameExtensions)(E,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,T.areSameExtensions)(E,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(),E=g.filter(f=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,T.areSameExtensions)(v,f.identifier))?!1:f.installedTimestamp&&f.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",f.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",f.identifier.id),!1)),l=this.installedExtensions.filter(f=>this.installingExtensions.some(v=>(0,T.areSameExtensions)(v,f))?!1:g.every(v=>!(0,T.areSameExtensions)(v.identifier,f))?(this.logService.info("Detected extension removed from another source",f.id),!0):!1);this.installedExtensions=g.map(f=>f.identifier),(E.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:l})}}};C=fe([te(1,p.IFileService),te(2,k.INativeEnvironmentService),te(3,a.ILogService),te(4,d.IUriIdentityService)],C),i.ExtensionsWatcher=C}),define(Z[137],ee([0,1,28,104,11,18,69,4,2]),function(B,i,D,I,b,k,T,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class d{constructor(g){this.uri=g,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let C=class{constructor(g){this._fileService=g,this._dispooables=new a.DisposableStore,this._limit=2**16;const E=new Map,l=f=>{let v=E.get(f.scheme);return v===void 0&&(v=g.hasProvider(f)&&!this._fileService.hasCapability(f,1024),E.set(f.scheme,v)),v};this._dispooables.add(p.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(f=>{E.delete(f.scheme)})),this.extUri=new k.ExtUri(l),this._canonicalUris=new T.SkipList((f,v)=>this.extUri.compare(f,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,k.normalizePath)(g));const E=this._canonicalUris.get(g);return E?E.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new d(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((l,f)=>l[1].touch<f[1].touch?1:l[1].touch>f[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let l=0;l<E;l++)this._canonicalUris.set(g[l][0],g[l][1].touch())}};C=fe([te(0,b.IFileService)],C),i.UriIdentityService=C,(0,I.registerSingleton)(D.IUriIdentityService,C,!0)}),define(Z[138],ee([0,1,100,14,36,18,10,8,16]),function(B,i,D,I,b,k,T,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.hasWorkspaceFileExtension=i.isSavedWorkspace=i.isTemporaryWorkspace=i.isUntitledWorkspace=i.UNTITLED_WORKSPACE_NAME=i.WORKSPACE_FILTER=i.WORKSPACE_EXTENSION=i.toWorkspaceFolder=i.WorkspaceFolder=i.Workspace=i.isWorkspaceFolder=i.isWorkspace=i.WorkbenchState=i.reviveIdentifier=i.isWorkspaceIdentifier=i.toWorkspaceIdentifier=i.isSingleFolderWorkspaceIdentifier=i.IWorkspaceContextService=void 0,i.IWorkspaceContextService=(0,p.createDecorator)("contextService");function d(e){const r=e;return typeof r?.id=="string"&&T.URI.isUri(r.uri)}i.isSingleFolderWorkspaceIdentifier=d;function C(e){if(e.configuration)return{id:e.id,configPath:e.configuration};if(e.folders.length===1)return{id:e.id,uri:e.folders[0].uri}}i.toWorkspaceIdentifier=C;function P(e){const r=e;return typeof r?.id=="string"&&T.URI.isUri(r.configPath)}i.isWorkspaceIdentifier=P;function g(e){const r=e;if(r?.uri)return{id:r.id,uri:T.URI.revive(r.uri)};const o=e;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(e?.id)return{id:e.id}}i.reviveIdentifier=g;var E;(function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"})(E=i.WorkbenchState||(i.WorkbenchState={}));function l(e){const r=e;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}i.isWorkspace=l;function f(e){const r=e;return!!(r&&typeof r=="object"&&T.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}i.isWorkspaceFolder=f;class v{constructor(r,o,m,S,w){this._id=r,this._transient=m,this._configuration=S,this._ignorePathCasing=w,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}i.Workspace=v;class u{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,k.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}i.WorkspaceFolder=u;function h(e){return new u({uri:e,index:0,name:(0,k.basenameOrAuthority)(e)},{uri:e.toString()})}i.toWorkspaceFolder=h,i.WORKSPACE_EXTENSION="code-workspace";const y=`.${i.WORKSPACE_EXTENSION}`;i.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[i.WORKSPACE_EXTENSION]}],i.UNTITLED_WORKSPACE_NAME="workspace.json";function c(e,r){return k.extUriBiasedIgnorePathCase.isEqualOrParent(e,r.untitledWorkspacesHome)}i.isUntitledWorkspace=c;function s(e){let r;return T.URI.isUri(e)?r=e:r=e.configuration,r?.scheme===a.Schemas.tmp}i.isTemporaryWorkspace=s;function t(e,r){return!c(e,r)&&!s(e)}i.isSavedWorkspace=t;function n(e){return(typeof e=="string"?(0,I.extname)(e):(0,k.extname)(e))===y}i.hasWorkspaceFileExtension=n}),define(Z[26],ee([0,1,54,4,2,18,7,10,99,17,11,8,9,138,36,28,3,29]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f,v,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=i.toUserDataProfile=i.EXTENSIONS_RESOURCE_NAME=i.reviveProfile=i.IUserDataProfilesService=i.PROFILES_ENABLEMENT_CONFIG=i.isUserDataProfile=void 0;function h(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&p.URI.isUri(n.location)&&p.URI.isUri(n.globalStorageHome)&&p.URI.isUri(n.settingsResource)&&p.URI.isUri(n.keybindingsResource)&&p.URI.isUri(n.tasksResource)&&p.URI.isUri(n.snippetsHome)&&((0,T.isUndefined)(n.extensionsResource)||p.URI.isUri(n.extensionsResource)))}i.isUserDataProfile=h,i.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",i.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function y(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,location:p.URI.revive(t.location).with({scheme:n}),globalStorageHome:p.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:p.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:p.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:p.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:p.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:p.URI.revive(t.extensionsResource)?.with({scheme:n})}}i.reviveProfile=y,i.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(t,n,e){return{id:(0,D.hash)(n.path).toString(16),name:t,location:n,isDefault:!1,globalStorageHome:(0,k.joinPath)(n,"globalStorage"),settingsResource:(0,k.joinPath)(n,"settings.json"),keybindingsResource:(0,k.joinPath)(n,"keybindings.json"),tasksResource:(0,k.joinPath)(n,"tasks.json"),snippetsHome:(0,k.joinPath)(n,"snippets"),extensionsResource:(0,k.joinPath)(n,i.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:e}}i.toUserDataProfile=c;let s=class extends b.Disposable{constructor(n,e,r,o){super();this.environmentService=n,this.fileService=e,this.uriIdentityService=r,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new I.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new I.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new I.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(m=>c(m.name,m.location,m.useDefaultFlags)):[];let e;const r=new l.ResourceMap;if(n.length){const m=this.getStoredProfileAssociations();if(m.workspaces)for(const[S,w]of Object.entries(m.workspaces)){const L=p.URI.parse(S),U=p.URI.parse(w),$=n.find(q=>this.uriIdentityService.extUri.isEqual(q.location,U));$&&r.set(L,$)}if(m.emptyWindow){const S=p.URI.parse(m.emptyWindow);e=n.find(w=>this.uriIdentityService.extUri.isEqual(w.location,S))}}const o=c((0,a.localize)(0,null),this.environmentService.userRoamingDataHome);n.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0?o.extensionsResource:void 0}),this._profilesObject={profiles:n,workspaces:r,emptyWindow:e}}return this._profilesObject}getProfile(n){const e=this.getWorkspace(n);return(p.URI.isUri(e)?this.profilesObject.workspaces.get(e):this.profilesObject.emptyWindow)??this.defaultProfile}getWorkspace(n){return(0,E.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,E.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}async createProfile(n,e,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(S=>S.name===n))throw new Error(`Profile with name ${n} already exists`);const o=c(n,(0,k.joinPath)(this.profilesHome,(0,D.hash)((0,u.generateUuid)()).toString(16)),e);await this.fileService.createFolder(o.location);const m=[];return this._onWillCreateProfile.fire({profile:o,join(S){m.push(S)}}),await v.Promises.settled(m),this.updateProfiles([o],[],[]),r&&await this.setProfileForWorkspace(o,r),o}async updateProfile(n,e,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(m=>m.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=c(e,o.location,r),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(n,e){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(e,r)}async unsetWorkspace(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n)}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const e=this.profiles.find(o=>o.id===n.id);if(!e)throw new Error(`Profile '${n.name}' does not exist`);const r=[];this._onWillRemoveProfile.fire({profile:e,join(o){r.push(o)}}),await v.Promises.settled(r),e.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])e.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[e],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(e.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(n,e,r){const o=[];for(let m of[...this.profilesObject.profiles,...n])m.isDefault||e.some(S=>m.id===S.id)||(m=r.find(S=>m.id===S.id)??m,o.push({location:m.location,name:m.name,useDefaultFlags:m.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(n,e,r)}triggerProfilesChanges(n,e,r){this._onDidChangeProfiles.fire({added:n,removed:e,updated:r,all:this.profiles})}updateWorkspaceAssociation(n,e){const r=this.getWorkspace(n);p.URI.isUri(r)?(this.profilesObject.workspaces.delete(r),e&&!e.isDefault&&this.profilesObject.workspaces.set(r,e)):this.profilesObject.emptyWindow=e?.isDefault?void 0:e,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[r,o]of this.profilesObject.workspaces.entries())n[r.toString()]=o.location.toString();const e=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:e}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};s.PROFILES_KEY="userDataProfiles",s.PROFILE_ASSOCIATIONS_KEY="profileAssociations",s=fe([te(0,d.IEnvironmentService),te(1,C.IFileService),te(2,f.IUriIdentityService),te(3,g.ILogService)],s),i.UserDataProfilesService=s}),define(Z[139],ee([0,1,19,3,25,12,4,2,13,10,85,22,23,33,9,27,34,26]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f,v,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let h=class extends p.Disposable{constructor(e,r,o,m,S){super();this.galleryService=e,this.telemetryService=r,this.logService=o,this.productService=m,this.userDataProfilesService=S,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,p.toDisposable)(()=>{this.installingExtensions.forEach(w=>w.cancel()),this.uninstallingExtensions.forEach(w=>w.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const r=await this.getTargetPlatform();return e.allTargetPlatforms.some(o=>(0,P.isTargetPlatformCompatible)(o,e.allTargetPlatforms,r))}async installFromGallery(e,r={}){try{if(!this.galleryService.isEnabled())throw new P.ExtensionManagementError(C.localize(0,null),P.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(e,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(e),error:o}),this.logService.error("Failed to install extension.",e.identifier.id),this.logService.error(o),c(o)}}async uninstall(e,r={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.uninstallExtension(e,r)}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...e.identifier,preRelease:e.preRelease}],{targetPlatform:r,compatible:!0},b.CancellationToken.None);if(!o)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(e,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.extensionsControlManifest||e-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=e),this.extensionsControlManifest}registerParticipant(e){this.participants.push(e)}async installExtension(e,r,o){const m=$=>`${g.ExtensionKey.create($).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!d.URI.isUri(r)){const $=this.installingExtensions.get(m(r));if($){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:q}=await $.waitUntilTaskIsFinished();return q}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const S=[],w=[],L=this.createInstallExtensionTask(e,r,o);d.URI.isUri(r)||this.installingExtensions.set(m(r),L),this._onInstallExtension.fire({identifier:L.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",L.identifier.id),S.push({task:L,manifest:e});let U=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",L.identifier.id);else try{const q=await this.getAllDepsAndPackExtensionsToInstall(L.identifier,e,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:Y,manifest:ne}of q){U=U||!!ne.extensionDependencies?.some(re=>(0,g.areSameExtensions)({id:re},L.identifier));const ce=m(Y);if(this.installingExtensions.has(ce))this.logService.info("Extension is already requested to install",Y.identifier.id);else{const re=this.createInstallExtensionTask(ne,Y,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ce,re),this._onInstallExtension.fire({identifier:re.identifier,source:Y,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",re.identifier.id),S.push({task:re,manifest:ne})}}}catch(q){if(d.URI.isUri(L.source))(0,D.isNonEmptyArray)(e.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",L.identifier.id,q.message),(0,D.isNonEmptyArray)(e.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",L.identifier.id,q.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",L.identifier.id),q}const $=S.reduce((q,{task:Y,manifest:ne})=>(q.set(Y.identifier.id.toLowerCase(),{task:Y,manifest:ne}),q),new Map);for(;$.size;){let q;const Y=[...$.values()].filter(({manifest:ne})=>!ne.extensionDependencies?.some(ce=>$.has(ce.toLowerCase())));Y.length?q=$.size===1?Y:Y.filter(({task:ne})=>!(ne===L&&!U)):(this.logService.info("Found extensions with circular dependencies",Y.map(({task:ne})=>ne.identifier.id)),q=[...$.values()]),await this.joinAllSettled(q.map(async({task:ne})=>{const ce=new Date().getTime();try{const{local:re}=await ne.run();if(await this.joinAllSettled(this.participants.map(ge=>ge.postInstall(re,ne.source,o,b.CancellationToken.None))),!d.URI.isUri(ne.source)){const ge=ne.operation===3,ae=ge?void 0:(new Date().getTime()-ne.source.lastUpdated)/1e3;if(s(this.telemetryService,ge?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ne.source),duration:new Date().getTime()-ce,durationSinceUpdate:ae}),a.isWeb&&ne.operation!==3)try{await this.galleryService.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}w.push({local:re,identifier:ne.identifier,operation:ne.operation,source:ne.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw d.URI.isUri(ne.source)||s(this.telemetryService,ne.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ne.source),duration:new Date().getTime()-ce,error:re}),this.logService.error("Error while installing the extension:",ne.identifier.id),re}finally{$.delete(ne.identifier.id.toLowerCase())}}))}return w.forEach(({identifier:q})=>this.logService.info("Extension installed successfully:",q.id)),this._onDidInstallExtensions.fire(w),w.filter(({identifier:q})=>(0,g.areSameExtensions)(q,L.identifier))[0].local}catch($){if(S.forEach(({task:q})=>q.cancel()),w.length)try{const q=await Promise.allSettled(w.map(({local:Y})=>this.createUninstallExtensionTask(Y,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let Y=0;Y<q.length;Y++){const ne=q[Y],{identifier:ce}=w[Y];ne.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ce.id):this.logService.warn("Rollback: Error while uninstalling extension",ce.id,(0,k.getErrorMessage)(ne.reason))}}catch(q){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(q),w.map(({identifier:Y})=>Y.id))}throw this._onDidInstallExtensions.fire(S.map(({task:q})=>({identifier:q.identifier,operation:2,source:q.source,context:o.context,profileLocation:o.profileLocation}))),$}finally{for(const{task:$}of S)if(!d.URI.isUri($.source)){const q=m($.source);this.installingExtensions.delete(q)||this.logService.warn("Installation task is not found in the cache",q)}}}async joinAllSettled(e){const r=[],o=[],m=await Promise.allSettled(e);for(const S of m)S.status==="fulfilled"?r.push(S.value):o.push(S.reason);if(o.length)throw y(o);return r}async getAllDepsAndPackExtensionsToInstall(e,r,o,m,S){if(!this.galleryService.isEnabled())return[];let w=await this.getInstalled(void 0,S);const L=[e,...w.map(q=>q.identifier)],U=[],$=async(q,Y)=>{const ne=Y.extensionDependencies||[],ce=[...ne];if(Y.extensionPack){const re=o?w.find(ge=>(0,g.areSameExtensions)(ge.identifier,q)):void 0;for(const ge of Y.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ae=>(0,g.areSameExtensions)({id:ae},{id:ge}))||ce.every(ae=>!(0,g.areSameExtensions)({id:ae},{id:ge}))&&ce.push(ge)}if(ce.length){const re=[...L,...U.map(ae=>ae.gallery.identifier)],ge=ce.filter(ae=>re.every(N=>!(0,g.areSameExtensions)(N,{id:ae})));if(ge.length){const ae=await this.galleryService.getExtensions(ge.map(N=>({id:N,preRelease:m})),b.CancellationToken.None);for(const N of ae){if(re.find(A=>(0,g.areSameExtensions)(A,N.identifier)))continue;const _=ne.some(A=>(0,g.areSameExtensions)({id:A},N.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(N,!1,m)}catch(A){if(A instanceof P.ExtensionManagementError&&A.code===P.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!_){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}else throw A}U.push({gallery:M.extension,manifest:M.manifest}),await $(M.extension.identifier,M.manifest)}}}};return await $(e,r),w=await this.getInstalled(void 0,S),U.filter(q=>!w.some(Y=>(0,g.areSameExtensions)(Y.identifier,q.gallery.identifier)))}async checkAndGetCompatibleVersion(e,r,o){if((await this.getExtensionsControlManifest()).malicious.some(L=>(0,g.areSameExtensions)(e.identifier,L)))throw new P.ExtensionManagementError(C.localize(3,null,e.identifier.id),P.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(e)){const L=await this.getTargetPlatform();throw new P.ExtensionManagementError(C.localize(4,null,e.identifier.id,this.productService.nameLong,(0,P.TargetPlatformToString)(L)),P.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const S=await this.getCompatibleVersion(e,r,o);if(S){if(o&&!r&&e.hasPreReleaseVersion&&!S.properties.isPreReleaseVersion)throw new P.ExtensionManagementError(C.localize(5,null,e.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&e.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([e.identifier],b.CancellationToken.None))[0]?new P.ExtensionManagementError(C.localize(6,null,e.identifier.id),P.ExtensionManagementErrorCode.ReleaseVersionNotFound):new P.ExtensionManagementError(C.localize(7,null,e.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",S.identifier.id);const w=await this.galleryService.getManifest(S,b.CancellationToken.None);if(w===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${e.identifier.id}`,P.ExtensionManagementErrorCode.Invalid);if(w.version!==S.version)throw new P.ExtensionManagementError(`Cannot install '${e.identifier.id}' extension because of version mismatch in Marketplace`,P.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:w}}async getCompatibleVersion(e,r,o){const m=await this.getTargetPlatform();let S=null;return!r&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==o&&(S=(await this.galleryService.getExtensions([{...e.identifier,preRelease:o}],{targetPlatform:m,compatible:!0},b.CancellationToken.None))[0]||null),!S&&await this.galleryService.isExtensionCompatible(e,o,m)&&(S=e),S||(r?S=(await this.galleryService.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:m,compatible:!0},b.CancellationToken.None))[0]||null:S=await this.galleryService.getCompatibleExtension(e,o,m)),S}async uninstallExtension(e,r){const o=$=>`${$.id.toLowerCase()}${r.versionOnly?`-${e.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,m=this.uninstallingExtensions.get(o(e.identifier));if(m)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),m.waitUntilTaskIsFinished();const S=($,q)=>{const Y=this.createUninstallExtensionTask($,q);return this.uninstallingExtensions.set(o(Y.extension.identifier),Y),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this._onUninstallExtension.fire({identifier:$.identifier,profileLocation:r.profileLocation,applicationScoped:$.isApplicationScoped}),Y},w=($,q)=>{q?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,r.profileLocation.toString(),q.message):this.logService.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,q.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)($),error:q}),this._onDidUninstallExtension.fire({identifier:$.identifier,version:$.manifest.version,error:q?.code,profileLocation:r.profileLocation,applicationScoped:$.isApplicationScoped})},L=[],U=[];try{L.push(S(e,r));const $=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${e.identifier.id}@${e.manifest.version}`);else{const q=this.getAllPackExtensionsToUninstall(e,$);for(const Y of q)this.uninstallingExtensions.has(o(Y.identifier))?this.logService.info("Extensions is already requested to uninstall",Y.identifier.id):L.push(S(Y,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${e.identifier.id}@${e.manifest.version}`):this.checkForDependents(L.map(q=>q.extension),$,e),await this.joinAllSettled(L.map(async q=>{try{if(await q.run(),await this.joinAllSettled(this.participants.map(Y=>Y.postUninstall(q.extension,r,b.CancellationToken.None))),q.extension.identifier.uuid)try{await this.galleryService.reportStatistic(q.extension.manifest.publisher,q.extension.manifest.name,q.extension.manifest.version,"uninstall")}catch{}w(q.extension)}catch(Y){const ne=Y instanceof P.ExtensionManagementError?Y:new P.ExtensionManagementError((0,k.getErrorMessage)(Y),P.ExtensionManagementErrorCode.Internal);throw w(q.extension,ne),ne}finally{U.push(q)}}))}catch($){const q=$ instanceof P.ExtensionManagementError?$:new P.ExtensionManagementError((0,k.getErrorMessage)($),P.ExtensionManagementErrorCode.Internal);for(const Y of L){try{Y.cancel()}catch{}U.includes(Y)||w(Y.extension,q)}throw q}finally{for(const $ of L)this.uninstallingExtensions.delete(o($.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}checkForDependents(e,r,o){for(const m of e){const S=this.getDependents(m,r);if(S.length){const w=S.filter(L=>!e.some(U=>(0,g.areSameExtensions)(U.identifier,L.identifier)));if(w.length)throw new Error(this.getDependentsErrorMessage(m,w,o))}}}getDependentsErrorMessage(e,r,o){return o===e?r.length===1?C.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(11,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(12,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(13,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(e,r,o=[]){if(o.indexOf(e)!==-1)return[];o.push(e);const m=e.manifest.extensionPack?e.manifest.extensionPack:[];if(m.length){const S=r.filter(L=>!L.isBuiltin&&m.some(U=>(0,g.areSameExtensions)({id:U},L.identifier))),w=[];for(const L of S)w.push(...this.getAllPackExtensionsToUninstall(L,r,o));return[...S,...w]}return[]}getDependents(e,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(m=>(0,g.areSameExtensions)({id:m},e.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",e),e}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(e,r,o){return o.profileLocation&&(0,E.isApplicationScopedExtension)(e)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(e,r,o)}createUninstallExtensionTask(e,r){return r.profileLocation&&e.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(e,r)}};h=fe([te(0,P.IExtensionGalleryService),te(1,v.ITelemetryService),te(2,l.ILogService),te(3,f.IProductService),te(4,u.IUserDataProfilesService)],h),i.AbstractExtensionManagementService=h;function y(n){const e=Array.isArray(n)?n:[n];return e.length===1?e[0]instanceof Error?e[0]:new Error(e[0]):e.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}i.joinErrors=y;function c(n){if(n instanceof P.ExtensionManagementError)return n;const e=new P.ExtensionManagementError(n.message,P.ExtensionManagementErrorCode.Internal);return e.stack=n.stack,e}function s(n,e,{extensionData:r,duration:o,error:m,durationSinceUpdate:S}){const w=m?m instanceof P.ExtensionManagementError?m.code:P.ExtensionManagementErrorCode.Internal:void 0;n.publicLog(e,{...r,success:!m,duration:o,errorcode:w,durationSinceUpdate:S})}i.reportTelemetry=s;class t{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(e=>new Promise((r,o)=>{const m=e.onCancellationRequested(()=>{m.dispose(),o(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=t}),define(Z[49],ee([0,1,19,3,24,15,12,51,75,2,16,14,13,18,38,55,7,10,88,17,23,33,46,11,8,9,27,4,43,40,26,28]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f,v,u,h,y,c,s,t,n,e,r,o,m,S,w,L,U){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var $;(function(ae){function N(_,M){if(_===M)return!0;const A=Object.keys(_),W=new Set;for(const G of Object.keys(M))W.add(G);if(A.length!==W.size)return!1;for(const G of A){if(_[G]!==M[G])return!1;W.delete(G)}return W.size===0}ae.equals=N})($=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,e.createDecorator)("IExtensionsScannerService");let q=class extends d.Disposable{constructor(N,_,M,A,W,G,Q,F,V,R,O){super();this.systemExtensionsLocation=N,this.userExtensionsLocation=_,this.extensionsControlLocation=M,this.cacheLocation=A,this.userDataProfilesService=W,this.extensionsProfileScannerService=G,this.fileService=Q,this.logService=F,this.environmentService=V,this.productService=R,this.instantiationService=O,this._onDidChangeCache=this._register(new m.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,E.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ce,(0,E.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ce,(0,E.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ne,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(N,_){const[M,A]=await Promise.all([this.scanSystemExtensions(N),this.scanUserExtensions(_)]),W=await this.scanExtensionsUnderDevelopment(N,[...M,...A]);return this.dedupExtensions(M,A,W,await this.getTargetPlatform(),!0)}async scanSystemExtensions(N){const _=[];_.push(this.scanDefaultSystemExtensions(!!N.useCache,N.language)),_.push(this.scanDevSystemExtensions(N.language,!!N.checkControlFile));const[M,A]=await Promise.all(_);return this.applyScanOptions([...M,...A],0,N,!1)}async scanUserExtensions(N){this.logService.trace("Started scanning user extensions");const _=await this.createExtensionScannerInput(N.profileLocation??this.userExtensionsLocation,!!N.profileLocation,1,!N.includeUninstalled,N.language);let A=await(N.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(_);return A=await this.applyScanOptions(A,1,N,!0),this.logService.trace("Scanned user extensions:",A.length),A}async scanExtensionsUnderDevelopment(N,_){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const M=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(A=>A.scheme===C.Schemas.file).map(async A=>{const W=await this.createExtensionScannerInput(A,!1,1,!0,N.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(W)).map(Q=>(Q.type=_.find(F=>(0,c.areSameExtensions)(F.identifier,Q.identifier))?.type??Q.type,this.extensionsScanner.validate(Q,W)))}))).flat();return this.applyScanOptions(M,"development",N,!0)}return[]}async scanExistingExtension(N,_,M){const A=await this.createExtensionScannerInput(N,!1,_,!0,M.language),W=await this.extensionsScanner.scanExtension(A);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(N,_,M){const A=await this.createExtensionScannerInput(N,!1,_,!0,M.language),W=await this.extensionsScanner.scanOneOrMultipleExtensions(A);return this.applyScanOptions(W,_,M,!0)}async scanMetadata(N){const _=(0,E.joinPath)(N,"package.json"),M=(await this.fileService.readFile(_)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(N,_){const M=(0,E.joinPath)(N,"package.json"),A=(await this.fileService.readFile(M)).value.toString(),W=JSON.parse(A);_.isMachineScoped=_.isMachineScoped||void 0,_.isBuiltin=_.isBuiltin||void 0,_.installedTimestamp=_.installedTimestamp||void 0,W.__metadata={...W.__metadata,..._},await this.fileService.writeFile((0,E.joinPath)(N,"package.json"),k.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async applyScanOptions(N,_,M,A){return M.includeAllVersions||(N=this.dedupExtensions(_===0?N:void 0,_===1?N:void 0,_==="development"?N:void 0,await this.getTargetPlatform(),A)),M.includeInvalid||(N=N.filter(W=>W.isValid)),N.sort((W,G)=>{const Q=P.basename(W.location.fsPath),F=P.basename(G.location.fsPath);return Q<F?-1:Q>F?1:0})}dedupExtensions(N,_,M,A,W){const G=(F,V,R)=>{if(F.isValid&&!V.isValid)return!1;if(F.isValid===V.isValid){if(W&&l.gt(F.manifest.version,V.manifest.version))return this.logService.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${F.location.path} with version ${F.manifest.version}`),!1;if(l.eq(F.manifest.version,V.manifest.version)){if(F.type===0)return this.logService.debug(`Skipping extension ${V.location.path} in favour of system extension ${F.location.path} with same version`),!1;if(F.targetPlatform===A)return this.logService.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return R?this.logService.warn(`Overwriting user extension ${F.location.path} with ${V.location.path}.`):this.logService.debug(`Overwriting user extension ${F.location.path} with ${V.location.path}.`),!0},Q=new Map;return N?.forEach(F=>{const V=s.ExtensionIdentifier.toKey(F.identifier.id),R=Q.get(V);(!R||G(R,F,!1))&&Q.set(V,F)}),_?.forEach(F=>{const V=s.ExtensionIdentifier.toKey(F.identifier.id),R=Q.get(V);if(!R&&N&&F.type===0){this.logService.debug(`Skipping obsolete system extension ${F.location.path}.`);return}(!R||G(R,F,!1))&&Q.set(V,F)}),M?.forEach(F=>{const V=s.ExtensionIdentifier.toKey(F.identifier.id),R=Q.get(V);(!R||G(R,F,!0))&&Q.set(V,F),Q.set(V,F)}),[...Q.values()]}async scanDefaultSystemExtensions(N,_){this.logService.trace("Started scanning system extensions");const M=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,_),W=await(N&&!M.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(M);return this.logService.trace("Scanned system extensions:",W.length),W}async scanDevSystemExtensions(N,_){const M=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!M?.length)return[];this.logService.trace("Started scanning dev system extensions");const A=_?await this.getBuiltInExtensionControl():{},W=[],G=u.URI.file(P.normalize(P.join(C.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const F of M){const V=A[F.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":W.push((0,E.joinPath)(G,F.name));break;default:W.push(u.URI.file(V));break}}const Q=await Promise.all(W.map(async F=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(F,!1,0,!0,N))));return this.logService.trace("Scanned dev system extensions:",Q.length),(0,D.coalesce)(Q)}async getBuiltInExtensionControl(){try{const N=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(N.value.toString())}catch{return{}}}async createExtensionScannerInput(N,_,M,A,W,G=!0){const Q=await this.getTranslations(W??g.language),F=await this.getMtime(N),V=_?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,R=V?await this.getMtime(V):void 0;return new Y(N,F,V,R,_,M,A,G,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,W,Q)}async getMtime(N){try{const _=await this.fileService.stat(N);if(typeof _.mtime=="number")return _.mtime}catch{}}};q=fe([te(4,L.IUserDataProfilesService),te(5,w.IExtensionsProfileScannerService),te(6,n.IFileService),te(7,r.ILogService),te(8,y.IEnvironmentService),te(9,o.IProductService),te(10,e.IInstantiationService)],q),i.AbstractExtensionsScannerService=q;class Y{constructor(N,_,M,A,W,G,Q,F,V,R,O,x,j,H){this.location=N,this.mtime=_,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=A,this.profile=W,this.type=G,this.excludeObsolete=Q,this.validate=F,this.productVersion=V,this.productDate=R,this.productCommit=O,this.devMode=x,this.language=j,this.translations=H}static createNlsConfiguration(N){return{language:N.language,pseudo:N.language==="pseudo",devMode:N.devMode,translations:N.translations}}static equals(N,_){return(0,E.isEqual)(N.location,_.location)&&N.mtime===_.mtime&&(0,E.isEqual)(N.applicationExtensionslocation,_.applicationExtensionslocation)&&N.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&N.profile===_.profile&&N.type===_.type&&N.excludeObsolete===_.excludeObsolete&&N.validate===_.validate&&N.productVersion===_.productVersion&&N.productDate===_.productDate&&N.productCommit===_.productCommit&&N.devMode===_.devMode&&N.language===_.language&&$.equals(N.translations,_.translations)}}let ne=class extends d.Disposable{constructor(N,_,M,A,W){super();this.obsoleteFile=N,this.extensionsProfileScannerService=_,this.uriIdentityService=M,this.fileService=A,this.logService=W}async scanExtensions(N){const _=N.profile?await this.scanExtensionsFromProfile(N):await this.scanExtensionsFromLocation(N);let M={};if(N.excludeObsolete&&N.type===1)try{const A=(await this.fileService.readFile(this.obsoleteFile)).value.toString();M=JSON.parse(A)}catch{}return(0,v.isEmptyObject)(M)?_:_.filter(A=>!M[c.ExtensionKey.create(A).toString()])}async scanExtensionsFromLocation(N){const _=await this.fileService.resolve(N.location);if(!_.children?.length)return[];const M=await Promise.all(_.children.map(async A=>{if(!A.isDirectory||N.type===1&&(0,E.basename)(A.resource).indexOf(".")===0)return null;const W=new Y(A.resource,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(W)}));return(0,D.coalesce)(M).sort((A,W)=>A.location.path<W.location.path?-1:1)}async scanExtensionsFromProfile(N){let _=await this.scanExtensionsFromProfileResource(N.location,()=>!0,N);if(N.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(N.location,N.applicationExtensionslocation)){_=_.filter(A=>!A.metadata?.isApplicationScoped);const M=await this.scanExtensionsFromProfileResource(N.applicationExtensionslocation,A=>!!A.metadata?.isApplicationScoped,N);_.push(...M)}return _}async scanExtensionsFromProfileResource(N,_,M){const A=await this.extensionsProfileScannerService.scanProfileExtensions(N);if(!A.length)return[];const W=await Promise.all(A.map(async G=>{if(_(G)){const Q=new Y(G.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(Q,G.metadata)}return null}));return(0,D.coalesce)(W)}async scanOneOrMultipleExtensions(N){try{if(await this.fileService.exists((0,E.joinPath)(N.location,"package.json"))){const _=await this.scanExtension(N);return _?[_]:[]}else return await this.scanExtensions(N)}catch(_){return this.logService.error(`Error scanning extensions at ${N.location.path}:`,(0,T.getErrorMessage)(_)),[]}}async scanExtension(N,_){try{let M=await this.scanExtensionManifest(N.location);if(M){M.publisher||(M.publisher=s.UNDEFINED_PUBLISHER),_=_??M.__metadata,delete M.__metadata;const A=(0,c.getGalleryExtensionId)(M.publisher,M.name),W=_?.id?{id:A,uuid:_.id}:{id:A},G=_?.isSystem?0:N.type,Q=G===0||!!_?.isBuiltin;M=await this.translateManifest(N.location,M,Y.createNlsConfiguration(N));const F={type:G,identifier:W,manifest:M,location:N.location,isBuiltin:Q,targetPlatform:_?.targetPlatform??"undefined",metadata:_,isValid:!0,validations:[]};return N.validate?this.validate(F,N):F}}catch(M){N.type!==0&&this.logService.error(M)}return null}validate(N,_){let M=!0;const A=(0,t.validateExtensionManifest)(_.productVersion,_.productDate,_.location,N.manifest,N.isBuiltin);for(const[W,G]of A)W===f.default.Error&&(M=!1,this.logService.error(this.formatMessage(_.location,G)));return N.isValid=M,N.validations=A,N}async scanExtensionManifest(N){const _=(0,E.joinPath)(N,"package.json");let M;try{M=(await this.fileService.readFile(_)).value.toString()}catch(W){return(0,n.toFileOperationResult)(W)!==1&&this.logService.error(this.formatMessage(N,(0,h.localize)(0,null,_.path,W.message))),null}let A;try{A=JSON.parse(M)}catch{const G=[];(0,p.parse)(M,G);for(const Q of G)this.logService.error(this.formatMessage(N,(0,h.localize)(1,null,_.path,Q.offset,Q.length,(0,a.getParseErrorMessage)(Q.error))));return null}return(0,p.getNodeType)(A)!=="object"?(this.logService.error(this.formatMessage(N,(0,h.localize)(2,null,_.path))),null):A}async translateManifest(N,_,M){const A=await this.getLocalizedMessages(N,_,M);if(A)try{const W=[],G=await this.resolveOriginalMessageBundle(A.default,W);if(W.length>0)return W.forEach(F=>{this.logService.error(this.formatMessage(N,(0,h.localize)(3,null,A.default?.path,(0,a.getParseErrorMessage)(F.error))))}),_;if((0,p.getNodeType)(A)!=="object")return this.logService.error(this.formatMessage(N,(0,h.localize)(4,null,A.default?.path))),_;const Q=A.values||Object.create(null);this.replaceNLStrings(M.pseudo,_,Q,G,N)}catch{}return _}async getLocalizedMessages(N,_,M){const A=(0,E.joinPath)(N,"package.nls.json"),W=(V,R)=>{R.forEach(O=>{this.logService.error(this.formatMessage(N,(0,h.localize)(5,null,V?.path,(0,a.getParseErrorMessage)(O.error))))})},G=V=>{this.logService.error(this.formatMessage(N,(0,h.localize)(6,null,V?.path)))},Q=`${_.publisher}.${_.name}`,F=M.translations[Q];if(F)try{const V=u.URI.file(F),R=(await this.fileService.readFile(V)).value.toString(),O=[],x=(0,p.parse)(R,O);return O.length>0?(W(V,O),{values:void 0,default:A}):(0,p.getNodeType)(x)!=="object"?(G(V),{values:void 0,default:A}):{values:x.contents?x.contents.package:void 0,default:A}}catch{return{values:void 0,default:A}}else{if(!await this.fileService.exists(A))return;let R;try{R=await this.findMessageBundles(N,M)}catch{return}if(!R.localized)return{values:void 0,default:R.original};try{const O=(await this.fileService.readFile(R.localized)).value.toString(),x=[],j=(0,p.parse)(O,x);return x.length>0?(W(R.localized,x),{values:void 0,default:R.original}):(0,p.getNodeType)(j)!=="object"?(G(R.localized),{values:void 0,default:R.original}):{values:j,default:R.original}}catch{return{values:void 0,default:R.original}}}}async resolveOriginalMessageBundle(N,_){if(N)try{const M=(await this.fileService.readFile(N)).value.toString();return(0,p.parse)(M,_)}catch{return null}else return null}findMessageBundles(N,_){return new Promise((M,A)=>{const W=G=>{const Q=(0,E.joinPath)(N,`package.nls.${G}.json`);this.fileService.exists(Q).then(F=>{F&&M({localized:Q,original:(0,E.joinPath)(N,"package.nls.json")});const V=G.lastIndexOf("-");V===-1?M({localized:(0,E.joinPath)(N,"package.nls.json"),original:null}):(G=G.substring(0,V),W(G))})};if(_.devMode||_.pseudo||!_.language)return M({localized:(0,E.joinPath)(N,"package.nls.json"),original:null});W(_.language)})}replaceNLStrings(N,_,M,A,W){const G=(Q,F,V)=>{const R=Q[F];if((0,v.isString)(R)){const O=R,x=O.length;if(x>1&&O[0]==="%"&&O[x-1]==="%"){const j=O.substr(1,x-2);let H=M[j];H===void 0&&A&&(H=A[j]);let X=typeof H=="string"?H:H.message;if(X!==void 0)if(N&&(X="\uFF3B"+X.replace(/[aouei]/g,"$&$&")+"\uFF3D"),V&&A&&(F==="title"||F==="category")){const oe=A[j],le={value:X,original:typeof oe=="string"?oe:oe?.message};Q[F]=le}else Q[F]=X;else this.logService.warn(this.formatMessage(W,(0,h.localize)(7,null,j)))}}else if((0,v.isObject)(R))for(const O in R)R.hasOwnProperty(O)&&(O==="commands"?G(R,O,!0):G(R,O,V));else if((0,v.isArray)(R))for(let O=0;O<R.length;O++)G(R,O,V)};for(const Q in _)_.hasOwnProperty(Q)&&G(_,Q)}formatMessage(N,_){return`[${N.path}]: ${_}`}};ne=fe([te(1,w.IExtensionsProfileScannerService),te(2,U.IUriIdentityService),te(3,n.IFileService),te(4,r.ILogService)],ne);let ce=class extends ne{constructor(N,_,M,A,W,G){super(_,M,A,W,G);this.cacheFile=N,this.cacheValidatorThrottler=this._register(new I.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new m.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(N){const _=await this.readExtensionCache();if(this.input=N,_&&_.input&&Y.equals(_.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),_.result.map(A=>(A.location=u.URI.revive(A.location),A));const M=await super.scanExtensions(N);return await this.writeExtensionCache({input:N,result:M}),M}async readExtensionCache(){try{const N=await this.fileService.readFile(this.cacheFile),_=JSON.parse(N.value.toString());return{result:_.result,input:(0,S.revive)(_.input)}}catch(N){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(N))}return null}async writeExtensionCache(N){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(N)))}catch(_){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(_))}}async validateCache(){if(!this.input)return;const N=await this.readExtensionCache();if(!N)return;const _=N.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!b.equals(M,_))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(A){this.logService.error(A)}}};ce=fe([te(2,w.IExtensionsProfileScannerService),te(3,U.IUriIdentityService),te(4,n.IFileService),te(5,r.ILogService)],ce);function re(ae,N){const _=(0,c.getExtensionId)(ae.manifest.publisher,ae.manifest.name);return{id:_,identifier:new s.ExtensionIdentifier(_),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:N,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}i.toExtensionDescription=re;class ge extends q{constructor(N,_,M,A,W,G,Q,F,V,R,O){super(N,_,(0,E.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,E.joinPath)(A,s.MANIFEST_CACHE_FOLDER),W,G,Q,F,V,R,O);this.translationsPromise=(async()=>{if(g.translationsConfigFile)try{const x=await this.fileService.readFile(u.URI.file(g.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(N){return this.translationsPromise}}i.NativeExtensionsScannerService=ge}),define(Z[140],ee([0,1,45,3,30,4,2,16,14,20,9,26]),function(B,i,D,I,b,k,T,p,a,d,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let g=class extends T.Disposable{constructor(l,f){super();this.userDataProfilesService=l,this.logService=f,this.processesLimiter=new I.Limiter(5)}async postUninstall(l){const f=this.parseScript(l,"uninstall");return f&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(f.script,"uninstall",f.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${v}`)))),d.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(l,f){const v=`vscode:${f}`;if(l.location.scheme===p.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[v]=="string"){const u=l.manifest.scripts[v].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${v} should be a node script`),null):{script:(0,a.join)(l.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(l,f,v,u,h){return new Promise((y,c)=>{const s=this.start(l,f,v,h);let t;const n=e=>{t&&(clearTimeout(t),t=null),e?c(e):y(void 0)};s.on("error",e=>{n((0,b.toErrorMessage)(e)||"Unknown")}),s.on("exit",(e,r)=>{n(e?`post-${f} process exited with code ${e}`:void 0)}),u&&(t=setTimeout(()=>{t=null,s.kill(),c("timed out")},5e3))})}start(l,f,v,u){const h={silent:!0,execArgv:void 0},y=(0,D.fork)(l,[`--type=extension-post-${f}`,...v],h);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const c=k.Event.fromNodeEventEmitter(y.stdout,"data"),s=k.Event.fromNodeEventEmitter(y.stderr,"data");c(e=>this.logService.info(u.identifier.id,u.manifest.version,`post-${f}`,e)),s(e=>this.logService.error(u.identifier.id,u.manifest.version,`post-${f}`,e));const t=k.Event.any(k.Event.map(c,e=>({data:`%c${e}`,format:[""]})),k.Event.map(s,e=>({data:`%c${e}`,format:["color: red"]})));return k.Event.debounce(t,(e,r)=>e?{data:e.data+r.data,format:[...e.format,...r.format]}:{data:r.data,format:r.format},100)(e=>{console.group(u.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),y}getExtensionStoragePath(l){return(0,a.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};g=fe([te(0,P.IUserDataProfilesService),te(1,C.ILogService)],g),i.ExtensionsLifecycle=g}),define(Z[141],ee([0,1,10,17,40,49,11,8,9,27,26]),function(B,i,D,I,b,k,T,p,a,d,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let P=class extends k.NativeExtensionsScannerService{constructor(E,l,f,v,u,h,y){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,D.URI.file(u.userDataPath),E,l,f,v,u,h,y)}};P=fe([te(0,C.IUserDataProfilesService),te(1,b.IExtensionsProfileScannerService),te(2,T.IFileService),te(3,a.ILogService),te(4,I.INativeEnvironmentService),te(5,d.IProductService),te(6,p.IInstantiationService)],P),i.ExtensionsScannerService=P}),define(Z[142],ee([0,1,3,4,2,112,7,78,8,26]),function(B,i,D,I,b,k,T,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.isProfileUsingDefaultStorage=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";i.IStorageService=(0,a.createDecorator)("storageService");var P;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(P=i.WillSaveStateReason||(i.WillSaveStateReason={}));var g;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(g=i.StorageScope||(i.StorageScope={}));var E;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(E=i.StorageTarget||(i.StorageTarget={}));class l extends b.Disposable{constructor(y={flushInterval:l.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,c){if(c===C){switch(y){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:y})}else this._onDidChangeValue.fire({scope:y,key:c,target:this.getKeyTargets(y)[c]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,c,s){return this.getStorage(c)?.get(y,s)}getBoolean(y,c,s){return this.getStorage(c)?.getBoolean(y,s)}getNumber(y,c,s){return this.getStorage(c)?.getNumber(y,s)}store(y,c,s,t){if((0,T.isUndefinedOrNull)(c)){this.remove(y,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,s,t),this.getStorage(s)?.set(y,c)})}remove(y,c){this.withPausedEmitters(()=>{this.updateKeyTarget(y,c,void 0),this.getStorage(c)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,c){const s=[],t=this.getKeyTargets(y);for(const n of Object.keys(t))t[n]===c&&s.push(n);return s}updateKeyTarget(y,c,s){const t=this.getKeyTargets(c);typeof s=="number"?t[y]!==s&&(t[y]=s,this.getStorage(c)?.set(C,JSON.stringify(t))):typeof t[y]=="number"&&(delete t[y],this.getStorage(c)?.set(C,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(y){switch(y){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(y){const c=this.get(C,y);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}isNew(y){return this.getBoolean(i.IS_NEW_KEY,y)===!0}async flush(y=P.NONE){this._onWillSaveState.fire({reason:y});const c=this.getStorage(-1),s=this.getStorage(0),t=this.getStorage(1);switch(y){case P.NONE:await D.Promises.settled([c?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await D.Promises.settled([c?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.getStorage(-1)?.items??new Map,c=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return u(y,c,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(y,c){return this.emitWillSaveState(P.NONE),(0,d.isUserDataProfile)(y)?this.switchToProfile(y,c):this.switchToWorkspace(y,c)}canSwitchProfile(y,c){return!(y.id===c.id||f(c)&&f(y))}switchData(y,c,s,t){this.withPausedEmitters(()=>{if(t)for(const[n,e]of y)c.set(n,e);else{const n=new Set;for(const[e,r]of y)n.add(e),c.get(e)!==r&&this.emitDidChangeValue(s,e);for(const[e]of c.items)n.has(e)||this.emitDidChangeValue(s,e)}})}}i.AbstractStorageService=l,l.DEFAULT_FLUSH_INTERVAL=60*1e3;function f(h){return h.isDefault||!!h.useDefaultFlags?.uiState}i.isProfileUsingDefaultStorage=f;class v extends l{constructor(){super();this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.profileStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y))),this._register(this.applicationStorage.onDidChangeStorage(y=>this.emitDidChangeValue(-1,y)))}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}i.InMemoryStorageService=v;async function u(h,y,c,s,t,n){const e=q=>{try{return JSON.parse(q)}catch{return q}},r=new Map,o=new Map;h.forEach((q,Y)=>{r.set(Y,q),o.set(Y,e(q))});const m=new Map,S=new Map;y.forEach((q,Y)=>{m.set(Y,q),S.set(Y,e(q))});const w=new Map,L=new Map;c.forEach((q,Y)=>{w.set(Y,q),L.set(Y,e(q))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const U=[];if(r.forEach((q,Y)=>{U.push({key:Y,value:q})}),console.table(U),console.groupEnd(),console.log(o),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const q=[];m.forEach((Y,ne)=>{q.push({key:ne,value:Y})}),console.table(q),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${n})`);const $=[];w.forEach((q,Y)=>{$.push({key:Y,value:q})}),console.table($),console.groupEnd(),console.log(L)}i.logStorage=u}),define(Z[143],ee([0,1,19,25,12,13,35,7,10,21,17,22,23,46,11,9,27,48,130,142,34]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f,v,u,h,y,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const s=k.isWeb?"web":(0,P.getTargetPlatform)(k.platform,T.arch);var t;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...R){return String(R.reduce((O,x)=>O|x,0))}var e;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(e||(e={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(O=S){this.state=O}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(O,x=this.state.pageSize){return new w({...this.state,pageNumber:O,pageSize:x})}withFilter(O,...x){const j=[...this.state.criteria,...x.length?x.map(H=>({filterType:O,value:H})):[{filterType:O}]];return new w({...this.state,criteria:j})}withSortBy(O){return new w({...this.state,sortBy:O})}withSortOrder(O){return new w({...this.state,sortOrder:O})}withFlags(...O){return new w({...this.state,flags:O.reduce((x,j)=>x|j,0)})}withAssetTypes(...O){return new w({...this.state,assetTypes:O})}withSource(O){return new w({...this.state,source:O})}get raw(){const{criteria:O,pageNumber:x,pageSize:j,sortBy:H,sortOrder:X,flags:oe,assetTypes:le}=this.state;return{filters:[{criteria:O,pageNumber:x,pageSize:j,sortBy:H,sortOrder:X}],assetTypes:le,flags:oe}}get searchText(){const O=this.state.criteria.filter(x=>x.filterType===e.SearchText)[0];return O&&O.value?O.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(O=>String(O.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function L(R,O){const x=(R||[]).filter(j=>j.statisticName===O)[0];return x?x.value:0}function U(R){const O="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(j=>j.assetType.indexOf(O)===0).reduce((j,H)=>{const X=Y(R,H.assetType);return X&&j.push([H.assetType.substring(O.length),X]),j},[])}function $(R){if(R.properties){const O=R.properties.filter(H=>H.key===r.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=O.filter(H=>x.test(H.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return Y(R,r.Repository)}function q(R){return{uri:`${R.fallbackAssetUri}/${r.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function Y(R,O){return R.files.filter(j=>j.assetType===O)[0]?{uri:`${R.assetUri}/${O}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${O}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ne(R,O){const x=R.properties?R.properties.filter(H=>H.key===O):[],j=x.length>0&&x[0].value;return j?j.split(",").map(H=>(0,g.adoptToGalleryExtensionId)(H)):[]}function ce(R){const O=R.properties?R.properties.filter(x=>x.key===o.Engine):[];return O.length>0&&O[0].value||""}function re(R){const O=R.properties?R.properties.filter(x=>x.key===o.PreRelease):[];return O.length>0&&O[0].value==="true"}function ge(R){const O=R.properties?R.properties.filter(j=>j.key===o.LocalizedLanguages):[],x=O.length>0&&O[0].value||"";return x?x.split(","):[]}function ae(R){return R.properties?.find(O=>O.key===o.SponsorLink)?.value}function N(R){return R.indexOf("preview")!==-1}function _(R){return R.targetPlatform?(0,P.toTargetPlatform)(R.targetPlatform):"undefined"}function M(R){const O=(0,D.distinct)(R.versions.map(_)),x=!!R.tags?.includes(P.WEB_EXTENSION_TAG),j=O.indexOf("web");return x?j===-1&&O.push("web"):j!==-1&&O.splice(j,1),O}function A(R,O){const x=(0,P.getFallbackTargetPlarforms)(O);for(let j=0;j<R.length;j++){const H=R[j];if(H.version===R[j-1]?.version){let X=j;const oe=_(H);if(oe===O)for(;X>0&&R[X-1].version===H.version;)X--;else if(x.includes(oe))for(;X>0&&R[X-1].version===H.version&&_(R[X-1])!==O;)X--;X!==j&&(R.splice(j,1),R.splice(X,0,H))}}return R}i.sortExtensionVersions=A;function W(R,O,x){R.telemetryData={index:O,querySource:x}}function G(R,O,x){const j=R.versions[0],H={manifest:Y(O,r.Manifest),readme:Y(O,r.Details),changelog:Y(O,r.Changelog),license:Y(O,r.License),repository:$(O),download:q(O),icon:Y(O,r.Icon),coreTranslations:U(O)};return{identifier:{id:(0,g.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:O.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:ae(j),description:R.shortDescription||"",installCount:L(R.statistics,"install"),rating:L(R.statistics,"averagerating"),ratingCount:L(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:x,assets:H,properties:{dependencies:ne(O,o.Dependency),extensionPack:ne(O,o.ExtensionPack),engine:ce(O),localizedLanguages:ge(O),targetPlatform:_(O),isPreReleaseVersion:re(O)},hasPreReleaseVersion:re(j),hasReleaseVersion:!0,preview:N(R.flags)}}let Q=class{constructor(O,x,j,H,X,oe,le,pe){this.requestService=x,this.logService=j,this.environmentService=H,this.telemetryService=X,this.fileService=oe,this.productService=le,this.configurationService=pe;const ve=le.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,O,this.telemetryService)}api(O=""){return`${this.extensionsGalleryUrl}${O}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(O,x,j){const H=I.CancellationToken.isCancellationToken(x)?{}:x,X=I.CancellationToken.isCancellationToken(x)?x:j,oe=[],le=[],pe=[],ve=[];let ie=!0;for(const de of O){de.uuid?le.push(de.uuid):oe.push(de.id);const Se=!!(de.version||de.preRelease);pe.push({id:de.id,uuid:de.uuid,includePreRelease:Se}),de.version&&ve.push({id:de.id,uuid:de.uuid,version:de.version}),ie=ie&&!!de.hasPreRelease&&!Se}if(!le.length&&!oe.length)return[];let se=new w().withPage(1,O.length);le.length&&(se=se.withFilter(e.ExtensionId,...le)),oe.length&&(se=se.withFilter(e.ExtensionName,...oe)),(H.queryAllVersions||ie)&&(se=se.withFlags(se.flags,t.IncludeVersions)),H.source&&(se=se.withSource(H.source));const{extensions:he}=await this.queryGalleryExtensions(se,{targetPlatform:H.targetPlatform??s,includePreRelease:pe,versions:ve,compatible:!!H.compatible},X);return H.source&&he.forEach((de,Se)=>W(de,Se,H.source)),he}async getCompatibleExtension(O,x,j){if((0,P.isNotWebExtensionInWebTargetPlatform)(O.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(O,x,j))return O;const H=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(e.ExtensionId,O.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:j,compatible:!0,includePreRelease:x},I.CancellationToken.None);return X[0]||null}async isExtensionCompatible(O,x,j){if(!(0,P.isTargetPlatformCompatible)(O.properties.targetPlatform,O.allTargetPlatforms,j)||!x&&O.properties.isPreReleaseVersion)return!1;let H=O.properties.engine;if(!H){const X=await this.getManifest(O,I.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,E.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(O,x,j,H,X){if(!(0,P.isTargetPlatformCompatible)(_(O),H,X)||x!=="any"&&re(O)!==(x==="prerelease"))return!1;if(j)try{const oe=await this.getEngine(O);if(!(0,E.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}catch(oe){return this.logService.error(`Error while getting the engine for the version ${O.version}.`,(0,b.getErrorMessage)(oe)),!1}return!0}async query(O,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=O.text||"";const H=O.pageSize??50;let X=new w().withPage(1,H);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,he)=>(X=X.withFilter(e.Category,he||se),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,he)=>(X=X.withFilter(e.Tag,he||se),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(e.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),X=X.withFilter(e.SearchText,j)),X=X.withSortBy(0)):O.ids?X=X.withFilter(e.ExtensionId,...O.ids):O.names?X=X.withFilter(e.ExtensionName,...O.names):X=X.withSortBy(4),typeof O.sortBy=="number"&&(X=X.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(X=X.withSortOrder(O.sortOrder)),O.source&&(X=X.withSource(O.source));const oe=async(ie,se)=>{const{extensions:he,total:de}=await this.queryGalleryExtensions(ie,{targetPlatform:s,compatible:!1,includePreRelease:!!O.includePreRelease},se);return he.forEach((Se,Oe)=>W(Se,(ie.pageNumber-1)*ie.pageSize+Oe,O.source)),{extensions:he,total:de}},{extensions:le,total:pe}=await oe(X,x),ve=async(ie,se)=>{if(se.isCancellationRequested)throw new b.CancellationError;const{extensions:he}=await oe(X.withPage(ie+1),se);return he};return{firstPage:le,total:pe,pageSize:X.pageSize,getPage:ve}}async queryGalleryExtensions(O,x,j){const H=O.flags;!!(O.flags&t.IncludeLatestVersionOnly)&&!!(O.flags&t.IncludeVersions)&&(O=O.withFlags(O.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(O.flags&t.IncludeLatestVersionOnly)&&!(O.flags&t.IncludeVersions)&&(O=O.withFlags(O.flags,t.IncludeLatestVersionOnly)),x.versions?.length&&(O=O.withFlags(O.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),O=O.withFlags(O.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:X,total:oe}=await this.queryRawGalleryExtensions(O,j);if(!(O.flags&t.IncludeLatestVersionOnly)){const ie=[];for(const se of X){const he=await this.toGalleryExtensionWithCriteria(se,x);he&&ie.push(he)}return{extensions:ie,total:oe}}const pe=[],ve=new Map;for(let ie=0;ie<X.length;ie++){const se=X[ie],he={id:(0,g.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},de=(0,p.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Oe=>(0,g.areSameExtensions)(Oe,he))?.includePreRelease;if(x.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(M(se),x.targetPlatform))continue;const Se=await this.toGalleryExtensionWithCriteria(se,x);!Se||Se.properties.isPreReleaseVersion&&(!de||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==x.targetPlatform&&Se.hasPreReleaseVersion?ve.set(se.extensionId,ie):pe.push([ie,Se])}if(ve.size){const ie=new Date().getTime(),se=new w().withFlags(H&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ve.size).withFilter(e.ExtensionId,...ve.keys()),{extensions:he}=await this.queryGalleryExtensions(se,x,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ie,count:ve.size});for(const de of he){const Se=ve.get(de.identifier.uuid);pe.push([Se,de])}}return{extensions:pe.sort((ie,se)=>ie[0]-se[0]).map(([,ie])=>ie),total:oe}}async toGalleryExtensionWithCriteria(O,x){const j={id:(0,g.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},H=x.versions?.find(pe=>(0,g.areSameExtensions)(pe,j))?.version,X=(0,p.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(pe=>(0,g.areSameExtensions)(pe,j))?.includePreRelease,oe=M(O),le=A(O.versions,x.targetPlatform);if(x.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(oe,x.targetPlatform))return null;for(let pe=0;pe<le.length;pe++){const ve=le[pe];if(!(H&&ve.version!==H)){if(await this.isValidVersion(ve,X?"any":"release",x.compatible,oe,x.targetPlatform))return G(O,ve,oe);if(H&&ve.version===H)return null}}return H||x.compatible?null:G(O,O.versions[0],oe)}async queryRawGalleryExtensions(O,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");O=O.withFlags(O.flags,t.ExcludeNonValidated).withFilter(e.Target,"Microsoft.VisualStudio.Code").withFilter(e.ExcludeWithFlags,n(t.Unpublished));const j=await this.commonHeadersPromise,H=JSON.stringify(O.raw),X={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},oe=new Date().getTime();let le,pe,ve=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},x),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ve};const ie=await(0,u.asJson)(le);if(ie){const se=ie.results[0],he=se.extensions,de=se.resultMetadata&&se.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ve=de&&de.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:ve}}return{galleryExtensions:[],total:ve}}catch(ie){throw pe=ie,ie}finally{this.telemetryService.publicLog2("galleryService:query",{...O.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-oe,success:!!le&&(0,u.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?(0,b.isCancellationError)(pe)?"canceled":(0,b.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(O,x,j,H){if(!this.isEnabled())return;const X=k.isWeb?this.api(`/itemName/${O}.${x}/version/${j}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${O}/extensions/${x}/${j}/stats?statType=${H}`),oe=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:X,headers:pe},I.CancellationToken.None)}catch{}}async download(O,x,j){this.logService.trace("ExtensionGalleryService#download",O.identifier.id);const H=(0,g.getGalleryExtensionTelemetryData)(O),X=new Date().getTime(),oe=ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:ie}),le=j===2?"install":j===3?"update":"",pe=le?{uri:`${O.assets.download.uri}${a.URI.parse(O.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${O.assets.download.fallbackUri}${a.URI.parse(O.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:O.assets.download,ve=await this.getAsset(pe);await this.fileService.writeFile(x,ve.stream),oe(new Date().getTime()-X)}async getReadme(O,x){if(O.assets.readme){const j=await this.getAsset(O.assets.readme,{},x);return await(0,u.asTextOrError)(j)||""}return""}async getManifest(O,x){if(O.assets.manifest){const j=await this.getAsset(O.assets.manifest,{},x),H=await(0,u.asTextOrError)(j);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(O,x){const j=Y(O,r.Manifest);if(!j)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(j,{headers:H});return await(0,u.asJson)(X)}async getCoreTranslation(O,x){const j=O.assets.coreTranslations.filter(H=>H[0]===x.toUpperCase())[0];if(j){const H=await this.getAsset(j[1]),X=await(0,u.asTextOrError)(H);return X?JSON.parse(X):null}return null}async getChangelog(O,x){if(O.assets.changelog){const j=await this.getAsset(O.assets.changelog,{},x);return await(0,u.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(O,x,j){let H=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);O.identifier.uuid?H=H.withFilter(e.ExtensionId,O.identifier.uuid):H=H.withFilter(e.ExtensionName,O.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,I.CancellationToken.None);if(!X.length)return[];const oe=M(X[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(oe,j))return[];const le=[];await Promise.all(X[0].versions.map(async ie=>{try{await this.isValidVersion(ie,x?"any":"release",!0,oe,j)&&le.push(ie)}catch{}}));const pe=[],ve=new Set;for(const ie of A(le,j))ve.has(ie.version)||(ve.add(ie.version),pe.push({version:ie.version,date:ie.lastUpdated,isPreReleaseVersion:re(ie)}));return pe}async getAsset(O,x={},j=I.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},oe={...H,...x.headers||{}};x={...x,...X,headers:oe};const le=O.uri,pe=O.fallbackUri,ve={...x,url:le};try{const ie=await this.requestService.request(ve,j);if(ie.res.statusCode===200)return ie;const se=await(0,u.asTextOrError)(ie);throw new Error(`Expected 200, got back ${ie.res.statusCode} instead.

${se}`)}catch(ie){if((0,b.isCancellationError)(ie))throw ie;const se=(0,b.getErrorMessage)(ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:se});const he={...x,url:pe};return this.requestService.request(he,j)}}async getEngine(O){let x=ce(O);if(!x){const j=await this.getManifestFromRawExtensionVersion(O,I.CancellationToken.None);if(!j)throw new Error("Manifest was not found");x=j.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const O=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(O.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,u.asJson)(O),j=[],H={};if(x){for(const X of x.malicious)j.push({id:X});if(x.migrateToPreRelease)for(const[X,oe]of Object.entries(x.migrateToPreRelease))(!oe.engine||(0,E.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[X,oe]of Object.entries(x.deprecated))oe&&(H[X.toLowerCase()]=(0,p.isBoolean)(oe)?{}:oe)}return{malicious:j,deprecated:H}}};Q=fe([te(1,u.IRequestService),te(2,f.ILogService),te(3,C.IEnvironmentService),te(4,c.ITelemetryService),te(5,l.IFileService),te(6,v.IProductService),te(7,d.IConfigurationService)],Q);let F=class extends Q{constructor(O,x,j,H,X,oe,le,pe){super(O,x,j,H,X,oe,le,pe)}};F=fe([te(0,y.IStorageService),te(1,u.IRequestService),te(2,f.ILogService),te(3,C.IEnvironmentService),te(4,c.ITelemetryService),te(5,l.IFileService),te(6,v.IProductService),te(7,d.IConfigurationService)],F),i.ExtensionGalleryService=F;let V=class extends Q{constructor(O,x,j,H,X,oe,le){super(void 0,O,x,j,H,X,oe,le)}};V=fe([te(0,u.IRequestService),te(1,f.ILogService),te(2,C.IEnvironmentService),te(3,c.ITelemetryService),te(4,l.IFileService),te(5,v.IProductService),te(6,d.IConfigurationService)],V),i.ExtensionGalleryServiceWithNoStorageService=V}),define(Z[144],ee([0,1,43,17,11,9,65,28,26]),function(B,i,D,I,b,k,T,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=void 0;let d=class je extends a.UserDataProfilesService{constructor(P,g,E,l,f){super(E,l,g,f);this.stateService=P}getStoredProfiles(){return(0,D.revive)(this.stateService.getItem(je.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,D.revive)(this.stateService.getItem(je.PROFILE_ASSOCIATIONS_KEY,{}))}};d=fe([te(0,T.IStateService),te(1,p.IUriIdentityService),te(2,I.IEnvironmentService),te(3,b.IFileService),te(4,k.ILogService)],d),i.UserDataProfilesService=d}),define(Z[145],ee([0,1,37,3,157,2]),function(B,i,D,I,b,k){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativePolicyService=void 0;class T extends D.AbstractPolicyService{constructor(a){super();this.productName=a,this.throttler=new I.Throttler,this.watcher=this._register(new k.MutableDisposable)}async initializePolicies(a){await this.throttler.queue(()=>new Promise((d,C)=>{try{this.watcher.value=(0,b.createWatcher)(this.productName,a,P=>{for(const g in P){const E=P[g];E===void 0?this.policies.delete(g):this.policies.set(g,E)}this._onDidChange.fire(Object.keys(P)),d()})}catch(P){C(P)}}))}}i.NativePolicyService=T}),define(Z[67],ee([0,1,114,3,14,7,20,83,158,159]),function(B,i,D,I,b,k,T,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class C extends Error{constructor(t,n){let e=n.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=n}}i.ExtractError=C;function P(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,e)=>n+e,t&61440)}function g(s){if(s instanceof C)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new C(t,s)}function E(s,t,n,e,r,o){const m=b.dirname(t),S=b.join(e,m);if(!S.startsWith(e))return Promise.reject(new Error(p.localize(0,null,t)));const w=b.join(e,t);let L;return o.onCancellationRequested(()=>{L&&L.destroy()}),Promise.resolve(T.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((U,$)=>{if(!o.isCancellationRequested)try{L=(0,D.createWriteStream)(w,{mode:n}),L.once("close",()=>U()),L.once("error",$),s.once("error",$),s.pipe(L)}catch(q){$(q)}}))}function l(s,t,n,e){let r=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return e.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((m,S)=>{const w=new I.Sequencer,L=U=>{U.isCancellationRequested||(o++,s.readEntry())};s.once("error",S),s.once("close",()=>r.then(()=>{e.isCancellationRequested||s.entryCount===o?m():S(new C("Incomplete",new Error(p.localize(1,null,o,s.entryCount))))},S)),s.readEntry(),s.on("entry",U=>{if(e.isCancellationRequested)return;if(!n.sourcePathRegex.test(U.fileName)){L(e);return}const $=U.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test($)){const ne=b.join(t,$);r=(0,I.createCancelablePromise)(ce=>T.Promises.mkdir(ne,{recursive:!0}).then(()=>L(ce)).then(void 0,S));return}const q=v(s,U),Y=P(U);r=(0,I.createCancelablePromise)(ne=>w.queue(()=>q.then(ce=>E(ce,$,Y,t,n,ne).then(()=>L(ne)))).then(null,S))})})}function f(s,t=!1){return new Promise((n,e)=>{(0,a.open)(s,t?{lazyEntries:!0}:void 0,(r,o)=>{r?e(g(r)):n((0,k.assertIsDefined)(o))})})}function v(s,t){return new Promise((n,e)=>{s.openReadStream(t,(r,o)=>{r?e(g(r)):n((0,k.assertIsDefined)(o))})})}function u(s,t){return new Promise((n,e)=>{const r=new d.ZipFile;t.forEach(m=>{m.contents?r.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&r.addFile(m.localPath,m.path)}),r.end();const o=(0,D.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",e),o.once("error",e),o.once("finish",()=>n(s))})}i.zip=u;function h(s,t,n={},e){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=f(s,!0);return n.overwrite&&(o=o.then(m=>T.Promises.rm(t).then(()=>m))),o.then(m=>l(m,t,{sourcePathRegex:r},e))}i.extract=h;function y(s,t){return f(s).then(n=>new Promise((e,r)=>{n.on("entry",o=>{o.fileName===t&&v(n,o).then(m=>e(m),m=>r(m))}),n.once("close",()=>r(new Error(p.localize(2,null,t))))}))}function c(s,t){return y(s,t).then(n=>new Promise((e,r)=>{const o=[];n.once("error",r),n.on("data",m=>o.push(m)),n.on("end",()=>e(Buffer.concat(o)))}))}i.buffer=c}),define(Z[146],ee([0,1,67,90]),function(B,i,D,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(k){return(0,D.buffer)(k,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,I.localize)(0,null))}})}i.getManifest=b}),define(Z[147],ee([0,1,3,30,12,2,16,14,13,18,38,7,10,29,20,67,89,58,17,139,22,23,40,49,122,140,146,123,136,33,46,11,8,9,27,34,28,26]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f,v,u,h,y,c,s,t,n,e,r,o,m,S,w,L,U,$,q,Y,ne,ce,re){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=i.INativeServerExtensionManagementService=void 0,i.INativeServerExtensionManagementService=(0,$.refineServiceDecorator)(c.IServerExtensionManagementService);let ge=class extends y.AbstractExtensionManagementService{constructor(F,V,R,O,x,j,H,X,oe,le,pe,ve){super(F,V,R,le,ve);this.environmentService=O,this.extensionsScannerService=x,this.extensionsProfileScannerService=j,this.downloadService=H,this.fileService=oe,this.installGalleryExtensionsTasks=new Map;const ie=this._register(X.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(ae,he=>ie.postUninstall(he))),this.manifestCache=this._register(new m.ExtensionsManifestCache(O,this)),this.extensionsDownloader=this._register(X.createInstance(e.ExtensionsDownloader));const se=this._register(new S.ExtensionsWatcher(this,oe,O,R,pe));this._register(se.onDidChangeExtensionsByAnotherSource(({added:he,removed:de})=>{he.length&&this._onDidInstallExtensions.fire(he.map(Se=>({identifier:Se.identifier,operation:1,local:Se}))),de.forEach(Se=>this._onDidUninstallExtension.fire({identifier:Se}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(F){this.logService.trace("ExtensionManagementService#zip",F.identifier.id);const V=await this.collectFiles(F),R=await(0,f.zip)((0,d.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,V);return g.URI.file(R)}async unzip(F){return this.logService.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const V=await this.downloadVsix(F),R=p.resolve(V.fsPath);return(0,o.getManifest)(R)}getInstalled(F,V){return this.extensionsScanner.scanExtensions(F??null,V)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(F,V={}){this.logService.trace("ExtensionManagementService#install",F.toString());const R=await this.downloadVsix(F),O=await(0,o.getManifest)(p.resolve(R.fsPath));if(O.engines&&O.engines.vscode&&!(0,L.isEngineValid)(O.engines.vscode,this.productService.version,this.productService.date))throw new Error(v.localize(0,null,(0,s.getGalleryExtensionId)(O.publisher,O.name),this.productService.version));return this.installExtension(O,R,V)}getMetadata(F){return this.extensionsScannerService.scanMetadata(F.location)}async updateMetadata(F,V){this.logService.trace("ExtensionManagementService#updateMetadata",F.identifier.id);const R={...V};return V.isPreReleaseVersion&&(R.preRelease=!0),F=await this.extensionsScanner.updateMetadata(F,R),this.manifestCache.invalidate(),F}async updateExtensionScope(F,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",F.identifier.id),F=await this.extensionsScanner.updateMetadata(F,{isMachineScoped:V}),this.manifestCache.invalidate(),F}removeUninstalledExtensions(F){return this.extensionsScanner.cleanUp(F)}async downloadVsix(F){if(F.scheme===T.Schemas.file)return F;const V=(0,d.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(F,V),V}doCreateInstallExtensionTask(F,V,R){let O;if(g.URI.isUri(V))O=new M(F,V,R,this.galleryService,this.extensionsScanner,this.logService);else{const x=s.ExtensionKey.create(V).toString();O=this.installGalleryExtensionsTasks.get(x),O||(this.installGalleryExtensionsTasks.set(x,O=new _(F,V,R,this.extensionsDownloader,this.extensionsScanner,this.logService)),O.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x)))}return R.profileLocation?new A(O,R.profileLocation,this.extensionsProfileScannerService):O}doCreateUninstallExtensionTask(F,V){return V.profileLocation?new G(F,V.profileLocation,this.extensionsProfileScannerService):new W(F,V,this.extensionsScanner)}async collectFiles(F){const V=async O=>{let x=await l.Promises.readdir(O);x=x.map(X=>p.join(O,X));const j=await Promise.all(x.map(X=>l.Promises.stat(X)));let H=Promise.resolve([]);return j.forEach((X,oe)=>{const le=x[oe];X.isFile()&&(H=H.then(pe=>[...pe,le])),X.isDirectory()&&(H=H.then(pe=>V(le).then(ve=>[...pe,...ve])))}),H};return(await V(F.location.fsPath)).map(O=>({path:`extension/${p.relative(F.location.fsPath,O)}`,localPath:O}))}};ge=fe([te(0,c.IExtensionGalleryService),te(1,ne.ITelemetryService),te(2,q.ILogService),te(3,h.INativeEnvironmentService),te(4,n.IExtensionsScannerService),te(5,t.IExtensionsProfileScannerService),te(6,u.IDownloadService),te(7,$.IInstantiationService),te(8,U.IFileService),te(9,Y.IProductService),te(10,ce.IUriIdentityService),te(11,re.IUserDataProfilesService)],ge),i.ExtensionManagementService=ge;let ae=class extends k.Disposable{constructor(F,V,R,O){super();this.beforeRemovingExtension=F,this.fileService=V,this.extensionsScannerService=R,this.logService=O,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(F){await this.removeUninstalledExtensions(),F&&await this.removeOutdatedExtensions()}async scanExtensions(F,V){const R={includeInvalid:!0,profileLocation:V};let O=[];return F===null||F===0?O.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},R)):F===1&&O.push(...await this.extensionsScannerService.scanUserExtensions(R)),O=F!==null?O.filter(x=>x.type===F):O,Promise.all(O.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(F){const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(V.map(R=>this.toLocalExtension(R)))}async extractUserExtension(F,V,R,O){const x=F.toString(),j=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),H=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,x);try{await l.Promises.rm(H)}catch{throw new c.ExtensionManagementError(v.localize(1,null,H,F.id),c.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(F,V,j,O),R={...R,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(g.URI.file(j),R);try{await this.rename(F,j,H,Date.now()+2*60*1e3),this.logService.info("Renamed to",H)}catch(X){try{await l.Promises.rm(j)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(X)}. Deleted from extracted location`,j),X}return this.scanLocalExtension(g.URI.file(H),1)}async updateMetadata(F,V){return await this.extensionsScannerService.updateMetadata(F.location,V),this.scanLocalExtension(F.location,F.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const V=F.map(R=>s.ExtensionKey.create(R));await this.withUninstalledExtensions(R=>{V.forEach(O=>R[O.toString()]=!0)})}async setInstalled(F){await this.withUninstalledExtensions(O=>delete O[F.toString()]);const R=(await this.scanUserExtensions(!0)).find(O=>s.ExtensionKey.create(O).equals(F))||null;return R?this.updateMetadata(R,{installedTimestamp:Date.now()}):null}async removeExtension(F,V){this.logService.trace(`Deleting ${V} extension from disk`,F.identifier.id,F.location.fsPath),await l.Promises.rm(F.location.fsPath),this.logService.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[s.ExtensionKey.create(F).toString()])}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=await l.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let R={};if(V)try{R=JSON.parse(V)}catch{}return F&&(F(R),Object.keys(R).length?await l.Promises.writeFile(this.uninstalledPath,JSON.stringify(R)):await l.Promises.rm(this.uninstalledPath)),R})}async extractAtLocation(F,V,R,O){this.logService.trace(`Started extracting the extension from ${V} to ${R}`);try{await l.Promises.rm(R)}catch(x){throw new c.ExtensionManagementError(this.joinErrors(x).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(V,R,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${R}:`,F.id)}catch(x){try{await l.Promises.rm(R)}catch{}let j=c.ExtensionManagementErrorCode.Extract;throw x instanceof f.ExtractError&&(x.type==="CorruptZip"?j=c.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(j=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError(x.message,j)}}async rename(F,V,R,O){try{await l.Promises.rename(V,R)}catch(x){if(a.isWindows&&x&&x.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${V} to ${R} with 'EPERM' error. Trying again...`,F.id),this.rename(F,V,R,O);throw new c.ExtensionManagementError(x.message||v.localize(2,null,V,R),x.code||c.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(F,V){const R=await this.extensionsScannerService.scanExistingExtension(F,V,{includeInvalid:!0});if(R)return this.toLocalExtension(R);throw new Error(v.localize(3,null,F.path))}async toLocalExtension(F){const V=await this.fileService.resolve(F.location);let R,O;return V.children&&(R=V.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,O=V.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:R,changelogUrl:O,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated}}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions(),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const j of V)F[s.ExtensionKey.create(j).toString()]||R.add(j.identifier.id.toLowerCase());const O=(0,s.groupByExtension)(V,j=>j.identifier);await D.Promises.settled(O.map(async j=>{const H=j.sort((X,oe)=>C.rcompare(X.manifest.version,oe.manifest.version))[0];R.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}));const x=V.filter(j=>F[s.ExtensionKey.create(j).toString()]);await D.Promises.settled(x.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const F=await this.extensionsScannerService.scanSystemExtensions({}),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=[],O=await this.extensionsScannerService.getTargetPlatform(),x=(0,s.groupByExtension)(V,j=>j.identifier);for(const j of x)if(j.length>1&&R.push(...j.sort((H,X)=>{const oe=C.rcompare(H.manifest.version,X.manifest.version);return oe!==0?oe:H.targetPlatform===O?-1:1}).slice(1)),j[0].type===0){const H=F.find(X=>(0,s.areSameExtensions)(X.identifier,j[0].identifier));(!H||C.gte(H.manifest.version,j[0].manifest.version))&&R.push(j[0])}await D.Promises.settled(R.map(j=>this.removeExtension(j,"outdated")))}joinErrors(F){const V=Array.isArray(F)?F:[F];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((R,O)=>new Error(`${R.message}${R.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}};ae=fe([te(1,U.IFileService),te(2,n.IExtensionsScannerService),te(3,q.ILogService)],ae);class N extends y.AbstractExtensionTask{constructor(F,V,R,O,x){super();this.identifier=F,this.source=V,this.options=R,this.extensionsScanner=O,this.logService=x,this._operation=2}get operation(){return(0,P.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(F,V){try{const R=await this.unsetUninstalledAndGetLocal(F.key);if(R)return F.metadata?this.extensionsScanner.updateMetadata(R,F.metadata):R}catch{throw a.isMacintosh?new c.ExtensionManagementError(v.localize(4,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(v.localize(5,null),c.ExtensionManagementErrorCode.Internal)}return this.extract(F,V)}async unsetUninstalledAndGetLocal(F){if(!await this.isUninstalled(F))return null;this.logService.trace("Removing the extension from uninstalled list:",F.id);const R=await this.extensionsScanner.setInstalled(F);return this.logService.info("Removed the extension from uninstalled list:",F.id),R}async isUninstalled(F){return!!(await this.extensionsScanner.getUninstalledExtensions())[F.toString()]}async extract({zipPath:F,key:V,metadata:R},O){const x=await this.extensionsScanner.extractUserExtension(V,F,R,O);return this.logService.info("Extracting completed.",V.id),x}}class _ extends N{constructor(F,V,R,O,x,j){super(V.identifier,V,R,x,j);this.manifest=F,this.gallery=V,this.extensionsDownloader=O}async doRun(F){const R=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,s.areSameExtensions)(j.identifier,this.gallery.identifier));R&&(this._operation=3);const O={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,w.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(R,O),metadata:O};const x=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:x,key:s.ExtensionKey.create(this.gallery),metadata:O},F);return R&&!this.options.profileLocation&&(R.targetPlatform!==j.targetPlatform||C.neq(R.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(R),{local:j,metadata:O}}catch(j){throw await this.deleteDownloadedVSIX(x),j}}async deleteDownloadedVSIX(F){try{await this.extensionsDownloader.delete(g.URI.file(F))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",F.toString(),(0,b.getErrorMessage)(V))}}async downloadExtension(F,V){let R;try{this.logService.trace("Started downloading extension:",F.identifier.id),R=(await this.extensionsDownloader.downloadExtension(F,V)).fsPath,this.logService.info("Downloaded extension:",F.identifier.id,R)}catch(O){throw new c.ExtensionManagementError((0,y.joinErrors)(O).message,c.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(R),R}catch(O){throw await this.deleteDownloadedVSIX(R),new c.ExtensionManagementError((0,y.joinErrors)(O).message,c.ExtensionManagementErrorCode.Invalid)}}}class M extends N{constructor(F,V,R,O,x,j){super({id:(0,s.getGalleryExtensionId)(F.publisher,F.name)},V,R,x,j);this.manifest=F,this.location=V,this.galleryService=O}async doRun(F){const V=new s.ExtensionKey(this.identifier,this.manifest.version),O=(await this.extensionsScanner.scanExtensions(1,void 0)).find(H=>(0,s.areSameExtensions)(this.identifier,H.identifier)),x=await this.getMetadata(this.identifier.id,this.manifest.version,F);if(x.isApplicationScoped=(0,w.isApplicationScopedExtension)(this.manifest),x.isMachineScoped=this.options.isMachineScoped||O?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||O?.isBuiltin,O)if(this._operation=3,V.equals(new s.ExtensionKey(O.identifier,O.manifest.version)))try{await this.extensionsScanner.removeExtension(O,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&C.gt(O.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(O);else{const H=await this.unsetUninstalledAndGetLocal(V);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:p.resolve(this.location.fsPath),key:V,metadata:x},F),metadata:x}}async getMetadata(F,V,R){try{let[O]=await this.galleryService.getExtensions([{id:F,version:V}],R);if(O||([O]=await this.galleryService.getExtensions([{id:F}],R)),O)return{id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class A{constructor(F,V,R){this.task=F,this.profileLocation=V,this.extensionsProfileScannerService=R,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const F=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[F.local,F.metadata]],this.profileLocation),F}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class W extends y.AbstractExtensionTask{constructor(F,V,R){super();this.extension=F,this.options=V,this.extensionsScanner=R}async doRun(F){const V=[],R=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const O=s.ExtensionKey.create(this.extension);V.push(...R.filter(x=>O.equals(s.ExtensionKey.create(x))))}else V.push(...R.filter(O=>(0,s.areSameExtensions)(O.identifier,this.extension.identifier)));if(!V.length)throw new Error(v.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const O of V)try{F.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(O)}catch(x){throw new Error(v.localize(9,null,(0,I.toErrorMessage)(x)))}}}class G extends y.AbstractExtensionTask{constructor(F,V,R){super();this.extension=F,this.profileLocation=V,this.extensionsProfileScannerService=R}async doRun(F){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Z[148],ee([0,1,127,3,15,12,2,7,21,17,128,9,126,160]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let l=class extends T.Disposable{constructor(v,u,h){super();this.environmentService=u,this.logService=h,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,u){this.logService.trace("RequestService#request (node) - begin",v.url);const{proxyUrl:h,strictSSL:y}=this;let c;try{c=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...c},t=v.agent?v.agent:await(0,g.getProxyAgent)(v.url||"",s,{proxyUrl:h,strictSSL:y});v.agent=t,v.strictSSL=y,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(v,u);return this.logService.trace("RequestService#request (node) - success",v.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",v.url,n),n}}async getNodeRequest(v){return((0,D.parse)(v.url).protocol==="https:"?await new Promise((y,c)=>{B(["https"],y,c)}):await new Promise((y,c)=>{B(["http"],y,c)})).request}_request(v,u){return I.Promises.withAsyncBody(async(h,y)=>{const c=(0,D.parse)(v.url),s=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),t={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,p.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(t.auth=v.user+":"+v.password);const n=s(t,e=>{const r=(0,p.isNumber)(v.followRedirects)?v.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&r>0&&e.headers.location)this._request({...v,url:e.headers.location,followRedirects:r-1},u).then(h,y);else{let o=e;e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,E.createGunzip)())),h({res:e,stream:(0,b.streamToBufferReadableStream)(o)})}});n.on("error",y),v.timeout&&n.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&n.write(v.data),n.end(),u.onCancellationRequested(()=>{n.abort(),y(new k.CancellationError)})})}async resolveProxy(v){}};l=fe([te(0,a.IConfigurationService),te(1,d.INativeEnvironmentService),te(2,P.ILogService)],l),i.RequestService=l}),define(Z[161],ee([0,1,44,3,15,30,12,2,16,14,13,35,10,20,21,119,58,125,17,102,143,22,121,40,49,147,141,11,111,113,47,109,61,62,124,9,115,116,37,145,133,27,48,148,65,129,66,34,132,41,134,135,28,137,26,144]),function(B,i,D,I,b,k,T,p,a,d,C,P,g,E,l,f,v,u,h,y,c,s,t,n,e,r,o,m,S,w,L,U,$,q,Y,ne,ce,re,ge,ae,N,_,M,A,W,G,Q,F,V,R,O,x,j,H,X,oe){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class le extends p.Disposable{constructor(ie){super();this.argv=ie,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ie,se]=await this.initServices();return ie.invokeFunction(async he=>{const de=he.get(ne.ILogService),Se=he.get(m.IFileService),Oe=he.get(h.INativeEnvironmentService),Ae=he.get(s.IExtensionManagementCLIService);de.info("CLI main",this.argv),this.registerErrorHandler(de),await this.doRun(Oe,Ae,Se),await Promise.all(se.map(Ue=>{(0,I.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const ie=new $.ServiceCollection,se={_serviceBrand:void 0,...N.default};ie.set(_.IProductService,se);const he=new y.NativeEnvironmentService(this.argv,se);ie.set(h.INativeEnvironmentService,he),await Promise.all([he.appSettingsHome.fsPath,he.extensionsPath].map(we=>we?E.Promises.mkdir(we,{recursive:!0}):void 0));const de=(0,ne.getLogLevel)(he),Se=[];Se.push(new ce.SpdLogLogger("cli",(0,d.join)(he.logsPath,"cli.log"),!0,!1,de)),de===ne.LogLevel.Trace&&Se.push(new ne.ConsoleLogger(de));const Oe=this._register(new ne.MultiplexLogService(Se));ie.set(ne.ILogService,Oe);const Ae=this._register(new S.FileService(Oe));ie.set(m.IFileService,Ae);const Ue=this._register(new w.DiskFileSystemProvider(Oe));Ae.registerProvider(a.Schemas.file,Ue);const xe=new G.StateService(he,Oe,Ae);ie.set(W.IStateService,xe);const z=new H.UriIdentityService(Ae);ie.set(j.IUriIdentityService,z);const K=new oe.UserDataProfilesService(xe,z,he,Ae,Oe);ie.set(X.IUserDataProfilesService,K);const J=C.isWindows&&se.win32RegValueName?this._register(new ae.NativePolicyService(se.win32RegValueName)):he.policyFile?this._register(new re.FilePolicyService(he.policyFile,Ae,Oe)):new ge.NullPolicyService;ie.set(ge.IPolicyService,J);const ue=this._register(new f.ConfigurationService(K.defaultProfile.settingsResource,Ae,J,Oe));ie.set(l.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),K.setEnablement(!!ue.getValue(X.PROFILES_ENABLEMENT_CONFIG)),ie.set(j.IUriIdentityService,new H.UriIdentityService(Ae)),ie.set(M.IRequestService,new L.SyncDescriptor(A.RequestService)),ie.set(v.IDownloadService,new L.SyncDescriptor(u.DownloadService)),ie.set(n.IExtensionsProfileScannerService,new L.SyncDescriptor(n.ExtensionsProfileScannerService)),ie.set(e.IExtensionsScannerService,new L.SyncDescriptor(o.ExtensionsScannerService)),ie.set(r.INativeServerExtensionManagementService,new L.SyncDescriptor(r.ExtensionManagementService)),ie.set(s.IExtensionGalleryService,new L.SyncDescriptor(c.ExtensionGalleryServiceWithNoStorageService)),ie.set(s.IExtensionManagementCLIService,new L.SyncDescriptor(t.ExtensionManagementCLIService)),ie.set(q.ILanguagePackService,new L.SyncDescriptor(Y.NativeLanguagePackService));const me=[],Ce=(0,R.isInternalTelemetry)(se,ue);if((0,R.supportsTelemetry)(se,he)){se.aiConfig&&se.aiConfig.ariaKey&&me.push(new O.OneDataSystemAppender(Ce,"monacoworkbench",null,se.aiConfig.ariaKey));const{installSourcePath:we}=he,Te={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const De=await E.Promises.readFile(he.stateResource.fsPath);be=JSON.parse(De.toString())[F.machineIdKey]}catch(De){De.code!=="ENOENT"&&Oe.error(De)}return(0,Q.resolveCommonProperties)(Ae,(0,D.release)(),(0,D.hostname)(),process.arch,se.commit,se.version,be,Ce,we)})(),piiPaths:(0,R.getPiiPathsFromEnvironment)(he)};ie.set(F.ITelemetryService,new L.SyncDescriptor(V.TelemetryService,[Te]))}else ie.set(F.ITelemetryService,R.NullTelemetryService);return[new U.InstantiationService(ie),me]}registerErrorHandler(ie){(0,T.setUnexpectedErrorHandler)(se=>{const he=(0,k.toErrorMessage)(se,!0);!he||ie.error(`[uncaught exception in CLI]: ${he}`)}),process.on("uncaughtException",se=>(0,T.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,T.onUnexpectedError)(se))}async doRun(ie,se,he){if(this.argv["install-source"])return this.setInstallSource(ie,he,this.argv["install-source"]);if(this.argv["list-extensions"])return se.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const de={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return se.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],de,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return se.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return se.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,x.buildTelemetryMessage)(ie.appRoot,ie.extensionsPath))}}asExtensionIdOrVSIX(ie){return ie.map(se=>/\.vsix$/i.test(se)?g.URI.file((0,d.isAbsolute)(se)?se:(0,d.join)((0,P.cwd)(),se)):se)}async setInstallSource(ie,se,he){await se.writeFile(g.URI.file(ie.installSourcePath),b.VSBuffer.fromString(he.slice(0,30)))}}async function pe(ve){const ie=new le(ve);try{await ie.run()}finally{ie.dispose()}}i.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c122d9b2d1af2c37bd55caad614321eb53b342f/core/vs/code/node/cliProcessMain.js.map
